/**
 * aud预约付款管理
 * @namespace audPayManageDetail
 * @name audPayManageDetail
 * @requires zepto,common,amountUtil
 */
define('audPayManageDetail', ['zepto', 'common','viewcontroller','model','routesUtil','amountUtil','dateUtil'], function($, common,controller,model,routesUtil,amountUtil,dateUtil) {
    var AudPayManageDetail = {
    };
    AudPayManageDetail.cutCount = 25;
    AudPayManageDetail._pageSize = 50;
    AudPayManageDetail.errorCode = 'OIBS.ER00006';
    var _conversationId = "";
    var _token = "";
    /**
     * 绑定返回原生
     * @namespace _style 绑定的样式
     */
    AudPayManageDetail.getBackApp = function(_style) {
        $(_style).bind("click", function () {
            $(this).css("background", "#c6c6c6");//改变按钮颜色
            bocovsbridge.navigateToPage(function (params) {
            }, function (params) {
            }, 'entrance');
        });
    };

    /**
     * 加载列表
     * @namespace _style 绑定的样式
     */
    AudPayManageDetail.ovpPayManageList = function(_t,p,flag){
        model.interaction({//先拿到conversationId
            method: routesUtil.method.BII.OvcCreConversationWithToken,
            loadingMask:flag,
            params: {}
        }, "BII", function(data) {
            _conversationId = data.conversationId;
            _token = data.token;
            var params = {};
            if(_t.currentPage == 1){
                params = {
                    currentIndex:_t.startIdx,
                    pageSize:_t.pageSize,
                    _refresh:"true",
                    conversationId:_conversationId
                };
            }else{
                params = {
                    currentIndex:_t.startIdx,
                    pageSize:_t.pageSize,
                    _refresh:"false",
                    conversationId:_conversationId
                };
            }
            model.interaction({
                method: routesUtil.method.BII.OvpBpaySchedListQry,
                loadingMask:flag,
                params: params
            }, "BII", function(data) {
                p.removeTip();
                var leng = $('.boc-list').length;
                _t.data = data.recordNumber;
                p.setRecordNum(_t.data);
                //判断列表数据是否已到最大条数
                if(_t.data != 0 && leng == _t.data){
                    p.showOverTipAtBtm();
                }else{
                    _t.resultData = _t.resultData.concat(data.scheduleList);
                    _t.icount = _t.resultData.length - data.scheduleList.length;
                    _t.bigData = {scheduleList:_t.resultData,icount:_t.icount};
                    //处理过长的title
                    var _title = common.strLong($.localeResource["BocAbroad_AudPaymentManageList"].ovs_bpa_spm,AudPayManageDetail.cutCount);
                    $("#audBpayMTitleName").html(_title);
                    if(_t.data == 0){
                        _t.append(_t.domNode.find('.boc-content') , new EJS({
                            url: '../BocAbroad/views/bpay/aud/AudPaymentManage/noresult.ejs',
                        }).render({data:null}));
                        $(".boc-content-item-a").remove();
                        $("#isum").hide();
                        $("#leftCount").hide();
                        $("#rightCount").hide();
                        //返回原生app
                        AudPayManageDetail.getBackApp(".boc-red-icon");
                    }else{
                        _t.append(_t.domNode.find('.boc-content') , new EJS({
                            url: '../BocAbroad/views/bpay/aud/AudPaymentManage/AudPayManageList.ejs',
                        }).render({data:_t.bigData}));
                        $("#leftCount").show();
                        $("#rightCount").show();
                        $("#isum").show();
                        $("#isum").html(_t.data);
                        //返回原生app
                        AudPayManageDetail.getBackApp(".boc-red-icon");
                        AudPayManageDetail.bindStyleDatail(".boc-list",_t.resultData);
                    }
                }
            },{errorFun: function(data1){
                if(data1 != null){
                    if(data1.code == AudPayManageDetail.errorCode) {
                        _t.append(_t.domNode.find('.boc-content'), new EJS({
                            url: '../BocAbroad/views/bpay/aud/AudPaymentManage/noresult.ejs',
                        }).render({data: null}));
                        $(".boc-content-item-a").remove();
                        //返回原生app
                        var _title = common.strLong($.localeResource["BocAbroad_AudPaymentManageList"].ovs_bpa_spm,AudPayManageDetail.cutCount);
                        $("#audBpayMTitleName").html(_title);
                        AudPayManageDetail.getBackApp(".boc-red-icon");
                    }else{
                        var _title = common.strLong($.localeResource["BocAbroad_AudPaymentManageList"].ovs_bpa_spm,AudPayManageDetail.cutCount);
                        $("#audBpayMTitleName").html(_title);
                        AudPayManageDetail.getBackApp(".boc-red-icon");
                        common.showMessage(data1.message);
                        return;
                    }
                }else{
                    _t.append(_t.domNode.find('.boc-content'), new EJS({
                        url: '../BocAbroad/views/bpay/aud/AudPaymentManage/noresult.ejs',
                    }).render({data: null}));
                    $(".boc-content-item-a").remove();
                    //返回原生app
                    var _title = common.strLong($.localeResource["BocAbroad_AudPaymentManageList"].ovs_bpa_spm,AudPayManageDetail.cutCount);
                    $("#audBpayMTitleName").html(_title);
                    AudPayManageDetail.getBackApp(".boc-red-icon");
                }
                p.removeTip();
            }});
        },{errorFun: function(){
            p.removeTip();
        }});
    };
    /**
     * 绑定样式显示详情
     * @namespace _style 绑定的样式
     * @name _data 列表data
     */
    AudPayManageDetail.bindStyleDatail = function(_style,_data){
        $(_style).bind("click", function(){
            var arr = this.id;
            var schedDetail = _data[arr];
            var params = {
                exchangeSeq:schedDetail.exchangeSeq,
                paymentAcctNum:schedDetail.paymentAcctNum,
                billerCode:schedDetail.billerCode,
                billerName:schedDetail.billerName,
                cusRefNum:schedDetail.cusRefNum,
                billerAlias:schedDetail.billerAlias,
                amount:amountUtil.changePartition(schedDetail.amount.toString()),
                description:schedDetail.description,
                assignedDate:schedDetail.assignedDate
            };
            $("#countBig").css("overflow-y","hidden");
            $("#countBig").css('-webkit-overflow-scrolling','');
            common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/bpay/aud/AudPaymentManage/AudPayManageDetail.ejs",
                }))({
                    id: 'paymanage',
                    data:params,
                    _hisClose: function(e){
                        $(e.currentTarget).css("background","#c6c6c6");//改变按钮颜色
                        common.fullLayer.close(e);
                        $("#countBig").css("overflow-y","auto");
                        $("#countBig").css('-webkit-overflow-scrolling','touch');
                    },
                    ovpBaySchedDelQry:function(e){
                        AudPayManageDetail.ovpRequestDel($("#exchangeSeq").text());
                    }
                })
            });
            var _titleDetail = common.strLong($.localeResource["BocAbroad_AudPaymentManageList"].ovs_bpa_spm_transactiondetails,AudPayManageDetail.cutCount);
            $("#audPayMDTitleName").html(_titleDetail);
        });
    };

    /**
     * 处理删除详情
     * @namespace _style 绑定的样式
     */
    AudPayManageDetail.ovpRequestDel = function(exchangeSeq){
        var str = $.localeResource["BocAbroad_AudPaymentManageList"].ovs_bpa_spm_afterdeletion;
        common.popup.single(str,function(e){
            common.fullLayer.close(e);//先关闭窗口
            model.interaction({
                method: routesUtil.method.BII.OvpBpaySchedRecordDel,
                params: {
                    conversationId:_conversationId,
                    token:_token,
                    exchangeSeq:exchangeSeq
                }
            }, "BII", function(data) {//跳转回列表页面
                common.params.targetRouter = {
                    routerKey: "BocAbroad_AudPaymentManageList",
                    isExcuteInit: false,
                    excuteFun: null,
                    funArgs: null,
                    moduleArgs: []
                }
                common.triggerRouter(common.params.targetRouter);
                var strdel = $.localeResource["BocAbroad_AudPaymentManageList"].ovs_bps_spm_delsuccess;
                common.popdown.single(strdel,function(e){});
                /*model.interaction({
                    method: routesUtil.method.BII.OvpBpaySchedListQry,
                    params: {
                        currentIndex:AudPayManageDetail._pageSize,
                        pageSize:AudPayManageDetail._pageSize,
                        _refresh:"true",
                        conversationId:_conversationId
                    }
                }, "BII", function(data) {
                    common.params.targetRouter = {
                        routerKey: "BocAbroad_AudPaymentManageList",
                        isExcuteInit: false,
                        excuteFun: null,
                        funArgs: null,
                        moduleArgs: []
                    }
                    common.triggerRouter(common.params.targetRouter);
                    var strdel = $.localeResource["BocAbroad_AudPaymentManageList"].ovs_bps_spm_delsuccess;
                    common.popdown.single(strdel,function(e){});
                }, {errorFun: function(err){

                    // TODO

                }});*/
            });
        });
    };
    return AudPayManageDetail;
});