/**
 * Created by Pactera on 2015/11/7.
 */
define(['zepto', 'common', 'viewcontroller', 'model', 'routesUtil','dateUtil','pluginsUtil', 'async'], function($, common, controller, model, routesUtil,dateUtil,pluginsUtil, async) {

    var mainView = $.extendCls(controller, {
        services: null,
        ejs: '../BocAbroad/views/bpay/aud/AudQueryHistoryList/queryHistoryMain.ejs',
        p:null,
        systemDate:null,
        conversationId:"", // 回话id
        minDate:"", // 最下时间
        maxDate:"", // 最大时间
        loading:true,
        resultData:[],
        recordNumber:0,
        isFirst:true,
        pageparams:{
            currentIndex: 0,
            pageSize: 50,
            startDate:"",
            endDate:"",
            _refresh: "true"
        },

       srocllView:null,

        //日期选择
        //原生日期控件调用
        showDatePicker:function(){
            var _t = this;
            var dateparams = "";
            var dateMin = "";
            var mindef = "";

            var sysDate = dateUtil.parse(_t.systemDate, 'yyyy/MM/dd');
            var tempdate =  dateUtil.addDays(sysDate, 1);
            mindef = dateUtil.addMonths(tempdate, -3);
            dateMin = dateUtil.addYears(tempdate, -1);

            dateparams = pluginsUtil.createLimitDataSelectParams(_t.systemDate, {
                  min: dateUtil.format(dateMin, "yyyy/MM/dd"),
                  max: dateUtil.format(sysDate, "yyyy/MM/dd"),
                  mindef: _t.minDate,
                  maxdef: _t.maxDate
            });

            bocovsbridge.showDatePicker(function(result){
                if (!result.close) {
                    var select = result.select;
                    if (select){
                       var arr =  select.split(",");
                        _t.minDate = arr[0];
                        _t.maxDate =  arr[1];
                        _t.pageparams.startDate = arr[0];
                        _t.pageparams.endDate = arr[1];
                        $('.boc-input-import-choose').text( _t.pageparams.startDate + "-" + _t.pageparams.endDate);
                    } else {
                        var picker = result.picker;
                        $('.boc-input-import-choose').text(picker.scopeMin + "-" + picker.scopeMax);
                        _t.minDate = picker.scopeMin;
                        _t.maxDate =  picker.scopeMax;
                        _t.pageparams.startDate = picker.scopeMin;
                        _t.pageparams.endDate = picker.scopeMax;
                    }
                    _t.pageparams.currentIndex = "0";
                    _t.loading = true;
                    _t.resultData = [];
                    _t.isFirst = true;
                    _t.getOvpBpayHistoryQry();
                    $('#listViewContainer').html('');
                    $('#recordNumber').html('');
                }
            }, function(params){

            },dateparams);
        },

        _showhisDetail: function(hisdetail) {

            var rec = $(".boc-list");
            common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/bpay/aud/AudQueryHistoryList/showHistoryDetail.ejs"
                }))({
                    id: 'hisdetailView',
                    data:hisdetail,
                    _hisClose: function(e){
                        common.fullLayer.close(e);
                        rec.css('visibility', 'visible');
                    }

                })
            });
        },
        /*
         历史列表页面，点击返回，跳转选择查询时间页面

         */
        goback:function(){
            bocovsbridge.navigateToPage(function(params){
            }, function(params){
            }, 'entrance');
        },

        onSubError: function(err) {

        },
        serviceFormParams: function() {
            return {};
        },

        /*
        查询无结果页面
         */
        noresult:function(){

            var noresultHtml = new EJS({
                url: '../BocAbroad/views/bpay/aud/AudQueryHistoryList/noresult.ejs'
            }).render();
            $('#listViewContainer').html(noresultHtml);
        },


        /**
         * 查询帐单历史列表
         */
        getOvpBpayHistoryQry: function() {
            var _t = this;

            if (! _t.isFirst ) {
                if (_t.recordNumber <=  _t.resultData.length) {
                    _t.srocllView.removeTip();
                    //Common.showAlert(window.app.nls.l_timeout, [window.app.nls.l_comfirm]);
                    return;
                }

            }
            model.interaction({
                method: routesUtil.method.BII.OvpBpayHistoryQry,
                loadingMask: _t.loading,//页面第一次加载loading显示
                params: _t.pageparams
            }, "BII", function (data) {

                _t.srocllView.removeTip();
                _t.loading = false;
                _t.isFirst = false;
                _t.resultData = _t.resultData.concat(data.billerHistoryList);
                _t.recordNumber = data.recordNumber;
                _t.srocllView.setRecordNum(_t.recordNumber);
                if (_t.recordNumber == 0){
                    _t.noresult();
                    return;
                }
                $('#recordNumberWrap').show();
                $('#recordNumber').html(_t.recordNumber)
                _t.append(_t.domNode.find('#listViewContainer'), new EJS({
                    url: '../BocAbroad/views/bpay/aud/AudQueryHistoryList/queryHistoryList.ejs'
                }).render(data));
                $("#recordNumber").html(_t.recordNumber);
                $.each($('.boc-list'), function(index, object){
                    $(object).bind('click', function(){
                        _t._showhisDetail( _t.resultData[index]);
                    });
                });

            }, {errorFun: function(err){

                // TODO

            }});

        },

        onLoadFinish: function(data) {
            var _t = this;
            _t.loading  = true;
            _t.resultData = [];
            $('#recordNumberWrap').hide();
            // 查询时间和回话id
            async.parallel(
                [function(callback){
                    _t.getSystemDate(callback);
                },function(callback){
                    _t.getConversationId(callback);
                }], function(error, result){

                    if (error == null) {
                        _t.systemDate = result[0];
                        _t.conversationId = result[1];
                        _t.pageparams.conversationId = _t.conversationId;
                        _t.queryBpayHistory();
                    }
                }
            );

        },
        /**
         * 取系统时间
         */
        getSystemDate:function(callkback){
            var _t = this;
            model.interaction({
                method: routesUtil.method.BII.OvcSysTimeQry,
                params: {}
            }, "BII", function(data) {
                _t.systemDate = data.sysTime;
                var sysDate = dateUtil.parse(_t.systemDate, 'yyyy/MM/dd hh:mm:ss');
                var tempdate = dateUtil.addDays(sysDate, 1);
                _t.minDate = dateUtil.format(dateUtil.addMonths(tempdate, -3),"yyyy/MM/dd");
                _t.maxDate = dateUtil.format(sysDate,"yyyy/MM/dd");
                _t.pageparams.startDate = _t.minDate;
                _t.pageparams.endDate = _t.maxDate;
                $('.boc-input-import-choose').text(_t.minDate + " - " + _t.maxDate);

                callkback(null, _t.systemDate);
            },{errorFun:function(){
                var cuurent = new Date();
                _t.systemDate = dateUtil.format(cuurent, 'yyyy/MM/dd hh:mm:ss');
                var sysDate = dateUtil.parse(_t.systemDate, 'yyyy/MM/dd hh:mm:ss');
                var tempdate = dateUtil.addDays(sysDate, 1);
                _t.minDate = dateUtil.format(dateUtil.addMonths(tempdate, -3),"yyyy/MM/dd");
                _t.maxDate = dateUtil.format(sysDate,"yyyy/MM/dd");
                _t.pageparams.startDate = _t.minDate;
                _t.pageparams.endDate = _t.maxDate;
                $('.boc-input-import-choose').text(_t.minDate + " - " + _t.maxDate);
                callkback(null, _t.systemDat);
            }})
        },

        /**
         * 获取回话id
         * @param callback
         */
        getConversationId:function(callback){
            var _t = this;
            //先拿到先拿到conversationId
            model.interaction({
                method: routesUtil.method.BII.OvcCreConversation,
                loadingMask: _t.loading,//页面第一次加载loading显示
                params: {}
            }, "BII", function(data) {
                _t.conversationId = data.conversationId;
                callback(null, _t.conversationId);
            }, {errorFun:function(data){
                // TODO
            }});
        },
        queryBpayHistory:function(){
            var _t = this;
            new common.ScrollPagination({
                pageSize: _t.pageSize,
                el: _t.domNode.find('#listViewContainer'),
                getPageData: function() {
                    _t.srocllView =this;
                    _t.getOvpBpayHistoryQry();

                }
            });
        },

        //执行方式
        onChoice: function() {
        },
        destroy: function() {
            $.proxy(this.baseprototype.destroy, this)();
        }
    });

    return common.Module.sub({
        _constructor: function() {
            this.mainView = null;
            $.proxy(this.baseprototype._constructor, this)();
        },
        CSSPATH:["../BocAbroad/styles/audhis.css"],
        init: function() {
           this.mainView = new mainView({
              id: "boc-historylistview",
              el: "#loginViewWrap",
                eloper: "html",
                //参数
                data: {
                   loading: true
               }
           });
           this.mainView.load();
        },
        initdata:function(data){

        },
        destroy: function() {
            this.mainView.destroy();
        }
    });
});