/**
 * 加拿大预约付款管理
 * @namespace caPayManageDetail
 * @name caPayManageDetail
 * @requires zepto,common,amountUtil
 * jsn = encodeURI(jsn);
 */
define('caPayManageDetail', ['zepto', 'common','viewcontroller','model','routesUtil','amountUtil','checkForm','pluginsUtil','dateUtil','constant'],function($, common,controller,model,routesUtil,amountUtil,checkForm,pluginsUtil,dateUtil,constant) {
    var CaPayManageDetail = {
    };
    CaPayManageDetail.cutCount = 25;
    CaPayManageDetail.errorCode = 'OIBS.53024';
    var _conversationId = "";
    var _token = "";

    /**
     * 绑定返回原生
     * @namespace _style 绑定的样式
     */
    // CaPayManageDetail.getBackApp = function(_style) {
    //     $(_style).bind("click", function () {
    //         bocovsbridge.navigateToPage(function (params) {
    //         }, function (params) {
    //         }, 'entrance');
    //     });
    // };

    /**
     * 加载列表
     * @namespace _style 绑定的样式
     */
    CaPayManageDetail.ovpPayManageList = function(_t,p,flag){
        _t.startIdx = _t.startIdx.toString();
        _t.pageSize = _t.pageSize.toString();
        _conversationId = _t._conversationId;
        _token = _t._token;
        var params = {};
        if(_t.currentPage == 1){
            params = {
                currentIndex:_t.startIdx, //当前页索引
                pageSize:_t.pageSize, //每页显示条数
                _refresh:"true", //刷新标记
                conversationId:_conversationId
            };
        }else{
            params = {
                currentIndex:_t.startIdx,
                pageSize:_t.pageSize,
                _refresh:"false",
                conversationId:_conversationId
            };
        }
        model.interaction({
            method: routesUtil.method.BII.OvpCANBpaySchedListQry,
            loadingMask:flag,
            params: params
        }, "BII", function(data) {
            p.removeTip();
            var leng = $('.boc-list').length;
            _t.data = data.recordNumber;
            p.setRecordNum(_t.data);

            _t.resultData = _t.resultData.concat(data.scheduleList);
            _t.icount = _t.resultData.length - data.scheduleList.length;
            _t.bigData = {scheduleList: _t.resultData, icount: _t.icount};
            //处理过长的title
            var _title = common.strLong($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm, CaPayManageDetail.cutCount);
            $("#caBpayMTitleName").html(_title);
            //加载缴费列表
            _t.append(_t.domNode.find('.boc-content'), new EJS({
                url: '../BocAbroad/views/bpay/can/CaPrepaymentManage/CaPayManageList.ejs',
            }).render({data: _t.bigData}));
            $("#leftCount").show();
            $("#rightCount").show();
            $("#isum").show();
            $("#isum").html(_t.data);
            //进入明细页
            CaPayManageDetail.bindStyleDatail(".boc-detail", _t.resultData);
            //进入修改页
            CaPayManageDetail.bindStyleModify(".boc-success-back", _t.resultData, _t.sysTime);
        },{
            errorFun: function(data){
                if(data !=null){
                    if(data.code == CaPayManageDetail.errorCode){
                        _t.append(_t.domNode.find('.boc-content'), new EJS({
                            url: '../BocAbroad/views/bpay/can/CaPrepaymentManage/noresult.ejs',
                        }).render({data: null}));
                        $(".boc-content-item-a").remove();
                        var _title = common.strLong($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm, CaPayManageDetail.cutCount);
                        $("#caBpayMTitleName").html(_title);
                        // CaPayManageDetail.getBackApp(".boc-red-icon");
                    }else{
                        var _title = common.strLong($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm, CaPayManageDetail.cutCount);
                        $("#caBpayMTitleName").html(_title);
                        // CaPayManageDetail.getBackApp(".boc-red-icon");
                        common.showMessage(data.message);
                        return;
                    }
                }else{
                    _t.append(_t.domNode.find('.boc-content'), new EJS({
                        url: '../BocAbroad/views/bpay/can/CaPrepaymentManage/noresult.ejs',
                    }).render({data: null}));
                    $(".boc-content-item-a").remove();
                    var _title = common.strLong($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm, CaPayManageDetail.cutCount);
                    $("#caBpayMTitleName").html(_title);
                    // CaPayManageDetail.getBackApp(".boc-red-icon");
                }
                p.removeTip();
            }
        });
    };


    /**
     * 点击显示详情
     * @namespace _style 类名
     * @name _data 列表data
     */
    CaPayManageDetail.bindStyleDatail = function(_style,_data){
        $(_style).bind("click", function(){
            var arr = this.id;
            var schedDetail = $.extend({}, _data[arr]);
            var params = {
                payeeActno:schedDetail.payeeActno,
                billerName:schedDetail.billerName,
                contactPhone:schedDetail.contactPhone,
                city:schedDetail.city,
                address:schedDetail.address,
                postCode:schedDetail.postCode,
                paymentAcctNum:schedDetail.paymentAcctNum,
                scheduleId:schedDetail.scheduleId,
                firstExecuteDate:schedDetail.firstExecuteDate,
                executedCount:schedDetail.executedCount,
                remainCount:schedDetail.remainCount,
                nextExecuteDate:schedDetail.nextExecuteDate,
                endDate:schedDetail.endDate,
                frequency:schedDetail.frequency,
                amount:amountUtil.changePartition(schedDetail.amount.toString()),
                executedCount:schedDetail.executedCount,
                description:schedDetail.description,
                status:schedDetail.status
            };
            $("#countBig").css("overflow-y","hidden");
            $("#countBig").css('-webkit-overflow-scrolling','');
            if(params.status != "4"){
                common.fullLayer.show({
                    view: new ($.extendCls(controller, {
                        ejs: "../BocAbroad/views/bpay/can/CaPrepaymentManage/CaPayManageDetail.ejs",
                    }))({
                        id: 'paymanage',
                        data:params,
                        _hisCloseDetail: function(e){
                            $(e.currentTarget).css("background","#c6c6c6");//改变按钮颜色
                            common.fullLayer.close(e);
                            $("#countBig").css("overflow-y","auto");
                            $("#countBig").css('-webkit-overflow-scrolling', 'touch');
                        },
                        //点击删除详情
                        ovpCaBaySchedDelQry:function(e){
                            CaPayManageDetail.ovpRequestDel($("#scheduleId").text());
                        },
                    })
                });
                var payDetailTotalCount = (parseInt(params.remainCount) + parseInt(params.executedCount)).toString();
                $(".payDetailTotalCount").text(payDetailTotalCount);
                var _titleDetail = common.strLong($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_schpaymentdetail,CaPayManageDetail.cutCount);
                $("#canPayMDTitleName").html(_titleDetail);
            }else{
                $("#countBig").css("overflow-y","auto");
                $("#countBig").css('-webkit-overflow-scrolling','touch');
            };
        });
    };

    /**
     * 预约缴费详情删除
     * @namespace _style 绑定的样式
     */
    CaPayManageDetail.ovpRequestDel = function(scheduleId){
        var str = $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_afterdeletion;
        //弹出提示框
        common.popup.single(str,function(e){
            common.fullLayer.close(e);
            model.interaction({
                method: routesUtil.method.BII.OvpCANBpaySchedRecordDel,
                params: {
                    conversationId:_conversationId,
                    token:_token,
                    scheduleId:scheduleId
                }
            }, "BII", function(data) {//跳转回列表页面
                //此处采用底部弹出提示框显示删除成功，然后自动消失
                common.params.targetRouter = {
                    routerKey: "BocAbroad_CanPaymentManageList",
                    isExcuteInit: false,
                    excuteFun: null,
                    funArgs: null,
                    moduleArgs: []
                }
                common.triggerRouter(common.params.targetRouter);
                // var strdel = $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_delsuccess;
                // common.popdown.single(strdel,function(e){});
                // 此处为跳转页面提示删除成功
                CaPayManageDetail.getRequestDelSuccess();
            },{errorFun: function(err){
                //错误时回调函数，此时重新请求token
                model.interaction({
                    method: routesUtil.method.BII.OvcCreConversationWithToken,
                    params: {}
                }, "BII", function(data) {
                    _token = data.token;
                    // 此时为发生错误情况确认后重新发送，仅需更新token，conversationId需要与其他接口一致，不更新
                    // _conversationId = data.conversationId;
                    common.showMessage(err.message);
                });
            }});
            // var strdel = $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_delsuccess;
            // common.popdown.single(strdel,function(e){});
        });
    };

    /**
     * 点击修改详情
     * @namespace _style 绑定的样式
     * @name _data 列表data
     */
    CaPayManageDetail.bindStyleModify = function(_style,_data,time){
        $(_style).bind("click", function(){
            var arr = this.id;
            var schedDetail = $.extend({}, _data[arr]);
            var params = {
                payeeActno:schedDetail.payeeActno,
                billerName:schedDetail.billerName,
                contactPhone:schedDetail.contactPhone,
                city:schedDetail.city,
                address:schedDetail.address,
                postCode:schedDetail.postCode,
                paymentAcctNum:schedDetail.paymentAcctNum,
                amount:schedDetail.amount,
                firstExecuteDate:schedDetail.firstExecuteDate,
                frequency:schedDetail.frequency,
                remainCount:schedDetail.remainCount,
                endDate:schedDetail.endDate,
                description:schedDetail.description,
            };
            $("#countBig").css("overflow-y","hidden");
            $("#countBig").css('-webkit-overflow-scrolling','');

            common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/bpay/can/CaPrepaymentManage/CaPayManageEdit.ejs",
                }))({
                    id: 'paymanageedit',
                    data:params,
                    _hisEditClose: function(e){
                        $(e.currentTarget).css("background","#c6c6c6");
                        common.fullLayer.close(e);
                        $("#countBig").css("overflow-y","auto");
                        $("#countBig").css('-webkit-overflow-scrolling', 'touch');
                    },
                    //点击弹出修改执行周期
                    CaScheDateSelect:function(){
                        // var scheDateParams = $.extend({}, _data[arr]);
                        var reserveNumberView = new ReserveNumberView({
                            id: 'selView',
                            data: this.data
                        }), _t = this;
                        common.fullLayer.show({
                            view: reserveNumberView,
                            classes: 'halfLayer',
                            onSure: function(data){
                                _t.domNode.find('#canExecuPeriod').text(data);
                            }
                        },1);
                        $(".halfLayer .dlg_content_body").attr("id","changeTopDetail");
                        $("#changeTopDetail").css('top', '28%');
                        $("#countBig").css("overflow-y","auto");
                        $("#countBig").css('-webkit-overflow-scrolling', 'touch');
                        // alert(params);
                    },
                    //点击弹出缴费结束方式选择
                    CaEndStyleSelect:function(){
                        var reservestyleView = new ReserveStyleView({
                            id: 'selView',
                            data: this.data
                        }), _t = this;
                        common.fullLayer.show({
                            view: reservestyleView,
                            classes: 'halfLayer',
                            onSure: function(data){
                                _t.domNode.find('.r-style').text(data);
                            }
                        },1);
                        $("#countBig").css("overflow-y","auto");
                        $("#countBig").css('-webkit-overflow-scrolling', 'touch');
                    },
                    //点击修改预约执行日期
                    onDate: function() {
                        var _t = this;
                        var params = "";
                        var dateMin = "";
                        var dateMax = "";
                        _t.sysDate = dateUtil.parse(time, 'yyyy/MM/dd hh:mm:ss');
                        dateMin = dateUtil.addDays(_t.sysDate, 0);
                        dateMax = dateUtil.addYears(_t.sysDate, 50);
                        params = pluginsUtil.createSigleDateSelectParams({min:dateUtil.format(dateMin, "yyyy/MM/dd"),
                            max:dateUtil.format(dateMax, "yyyy/MM/dd"), def:dateUtil.format(dateMin,"yyyy/MM/dd")}, "yyyy/MM/dd");
                        bocovsbridge.showDatePicker(function(data){
                            if(!data.close){
                                _t.assignedDateShow = data.picker.single;
                                $('#schedDate').val(_t.assignedDateShow);
                            }
                        }, function(data){
                            console(data);
                        }, params);
                    },

                    //点击修改最后支付日期
                    onLastPayDate:function () {
                        var _t = this;
                        var params = "";
                        var dateMin = "";
                        var dateMax = "";
                        var assignedParesDate = new Date(Date.parse($('#schedDate').val()));
                        dateMin = dateUtil.addDays(assignedParesDate, 0);
                        dateMax = dateUtil.addYears(assignedParesDate, 50);
                        params = pluginsUtil.createSigleDateSelectParams({min:dateUtil.format(dateMin, "yyyy/MM/dd"),
                        max:dateUtil.format(dateMax, "yyyy/MM/dd"), def:dateUtil.format(dateMin,"yyyy/MM/dd")}, "yyyy/MM/dd");
                        bocovsbridge.showDatePicker(function(data){
                            if(!data.close){
                                _t.assignedSecDateShow = data.picker.single;
                                $('#canLastPaymentDate').val(_t.assignedSecDateShow);
                            }
                        }, function(data){
                            console(data);
                        }, params);
                    },

                    //失去焦点后格式化金额
                    // blurChangeFomat:function(){
                    //     var amountFormat = amountUtil.changePartition($("#amount").val());
                    //     $("#amount").val(amountFormat);
                    // },

                    // 缴费描述文字变化
                    blueMsg:function(){
                        var num = $('#description').val().length;
                        $('#changeTextNum').html("(" + num + "/100)");
                    },

                    //提交修改后内容
                    ovpCaBaySchedSubmit:function(){
                        switch ($("#canExecuPeriod").text() ){
                            case $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_cansingle :
                                schedDetail.frequency = "1";
                                break;
                            case $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_candaily :
                                schedDetail.frequency = "2";
                                break;
                            case $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_canweekly :
                                schedDetail.frequency = "3";
                                break;
                            case $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_canbiweekly :
                                schedDetail.frequency = "4";
                                break;
                            case $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_canmonthly :
                                schedDetail.frequency = "5";
                                break;
                            case $.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_canquarterly :
                                schedDetail.frequency = "6";
                                break;
                            default :
                                schedDetail.frequency = "7";
                        };
                        schedDetail.amount = $("#amount").val();
                        schedDetail.assignedDate = $("#schedDate").val();
                        schedDetail.endDate = $("#canLastPaymentDate").val();
                        schedDetail.count = $("#canPaymentCount").val();
                        // schedDetail.frequency = params.frequency;
                        schedDetail.description = $("#description").val();
                        $("#amount").val($("#amount").val().replace(',',''));
                        if(CaPayManageDetail.checkFormForSinPayManageDetail(".boc-input-import")){
                            schedDetail.amount = schedDetail.amount.replace(',', '');
                            //最后支付日期不早于预约执行日期 (预约周期为单次不判断,)
                            if($(".single-display-none").css("display") == "none"){
                                CaPayManageDetail.getSubmitVerifyMessage(schedDetail);
                            } else {
                                if($('#canLastPaymentDate') != "none" && Date.parse(schedDetail.endDate) < Date.parse(schedDetail.assignedDate)){
                                    var showHideSingle = common.strLong($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bpa_bpm_lastpaylaterschtrandate,CaPayManageDetail.cutCount);
                                    common.showMessage(showHideSingle);
                                }else{
                                    CaPayManageDetail.getSubmitVerifyMessage(schedDetail);
                                };
                            };
                        };
                    },
                })
            });
            //加载页面后缴费描述
            var num = $('#description').val().length;
            $('#changeTextNum').html("(" + num + "/100)");

            //进入页面判断预约周期是否为单次
            var showHideSingle = common.strLong($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_cansingle,CaPayManageDetail.cutCount);
            if($("#canExecuPeriod").text() == showHideSingle){
                $(".single-display-none").css("display","none");
                $("#canPaymentCount").attr("validate","");
                $("#canLastPaymentDate").attr("validate","");
            }else{
                $(".single-display-none").css("display","block");
                if( params.endDate ){
                    $("#canPaymentCount").attr("validate","");
                    $("#canLastPaymentDate").attr("validate","{required:true}");
                }else{
                    $("#canPaymentCount").attr("validate","{required:true,reg109:'reg109'}");
                    $("#canLastPaymentDate").attr("validate","");
                };
            };
            if( params.endDate ){
                $("#canSwitchCountOr").css("display","none");
                $("#canSwitchLastDate").css("display","inline-block");
                $("#canPaymentCount").css("display","none");
                $("#canLastPaymentDate").css("display","inline-block");
            }else{
                $("#canSwitchCountOr").css("display","inline-block");
                $("#canSwitchLastDate").css("display","none");
                $("#canPaymentCount").css("display","inline-block");
                $("#canLastPaymentDate").css("display","none");
            };
            var _titleDetail = common.strLong($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bps_sbpm_amendpaymentinformation,CaPayManageDetail.cutCount);
            $("#canPayMDTitleNameMod").html(_titleDetail);
        });
    };

    /**
     * 执行周期弹框选择
     */
    var ReserveNumberView = $.extendCls(controller, {
        ejs: '../BocAbroad/views/bpay/can/CaPrepaymentManage/CaFrequencySelector.ejs',
        onSelectoCount: function(e){
            $("#changeTopDetail").attr("id","");
            var obj = $(e.target || e.srcElement);
            common.fullLayer.sure(obj.text().trim());
            if(obj.index() == "0"){
                $(".single-display-none").css("display","none");
                $("#canPaymentCount").attr("validate","");
                $("#canLastPaymentDate").attr("validate","");
            }else{
                $(".single-display-none").css("display","block");
                $("#canPaymentCount").attr("validate","{required:true,reg109:'reg109'}");
            };
        }
    });

    /**
     * 缴费结束方式弹框选择
     */
    var ReserveStyleView = $.extendCls(controller, {
        ejs: '../BocAbroad/views/bpay/can/CaPrepaymentManage/CaStyelequencySelector.ejs',
        onSelectoStyle: function(e){
            var obj = $(e.target || e.srcElement);
            common.fullLayer.sure(obj.text().trim());
            var selectoStyleCount = $(obj).index();
            // alert(typeof selectoStyleCount);
            if(selectoStyleCount == 0){
                $("#canSwitchCountOr").css("display","inline-block");
                $("#canSwitchLastDate").css("display","none");
                $("#canPaymentCount").css("display","inline-block");
                $("#canLastPaymentDate").css("display","none");
                $("#canPaymentCount").attr("validate","{required:true,reg109:'reg109'}");
                $("#canLastPaymentDate").attr("validate","");
            }else{
                $("#canSwitchCountOr").css("display","none");
                $("#canSwitchLastDate").css("display","inline-block");
                $("#canPaymentCount").css("display","none");
                $("#canLastPaymentDate").css("display","inline-block");
                $("#canPaymentCount").attr("validate","");
                $("#canLastPaymentDate").attr("validate","{required:true}");
            }
        }
    });

    /**
     *交验表单输入项
     */
    CaPayManageDetail.checkFormForSinPayManageDetail = function(_style){
        if(!checkForm.checkAll(_style)){
            return false;
        }
        return true;
    };

    //提交验证
    CaPayManageDetail.getSubmitVerifyMessage = function(retParams){
        if($(".single-display-none").css("display") == "none"){
            _parames = {
                scheduleId : retParams.scheduleId,
                currencyCode :"028",
                amount : retParams.amount,
                assignedDate : retParams.assignedDate,
                count : "1",
                frequency : retParams.frequency,
                description : retParams.description,
                token:_token,
                conversationId:_conversationId
            };
        }else{
            if($("#canLastPaymentDate").css("display") == "none"){
                _parames = {
                    scheduleId : retParams.scheduleId,
                    currencyCode :"028",
                    amount : retParams.amount,
                    assignedDate : retParams.assignedDate,
                    count : retParams.count,
                    frequency : retParams.frequency,
                    description : retParams.description,
                    token:_token,
                    conversationId:_conversationId
                };
            }else{
                _parames = {
                    scheduleId : retParams.scheduleId,
                    currencyCode :"028",
                    amount : retParams.amount,
                    assignedDate : retParams.assignedDate,
                    endDate : retParams.endDate,
                    frequency : retParams.frequency,
                    description : retParams.description,
                    token:_token,
                    conversationId:_conversationId
                };
            };
        };
        if($(".single-display-none").css("display") != "none"){
            if($("#canPaymentCount").css("display") == "block" || $("#canPaymentCount").css("display") == "inline-block"){
                if($("#canPaymentCount").val() == "0"){
                    common.showMessage($.localeResource["BocAbroad_CanPaymentManageList"].ovs_bpa_bpm_times);
                    return;
                };
            };
        };
        model.interaction({
            method: routesUtil.method.BII.OvpCANBpaySchedRecordMod,
            params:_parames
        }, "BII", function(data) {
            CaPayManageDetail.getRetSuccess(retParams);
        },{errorFun: function(err){
            //错误时回调函数，此时重新请求token
            model.interaction({
                method: routesUtil.method.BII.OvcCreConversationWithToken,
                params: {}
            }, "BII", function(data) {
                _token = data.token;
                // 此时为发生错误情况确认后重新发送，仅需更新token，conversationId需要与其他接口一致，不更新
                // _conversationId = data.conversationId;
                common.showMessage(err.message);
            });
        }});
    };

    //删除成功后的页面
    CaPayManageDetail.getRequestDelSuccess = function(){
        common.fullLayer.show({
            view: new ($.extendCls(controller, {
                ejs: "../BocAbroad/views/bpay/can/CaPrepaymentManage/CaPayManageModSuccess.ejs",
            }))({
                id: 'paymanageok',
                data:[],
                _hisCloseOk: function(e){
                    common.fullLayer.close(e);
                    common.params.targetRouter = {
                        routerKey: "BocAbroad_CanPaymentManageList",
                        isExcuteInit: false,
                        excuteFun: null,
                        funArgs: null,
                        moduleArgs: []
                    }
                    common.triggerRouter(common.params.targetRouter);
                },
                goHome:function(){
                    bocovsbridge.navigateToPage(function (params) {
                    }, function (params) {
                    }, 'home');
                }
            })
        });
    };

    //提交成功后的页面
    CaPayManageDetail.getRetSuccess = function(schedDetail){
        common.fullLayer.show({
            view: new ($.extendCls(controller, {
                ejs: "../BocAbroad/views/bpay/can/CaPrepaymentManage/CaPayManageSuccess.ejs",
            }))({
                id: 'paymanageok',
                data:schedDetail,
                _hisCloseOk: function(e){
                    common.fullLayer.close(e);
                    common.params.targetRouter = {
                        routerKey: "BocAbroad_CanPaymentManageList",
                        isExcuteInit: false,
                        excuteFun: null,
                        funArgs: null,
                        moduleArgs: []
                    }
                    common.triggerRouter(common.params.targetRouter);
                },
                goHome:function(){
                    bocovsbridge.navigateToPage(function (params) {
                    }, function (params) {
                    }, 'home');
                }
            })
        });
    };

    return CaPayManageDetail;
});