define(['zepto', 'common', 'viewcontroller', 'model', 'routesUtil', 'constant', 'pluginsUtil', 'dateUtil', 'checkForm', 'amountUtil'],
    function($, common, controller, model, routesUtil, constant,  pluginsUtil, dateUtil, checkForm, amountUtil) {
        var mainView = $.extendCls(controller, {
            ejs: '../BocAbroad/views/bpay/can/CanBpayPay/CanBpayPay.ejs',
            conversationId: "",
            token: "",

            noFiterAccList: [],//未过滤账户
            acctList: [],//账户
            billerBookList: [], //收件人列表

            billerName:"",//收款人
            payeeId:"",//收款人ID
            accountId: "",//付款人ID
            accountNumber: "",//付款账号
            payeeAccountNumber:"",//收款人账号
            accountType: "",//账户类型 201 储蓄 203 支票
            accountNickName: "",//昵称
            currencyCode: "",//币种 默认028 加拿大
            amount: "",//金额

            frequency:"1",//1=单次  2=每天    3=每周  4=每两周  5=每月   6=每季度  7=每年
            assigneWayType:"1",//1=次数 2=最后日期

            assignedDate:"",//预约日期
            endDate:"",//最终结束日期
            countTime:"",//缴费次数
            assignedDateShow:"",//日期显示框
            assignedSecDateShow:"",//日期显示框

            sysTime:"",
            sysDate:"",

            scheduleId:"",//交易编号

            // minAmount:0,
            // maxAmount:999999999999,
            bComfirm: true,

            afterFormSubmit: function(data) {

            },
            onSubError: function(err) {

            },
            serviceFormParams: function() {
                return {};
            },

            onLoadFinish: function(data) {
                var _t = this;

                //得到系统时间
                //  _t.sysTime="2016/12/25 15:22:22";


                model.interaction({
                    method: routesUtil.method.BII.OvcSysTimeQry,
                    params: {}
                }, "BII", function(data) {
                    _t.sysTime = dateUtil.parse(data.sysTime, 'yyyy/MM/dd hh:mm:ss');
                    _t.sysDate = dateUtil.format(_t.sysTime, "yyyy/MM/dd");
                    $('#txtDate').html(_t.sysDate);

                    //提示栏（0/100）
                    var str = $.localeResource["BocAbroad_CanBpayPay"].l_describe;
                    str = str + " (0/100)";
                    $('#hid').html(str);

                    _t.clearData();
                    bocovsbridge.retrieveAccountsList(function(data){
                        _t.noFiterAccList = data.acctList;
                        _t.fiterAccount();
                    }, function(err){});
                });
            },

            //过滤账户
            fiterAccount: function(){
                var _t = this;
                var count = 0;
                for( var i  = 0; i < _t.noFiterAccList.length; i++){//账户限定：201 海外普通活期 203 海外支票 218 海外对私基本支票
                    if(_t.noFiterAccList[i].accountType == "201" || _t.noFiterAccList[i].accountType == "203"|| _t.noFiterAccList[i].accountType == "218"){
                        if(_t.noFiterAccList[i].currencyCode == "028") {
                            count += 1;
                            _t.acctList.push(_t.noFiterAccList[i]);
                        }
                    }
                }
                if(1 == count){ //此处为单一账户默认选择
                    _t.accountId = _t.acctList[0].accountId;
                    _t.accountNumber = _t.acctList[0].accountNumber;
                    _t.accountType = _t.acctList[0].accountType;
                    _t.currencyCode = _t.acctList[0].currencyCode;
                    _t.accountNickName = _t.acctList[0].accountNickName;

                    $("#accountContent").removeClass('hide').addClass('show');
                    $("#accountChoice").removeClass('show').addClass('hide');
                    $("#rightIconShow").removeClass('hide').addClass('show');
                    $("#txtAccountNum").html(_t.accountNumber);

                    var str = constant.account_type_[_t.accountType];
                    $("#txtAccountType").html('<em class="boc-change-type" style="float: left;">'+str+'</em>');
                    if(_t.accountNickName != undefined && _t.accountNickName != null &&  _t.accountNickName != "")
                    {
                        $('#txtAccountType').html('<em class="boc-change-type" style="float: left;">'+str+'</em>'+'&nbsp;&nbsp;|&nbsp;&nbsp;' + _t.accountNickName);
                    }
                }
                if( 0 == count){//没有账户跳转为空页面
                    _t.showNoAccountView();
                }
            },
            //选择转出账号
            onOvpAcctListQry: function() {
                var _t = this;
                if(_t.acctList.length == 0 )
                    return;
                var params = {acctList: _t.acctList};

                bocovsbridge.showAccountListPage(function(data){
                    var result = data.data;
                    for(var i = 0; i < _t.acctList.length; i++){
                        if(_t.acctList[i].accountId == result.accountId){
                            _t.accountId = _t.acctList[i].accountId;
                            _t.accountNumber = _t.acctList[i].accountNumber;
                            _t.accountType = _t.acctList[i].accountType;
                            _t.currencyCode = _t.acctList[i].currencyCode;
                            _t.accountNickName = _t.acctList[i].accountNickName;

                            $("#accountContent").removeClass('hide').addClass('show');
                            $("#accountChoice").removeClass('show').addClass('hide');
                            $("#rightIconShow").removeClass('hide').addClass('show');
                            $("#txtAccountNum").html(_t.accountNumber);

                            var str = constant.account_type_[_t.accountType];
                            $("#txtAccountType").html('<em class="boc-change-type" style="float: left;">'+str+'</em>');
                            if(_t.accountNickName != undefined && _t.accountNickName != null &&  _t.accountNickName != ""){
                                $('#txtAccountType').html('<em class="boc-change-type" style="float: left;">'+str+'</em>'+'&nbsp;&nbsp;|&nbsp;&nbsp;' + _t.accountNickName);}
                            else break;
                        }
                    }
                }, function(data){},params);
            },
            //显示无可用账户界面
            showNoAccountView:function(){
                var _t = this;
                common.fullLayer.show({
                    view: new($.extendCls(controller, {
                        ejs: "../BocAbroad/views/bpay/can/CanBpayPay/noAccountView.ejs"
                    }))({
                        id: 'NoAccountView',
                        data: {},
                        _hisClose: function(e) {
                            common.fullLayer.close(e);
                            _t.onBack('entrance');
                        }
                    })
                });
            },
            //选择收款人
            onOvpPeerQry: function() {
                var _t = this;
                common.fullLayer.show({
                    view: new($.extendCls(controller, {}))({
                        id: 'bpayPayChoicePeerView',
                        data: [],
                        recordNumber:-1,
                        sure: function(e) {
                            common.fullLayer.close(e);
                            var clickobj = $(e.target);
                            while (clickobj.length > 0 && !clickobj.hasClass('boc-company-card')) {
                                clickobj = clickobj.parent();
                            }
                            var index = clickobj.attr("index");
                            $('#txtPeer').val(this.data[index].billerName);
                            $('#scroller').removeClass('hide').addClass('show');
                            $('#payeeInfoCity').html(this.data[index].city);
                            $('#payeeInfoPhone').html(this.data[index].contactPhone);
                            $('#payeeInfoPostCode').html(this.data[index].postCode);
                            $('#payeeInfoAddress').html(this.data[index].address);
                            _t.billerName = this.data[index].billerName;
                            _t.payeeId = this.data[index].payeeID;
                            _t.payeeAccountNumber = this.data[index].payeeActno;
                            //  _t.minAmount = this.data[i].minAmount;
                            //  _t.maxAmount = this.data[i].maxAmount;
                            //  str = $.localeResource['BocAbroad_CanBpayPay'].l_sinbpay1 + this.data[i].minAmount.toString().changePartition() + "-" + this.data[i].maxAmount.toString().changePartition();
                            //   $('#txtMoneyDis').html(str);
                        },

                        noresult:function(){
                            var noresultHtml = new EJS({
                                url: '../BocAbroad/views/bpay/aud/AudQueryHistoryList/noresult.ejs'
                            }).render();
                            $('#bpayPayeeView').html(noresultHtml);
                        },

                        onLoadFinish: function(data) {
                            var _t = this;
                            model.interaction({
                                method: routesUtil.method.BII.OvcCreConversationWithToken,
                                params: {}
                            }, "BII", function(data) {
                                new common.ScrollPagination({
                                    pageSize: 50,
                                    recordNum: 10000,
                                    el: _t.domNode,
                                    getPageData: function(pageSize, currentPage, startIdx, endIdx, callback) {
                                        //this.removeTip();
                                        if(_t.data.length  == _t.recordNumber || _t.data.length  == _t.recordNumber % pageSize){
                                            this.removeTip();
                                            return;
                                        }
                                        var p = this;
                                        var params = {
                                            "conversationId": data.conversationId,
                                            "currentIndex": _t.data.length / pageSize *  pageSize ,
                                            "pageSize": pageSize,
                                            "_refresh":'true'
                                        };

                                        model.interaction({
                                            method: routesUtil.method.BII.OvpCANBpayPayeeListQry,
                                            params: params,
                                            loadingMask:_t.flag
                                        }, "BII", function(data) {

                                            if (data.list.length ==0){
                                                _t.noresult();
                                                return;
                                            }

                                            _t.flag = false;
                                            _t.recordNumber = data.recordNumber;
                                            p.setRecordNum(data.recordNumber);
                                            p.removeTip();

                                            if(_t.data.length != data.recordNumber)
                                                _t.data = _t.data.concat(data.list);

                                            _t.append(_t.domNode, new EJS({
                                                url: '../BocAbroad/views/bpay/can/CanBpayPay/bpayPayChoicePeerView.ejs'}).render({
                                                data: {
                                                    billerBookList: data.list, startIdx: startIdx != 0 ? startIdx - 1 : startIdx
                                                }
                                            }));
                                        }, {errorFun:function(data){ common.showMessage(data.message, function(){common.fullLayer.close()});}});
                                    }
                                });
                            });//OvcCreConversationWithToken end
                        },
                        _hisClose:function(e){
                            common.fullLayer.close(e);
                        }
                    })
                });
            },
            //提交
            onSubmit: function() {
                var _t = this;
                _t.amount = $('#txtMoney').val().trim() + "";
                if(_t.accountId == ""){
                    common.showMessage($.localeResource['BocAbroad_CanBpayPay'].ovs_bpa_bp_select);
                    return;
                }
                if(!checkForm.checkAll('.boc-content')){//验证页面信息。
                    return;
                }
                _t.showComfirm();
                //限额判断 加拿大无特殊要求
                // if(Number(_t.amount) < Number(_t.minAmount) ) {
                //     common.showMessage($.localeResource['BocAbroad_CanBpayPay'].l_tip3);
                //     return;
                // }
                //
                // if(Number(_t.amount) > Number(_t.maxAmount)){
                //     common.showMessage($.localeResource['BocAbroad_CanBpayPay'].l_tip2);
                //     return;
                // }

            },

            //显示确认界面
            showComfirm: function(){
                var _t = this;
                if(_t.bComfirm == false){
                    return;
                }
                else{
                    _t.bComfirm = false;
                    setTimeout(function(){
                        _t.bComfirm = true;
                    }, 1000);
                }

                if (_t.assignedDate == ""){
                    _t.assignedDate = $('#txtDate').text();
                }

                ///选择结束方式
                if(_t.frequency !='1'){
                    if($("#txtSecWay").html()==$.localeResource['BocAbroad_CanBpayPay'].ovs_bpa_bp_choice){
                        common.showMessage($.localeResource['BocAbroad_CanBpayPay'].ovs_bpa_bp_way_select);
                        return;
                    }
                    else{
                        if(_t.assigneWayType=='1'){
                            if($("#txtSecTimes").val()=='') {
                                common.showMessage($.localeResource['BocAbroad_CanBpayPay'].ovs_bpa_bp_way_select_times);
                                return;
                            }
                        }
                    }
                }
                if($('#txtSecTimes').val()!='')
                    _t.countTime = $('#txtSecTimes').val();

                common.fullLayer.show({
                    view: new($.extendCls(controller, {
                        ejs: "../BocAbroad/views/bpay/can/CanBpayPay/bpayPayComfirm.ejs"
                    }))({
                        id: 'bpayPayComfirmView',
                        data: [{
                            accountId: _t.accountId,
                            accountNumber:_t.accountNumber,
                            payeeId: _t.payeeId,
                            //currency: constant.currency_sign_1_[_t.currencyCode],
                            amount:amountUtil.changePartition(_t.amount),
                            billerName:_t.billerName,
                            billerAccount:_t.payeeAccountNumber,
                            assignedDate:_t.assignedDate,
                            endDate:_t.endDate,
                            countTime:_t.countTime,

                            payeeInfoCity:$("#payeeInfoCity").text(),
                            payeeInfoPhone:$("#payeeInfoPhone").text(),
                            payeeInfoPostCode:$("#payeeInfoPostCode").text(),
                            payeeInfoAddress:$("#payeeInfoAddress").text(),
                            description: $('#txtDescribe').val(),

                            frequency:_t.frequency,//1=单次  2=每天    3=每周  4=每两周  5=每月   6=每季度  7=每年
                            frequencyText:constant.canPayment_schStyle_[_t.frequency],
                            type:_t.assigneWayType//1:次数 2：最后日期
                        }],
                        sure: function(e) {
                            common.fullLayer.close(e);
                            _t.bComfirm = true;
                            model.interaction({
                                method: routesUtil.method.BII.OvcCreConversationWithToken,
                                params: {}
                            }, "BII", function(data) {
                                _t.conversationId = data.conversationId;
                                _t.token = data.token;
                                _t._OvpCanBpayPayment();
                            });
                        },
                        _hisClose:function(e){
                            common.fullLayer.close(e);
                            _t.bComfirm = true;
                        },
                        onLoadFinish:function(data){
                        }
                    })
                }, $.localeResource['BocAbroad_CanBpayPay'].l_describe1);
            },
            //确认接口
            _OvpCanBpayPayment:function(){
                var _t = this;
                var params = {
                    conversationId:_t.conversationId,
                    token:_t.token,

                    accountId: _t.accountId,
                    currencyCode: "028",
                    billerName: _t.billerName,
                    payeeActno:_t.payeeAccountNumber,
                    payeeId: _t.payeeId,
                    // amount:amountUtil.changePartition(_t.amount),
                    amount:_t.amount,
                    assignedDate:_t.assignedDate,
                    frequency:_t.frequency,
                    description: $('#txtDescribe').val()
                };
                if(_t.assigneWayType=='1'){
                    if(_t.countTime == '')
                        _t.countTime = '1';
                    $.extend(params,{count: _t.countTime});
                }
                else{
                    $.extend(params,{endDate:_t.endDate});
                }

                model.interaction({
                    method: routesUtil.method.BII.OvpCANBpayPayment,
                    params: params
                }, "BII", function(data) {
                    _t.scheduleId=data.scheduleId;
                    
                    // var scheduleId ='test';
                    //成功回显示界面
                    common.fullLayer.show({
                        view: new($.extendCls(controller, {
                            ejs: "../BocAbroad/views/bpay/can/CanBpayPay/bpayPayResult.ejs"
                        }))({
                            id: 'bpayPayResultView',
                            data: [{
                                scheduleId: _t.scheduleId
                            }],
                            onBack: function(e) {
                                common.fullLayer.close(e);
                                common.params.targetRouter = {
                                    routerKey: "BocAbroad_CanBpayPay",
                                    isExcuteInit: false,
                                    excuteFun: null,
                                    funArgs: null,
                                    moduleArgs: []
                                };
                                common.triggerRouter(common.params.targetRouter);
                                _t.clearData();
                                // _t.onBack('entrance');
                            },
                            _hisClose:function(e){
                                common.fullLayer.close(e);
                                common.params.targetRouter = {
                                    routerKey: "BocAbroad_CanBpayPay",
                                    isExcuteInit: false,
                                    excuteFun: null,
                                    funArgs: null,
                                    moduleArgs: []
                                };
                                common.triggerRouter(common.params.targetRouter);
                                _t.clearData()
                            }
                        })
                    }, "");
                });
            },

            //执行方式
            onChoice: function() {
                var _t = this;
                common.fullLayer.show({
                    classes:"halfLayer",
                    closeByMask:true,
                    view: new($.extendCls(controller, {
                        ejs: "../BocAbroad/views/bpay/can/CanBpayPay/bpayPayChoiceWayView.ejs"
                    }))({
                        id: 'bpayPayChoiceWayView',
                        onChoose: function(e) {
                            common.fullLayer.close(e);
                            var typeHtml = e.currentTarget.children[0].innerHTML;
                            //1=单次  2=每天    3=每周  4=每两周  5=每月   6=每季度  7=每年
                            var clickobj = $(e.target);
                            while (clickobj.length > 0 && !clickobj.hasClass('boc-popup-a')) {
                                clickobj = clickobj.parent();
                            }
                            _t.frequency = clickobj.attr("index");
                            $("#txtWay").html(typeHtml);

                            if(typeHtml!=$.localeResource['BocAbroad_CanBpayPay'].l_canbpay1){
                                //如果所选项，不为“单次执行”,弹出选择提示框，默认选择执行次数。
                                $("#txtSecWay").html($.localeResource['BocAbroad_CanBpayPay'].l_sec_times);
                                $("#ll_sec_way").removeClass("hide").addClass("show");

                                $("#ll_sec_times").removeClass("hide").addClass("show");
                                $("#ll_sec_date").removeClass("show").addClass("hide");
                                _t.countTime = '1';
                            }
                            else{
                                //如果所选项，为“单次执行”,关闭选择提示框，默认执行次数为1。
                                $("#ll_sec_way").removeClass("show").addClass("hide");
                                $("#txtSecWay").html($.localeResource['BocAbroad_CanBpayPay'].l_sec_times);
                                _t.assigneWayType = '1';

                                //选择执行周期恢复默认
                                $("#ll_sec_times").removeClass("show").addClass("hide");
                                $("#txtSecTimes").val('');
                                _t.countTime='1';

                                //选择执行最后执行日期恢复默认
                                $("#ll_sec_date").removeClass("show").addClass("hide");
                                $("#txtSecDate").html(_t.assignedDate);
                                _t.endDate=_t.assignedDate;
                            }
                        }
                    })
                }, $.localeResource['BocAbroad_CanBpayPay'].l_choiceway);
                $(".halfLayer .dlg_content_body").attr("id","changeTopDetail");
                $("#changeTopDetail").css('top', '28%');
            },
            //第二次选择执行方式
            onSecChoice: function() {
                var _t = this;
                common.fullLayer.show({
                    classes:"halfLayer",
                    closeByMask:true,
                    view: new($.extendCls(controller, {
                        ejs: "../BocAbroad/views/bpay/can/CanBpayPay/bpayPaySecondChoiceWayView.ejs"
                    }))({
                        id: 'bpayPaySecondChoiceWayView',
                        onSecTimes: function(e) {
                            common.fullLayer.close(e);
                            _t.assigneWayType='1';//次数
                            $("#txtSecWay").html($.localeResource['BocAbroad_CanBpayPay'].l_sec_times);
                            $("#txtSecTimes").val('');
                            $("#ll_sec_times").removeClass("hide").addClass("show");

                            //选择执行最后执行日期恢复默认
                            $("#ll_sec_date").removeClass("show").addClass("hide");
                            $("#txtSecDate").html(_t.assignedDate);
                            _t.endDate=_t.assignedDate;
                        },
                        onSecDate: function(e) {
                            common.fullLayer.close(e);
                            _t.assigneWayType='2';//最后日期
                            $("#txtSecWay").html($.localeResource['BocAbroad_CanBpayPay'].l_sec_date);
                            $("#txtSecDate").html(_t.assignedDate);
                            $("#ll_sec_date").removeClass("hide").addClass("show");
                            _t.endDate=_t.assignedDate;

                            //选择执行周期恢复默认
                            $("#ll_sec_times").removeClass("show").addClass("hide");
                            $("#txtSecTimes").val('');
                            _t.countTime='1';


                            // _t.countTime='1';
                        }
                    })
                }, $.localeResource['BocAbroad_CanBpayPay'].l_choiceway);
            },

            //显示date
            onDate: function() {
                var _t = this;
                var params = "";
                var dateMin = "";
                var dateMax = "";

                dateMin = dateUtil.addDays(_t.sysTime, 0);
                dateMax = dateUtil.addYears(_t.sysTime, 3);

                params = pluginsUtil.createSigleDateSelectParams({min:dateUtil.format(dateMin, "yyyy/MM/dd"),
                    max:dateUtil.format(dateMax, "yyyy/MM/dd"), def:dateUtil.format(dateMin,"yyyy/MM/dd")}, "yyyy/MM/dd");
                bocovsbridge.showDatePicker(function(data){
                    if(!data.close){
                        _t.assignedDate = data.picker.single;
                        // _t.assignedDateShow = "31/12/2016";
                        // _t.assignedDate = dateUtil.format(dateUtil.parse(_t.assignedDateShow, 'dd/MM/yyyy'), "yyyy/MM/dd");
                        $('#txtDate').html(_t.assignedDate);

                        if(_t.assignedDate == _t.sysDate) {
                            //选择周期恢复默认
                            $("#ll_way").removeClass("show").addClass("hide");
                            $("#txtWay").html($.localeResource['BocAbroad_CanBpayPay'].l_canbpay1);
                            _t.frequency ='1';

                            //选择执行方式恢复默认
                            $("#ll_sec_way").removeClass("show").addClass("hide");
                            $("#txtSecWay").html($.localeResource['BocAbroad_CanBpayPay'].l_sec_times);
                            _t.assigneWayType = '1';

                            //选择执行周期恢复默认
                            $("#ll_sec_times").removeClass("show").addClass("hide");
                            $("#txtSecTimes").val('');
                            _t.countTime='1';

                            //选择执行最后执行日期恢复默认
                            $("#ll_sec_date").removeClass("show").addClass("hide");
                            $("#txtSecDate").html(_t.assignedDate);
                            _t.endDate=_t.assignedDate;

                        }
                        else
                            $("#ll_way").removeClass("hide").addClass("show");
                        // $("#txtWay").html($.localeResource['BocAbroad_CanBpayPay'].l_canbpay1);//默认单次执行
                    }
                }, function(data){
                    console(data);
                }, params);
            },

            //最后执行日期
            onSecDate:function () {
                var _t = this;
                var params = "";
                var dateMin = "";
                var dateMax = "";

                // _t.sysDate = dateUtil.parse(_t.sysTime, 'yyyy/MM/dd hh:mm:ss');
                var assignedParesDate = dateUtil.parse(_t.assignedDate, 'yyyy/MM/dd');

                dateMin = dateUtil.addDays(assignedParesDate, 0);
                dateMax = dateUtil.addYears(assignedParesDate, 50);
                params = pluginsUtil.createSigleDateSelectParams({min:dateUtil.format(dateMin, "yyyy/MM/dd"),
                    max:dateUtil.format(dateMax, "yyyy/MM/dd"), def:dateUtil.format(dateMin,"yyyy/MM/dd")}, "yyyy/MM/dd");

                bocovsbridge.showDatePicker(function(data){
                    if(!data.close){
                        _t.endDate = data.picker.single;
                        $('#txtSecDate').html(_t.endDate);
                    }
                }, function(data){
                    console(data);
                }, params);
            },

            clearData: function () {
                var _t = this;
                _t.noFiterAccList = [];
                _t.acctList = [];
                _t.billerBookList = [];
            },

            //输入提示（0/100）函数
            blueMsg:function(){
                var _txtDescribe = $('#txtDescribe').val();
                var num = _txtDescribe.length;
                var str = $.localeResource["BocAbroad_CanBpayPay"].l_describe;
                str = str + " (" + num + "/100)";
                $('#hid').html(str);
            },

            // 返回主菜单
            onBack: function(data) {
                var params = "";
                if(data == undefined || data == "")
                    params = "entrance";
                else
                    params = data;
                bocovsbridge.navigateToPage(function(data){}, function(data){},params);
            },
            onBackUI: function() {
                bocovsbridge.navigateToPage(function(data){}, function(data){}, "entrance");
            },
            destroy: function() {
                $.proxy(this.baseprototype.destroy, this)();
            }
        });

        return common.Module.sub({
            _constructor: function() {
                this.mainView = null;
                $.proxy(this.baseprototype._constructor, this)();
            },
            init: function() {
                this.mainView = new mainView({
                    id: "bpayPayCan",
                    el: "#loginViewWrap",
                    eloper: "html",
                    //参数
                    data: {
                        // acctTypeList: ["201", "203", "218"]
                    }
                });
                this.mainView.load();

            },
            destroy: function() {
                this.mainView.destroy();
            }
        });
    });