define(['zepto', 'common', 'viewcontroller', 'model', 'routesUtil', 'constant', 'pluginsUtil', 'dateUtil', 'checkForm', 'iscroll'],
    function($, common, controller, model, routesUtil, constant, pluginsUtil, dateUtil, checkForm, iscroll) {
        var mainView = $.extendCls(controller, {
            ejs: '../BocAbroad/views/bpay/jom/JomPay/jombpayPay.ejs',
            services: [],
            acctList: [],
            noFiterAccList: [],
            accListCountNet: 0,
            billerBookList: [], //公司信息
            conversationId: "",
            accountId: "",
            accountMainNumber: "",//借记卡的number
            accountNumber: "",
            accountType: "",//账号类型
            accountNickName: "",//别名
            availableBalance: "",
            currencyCode: "",
            money: "",
            token: "",
            otp:"",
            transMode:"0",
            assignedDate:"",
            sysTime:"",
            challenge:false,
            confirmBillerName: "",
            bComfirm: true,
            flag: true,
            exchangeSeq:"",
            rrnInfo:"",
            contractSelected:false,
            afterFormSubmit: function(data) {

            },
            onSubError: function(err) {

            },
            serviceFormParams: function() {
                return {};
            },
            onLoadFinish: function(data) {
                var _t = this;

                //得到系统时间
                model.interaction({
                    method: routesUtil.method.BII.OvcSysTimeQry,
                    params: {}
                }, "BII", function(data) {
                    //  _t.sysTime = data.sysTime.split(' ')[0];
                    _t.sysTime = data.sysTime.substring(0,10);
                });


                bocovsbridge.retrieveAccountsList(function(data){
                    //alert("aaaaaaaa" + data.acctList.length);
                    _t.clearData();
                    _t.noFiterAccList = data.acctList;

                    _t.fiterAccount();

                }, function(data){

                });
            },

            //过滤账户查询余额
            fiterAccount: function(){
                var _t = this;
                //是否有可用账户
                var count = 0;
                for(var i = 0; i < _t.noFiterAccList.length; i++){
                    if(_t.noFiterAccList[i].accountType == "201" || _t.noFiterAccList[i].accountType == "203"){//活期账户，支票账户
                        if(_t.noFiterAccList[i].currencyCode == "032"){//
                            _t.acctList.push(_t.noFiterAccList[i]);
                            count += 1;
                        }
                    }
                    else if(_t.noFiterAccList[i].accountType == "213"){//活一本 无法过滤
                        _t.acctList.push(_t.noFiterAccList[i]);
                        count += 1;
                    }

                }

                //console.log(_t.acctList.length);

                if(count == 0){
                    _t.showNoAccountView();
                    return;
                }

                _t.initData();

            },

            initData:function(){
                var _t = this;
                //alert("_t.acctList.length " + _t.acctList.length );


                if(_t.acctList != null){
                    _t.accountMainNumber = "";
                    if(_t.acctList.length == 1){
                        $("#accountContent").removeClass('hide').addClass('show');
                        $("#accountChoice").removeClass('show').addClass('hide');


                        //借记卡单独处理
                        if(_t.acctList[0].accountType == "213"){
                            _t.accountId = _t.acctList[0].accountId;
                            _t.accountType = _t.acctList[0].accountType;
                            _t.accountNickName = _t.acctList[0].accountNickName;
                            _t.accountMainNumber = _t.acctList[0].accountNumber;
                            var subDebitInfo = _t.acctList[0].subDebitInfo;
                            if(subDebitInfo != null){
                                var subAcctList = subDebitInfo.subAcctList;
                                if(subAcctList && subAcctList.length > 0){
                                    _t.accountNumber = subAcctList[0].accountNumber;
                                    //非关联账户的查询余额
                                    var params = {accountId: _t.accountId, accountNumber: _t.accountNumber};
                                    model.interaction({
                                        method: routesUtil.method.BII.OvpNoAssoAcctBalanceQry,//子账户余额查询
                                        params: params
                                    }, "BII", function (data) {
                                        var balanceList = data.balanceList;
                                        for(var i = 0; i < balanceList.length; i++){
                                            if(balanceList[i].currencyCode == "032"){
                                                _t.availableBalance = balanceList[i].availableBalance;
                                                _t.currencyCode = balanceList[i].currencyCode;
                                                $("#txtBalMoney").html(_t.availableBalance.toString().changePartition() );
                                                $("#txtBalCurrencyCode").html("("+ constant.currency_sign_1_[_t.currencyCode] +")") ;
                                                $("#txtCurrenyCode").html("("+ constant.currency_sign_1_[_t.currencyCode] +")");
                                                _t.setCanvas();

                                            }
                                        }
                                    }, function(data){}, false);

                                }
                            }
                        }
                        else{//如果不是借记卡213并且length长度为1
                            _t.accountId = _t.acctList[0].accountId;
                            _t.accountNumber = _t.acctList[0].accountNumber;
                            _t.accountType = _t.acctList[0].accountType;
                            _t.accountNickName = _t.acctList[0].accountNickName;

                            var params = {accountId: _t.accountId};
                            model.interaction({
                                method: routesUtil.method.BII.OvpAcctBalanceQry,//余额查询
                                params: params
                            }, "BII", function(data) {
                                var balanceList = data.balanceList;

                                for(var i = 0; i < balanceList.length; i++){
                                    if(balanceList[i].currencyCode == "032"){//马拉西亚
                                        _t.currencyCode = balanceList[i].currencyCode;
                                        _t.availableBalance = balanceList[i].availableBalance;
                                    }
                                }


                                $("#txtBalMoney").html(_t.availableBalance.toString().changePartition() );
                                $("#txtBalCurrencyCode").html("("+ constant.currency_sign_1_[_t.currencyCode] +")") ;
                                $("#txtCurrenyCode").html("("+ constant.currency_sign_1_[_t.currencyCode] +")");
                                _t.setCanvas();

                            });
                        }

                        if(_t.accountMainNumber == "")//借记卡number
                            $("#txtAccountNum").html(_t.accountNumber);
                        else
                            $("#txtAccountNum").html(_t.accountMainNumber);

                        var str = constant.account_type_[_t.accountType];
                        $("#txtAccountType").html('<em class="boc-change-type" style="float: left;">'+str+'</em>');
                        if(_t.accountNickName != undefined && _t.accountNickName != null &&  _t.accountNickName != "")//如果别名不为空
                            $('#txtAccountType').html('<em class="boc-change-type" style="float: left;">'+str+'</em>'+'&nbsp;&nbsp;|&nbsp;&nbsp;' + _t.accountNickName);


                    }
                }
                else if(_t.acctList.length > 1){ // 选择界面
                    $("#accountContent").removeClass('show').addClass('hide');
                    $("#accountChoice").removeClass('hide').addClass('show');
                }
                else{
                    _t.showNoAccountView();
                }
            },
            /**
             * 设置币种
             */
            setCanvas: function() {
                var _t = this;
                //alert("aaaaaaaaaaaaaaaaaa" + _t.accountType + "bbbb" + _t.currencyCode);
                if(_t.accountType == "201" || _t.accountType == "203" ){//

                    if(_t.currencyCode != ""){
                        $('#bgCurrencyCode').removeClass('hide').addClass('show');
                        $('#txtCurrencyCode').removeClass('hide').addClass('show');
                    }
                    else{
                        $('#bgCurrencyCode').removeClass('show').addClass('hide');
                        $('#txtCurrencyCode').removeClass('show').addClass('hide');
                    }

                }
                else{
                    $('#bgCurrencyCode').removeClass('show').addClass('hide');
                    $('#txtCurrencyCode').removeClass('show').addClass('hide');
                }

                $('#txtCurrencyCode').html(constant.currency_sign_1_[_t.currencyCode]);
            },
            //点击复选框，改变协议同意状态,默认已选择
            contract_select_event: function () {
                var _t = this;
                if (_t.contractSelected == false){
                    // $("#contract_select_button").attr('disabled','');
                    $("#contract_select_button").removeAttr('disabled');
                    $("#contract_select_button").attr('style',"background: #5c7197;");
                    $("#contract_select_img").attr('src','images/contract_selected.png');
                    _t.contractSelected = true;
                } else if (_t.contractSelected == true){
                    $("#contract_select_button").attr('disabled','disabled');
                    $("#contract_select_button").attr('style',"background: #999999;");
                    $("#contract_select_img").attr('src','images/contract_notselected.png');
                    _t.contractSelected = false;
                }
            },
            showNotice:function () {
                common.fullLayer.show({
                    view: new ($.extendCls(controller, {
                        ejs: '../BocAbroad/views/static/JomPayStaticProtocol.ejs'
                    }))({
                        id: 'ProtocolView',
                        data: {},
                        _hisClose: function (e) {
                            common.fullLayer.close(e);
                        }
                    })
                });
            },
            //提交
            onSubmit: function() {
                //debugger;
                var _t = this;

                //_t.showNoAccountView();
                //return;

                var str = $('#txtMoney').val();
                _t.money = str.trim();//str.replace(" ", "");
                if(_t.accountId == ""){
                    common.showMessage($.localeResource['BocAbroad_JomPay'].ovs_bpa_bp_select);
                    return;
                }
                // if (_t.contractSelected == false){
                //     common.showMessage($.localeResource['BocAbroad_JomPay'].ovs_bpa_bp_protocol_select);
                //     return;
                // }

                if(!checkForm.checkAll('.boc-content')){//验证页面信息。
                    return;
                };
                //金额不足提示
                //alert("aaaaaaaaaaa" + _t.money);
                //console.log("_t.availableBalance" + _t.availableBalance +  "_t.money"  + _t.money);
                if(_t.availableBalance != undefined && Number(_t.availableBalance) < Number(_t.money))
                {
                    common.popup.single($.localeResource['BocAbroad_JomPay'].ovs_bpa_bp_error2, $.proxy(_t.checkParams, _t));
                }
                //common.showAlert($.localeResource['BocAbroad_AudBpayPay'].ovs_bpa_bp_error2, [window.app.nls.l_comfirm, window.app.nls.l_cancel], [$.proxy(_t.showComfirm, _t), function(){}]);
                else
                {
                    _t.checkParams();
                    //_t.showComfirm();修改了函数顺序，原来这个直接跳过了接口 dzx
                }





            },
            //显示确认页面
            showComfirm:function(){
                //  debugger;
                var _t = this;
                if(_t.bComfirm == false){
                    return;
                }
                else{
                    _t.bComfirm = false;
                    setTimeout(function(){
                        _t.bComfirm = true;
                    }, 1000);
                }
//--------------------------------------------------------
                var params = {
                    // cusRefNum1: $('#txtCusRefNum1').val().trim(),
                    // cusRefNum2: $('#txtCusRefNum2').val().trim(),
                    // billerCode: $('#txtBillerCode').val().trim(),
                    // description: $('#txtDescription').val().trim(),
                    // amount: _t.money
                    //paymentDate: _t.transMode == "0" ? _t.sysTime : _t.assignedDate
                    cusRefNum: $('#txtCusRefNum1').val().trim(),
                    billerCode: $('#txtBillerCode').val().trim(),
                    amount: _t.money,
                    paymentDate:_t.sysTime
                };
                // model.interaction({
                //         method: routesUtil.method.BII.OvpBpayBillerNameQry,
                //         params: params
                //     }, "BII", function(data) {
                var str = "";
                //debugger;
                // _t.confirmBillerName = "TestName";
                common.fullLayer.show({
                    view: new($.extendCls(controller, {
                        ejs: "../BocAbroad/views/bpay/jom/JomPay/jombpayPayComfirm.ejs"
                    }))({
                        id: 'bpayPayComfirmView',
                        data: [{

                            accountId: _t.accountId,
                            accountNumber: _t.accountMainNumber == "" ? _t.accountNumber : _t.accountMainNumber,
                            billerCode: $('#txtBillerCode').val().trim(),
                            billerName: _t.confirmBillerName,
                            billerAlias: $('#txtBillerAlias').val().trim(),
                            cusRefNum1: $('#txtCusRefNum1').val().trim(),
                            cusRefNum2: $('#txtCusRefNum2').val().trim(),
                            description: $('#txtDescription').val().trim(),
                            //transMode: _t.transMode,
                            // transModeTxt: str,
                            assignedDate: _t.assignedDate,
                            amount: _t.money.toString().changePartition(),
                            type:"MYR"//?
                        }],
                        sure: function(e) {
                            common.fullLayer.close(e);
                            _t.bComfirm = true;
                            _t.onTokePassword();
                            //_t.checkParams();
                        },
                        _hisClose:function(e){
                            _t.bComfirm = true;
                            common.fullLayer.close(e);
                        },
                        onLoadFinish:function(data){
                            //var myScroll = new IScroll('.boc-content', { mouseWheel: true ,click:true});
                        }
                    })
                }, $.localeResource['BocAbroad_JomPay'].l_describe1);
                //             }
                //         );
                // });
            },

            //显示无可用账户界面
            showNoAccountView:function() {
                var _t = this;
                common.fullLayer.show({
                    view: new ($.extendCls(controller, {
                        ejs: '../BocAbroad/views/bpay/jom/JomPay/noAccountView.ejs'
                    }))({
                        id: 'NoAccountView',
                        data: {},
                        _hisClose: function (e) {
                            common.fullLayer.close(e);
                            _t.onBack('entrance');
                        }
                    })
                });

            },
            //选择转出账号 onchice
            onOvpAcctListQry: function() {
                var _t = this;
                if(_t.acctList.length < 1 )
                    return;
                else if(_t.acctList.length == 1 && _t.acctList[0].accountType != "213")
                    return;

                var params = {acctList: _t.acctList};
                bocovsbridge.showAccountListPage(function(data) {
                        var result = data.data;

                        for(var i = 0; i < _t.acctList.length; i++){
                            if(_t.acctList[i].accountId == result.accountId){
                                //借记卡处理
                                if(_t.acctList[i].accountType == "213"){
                                    _t.accountId = _t.acctList[i].accountId;
                                    _t.accountType = _t.acctList[i].accountType;
                                    _t.accountNickName = _t.acctList[i].accountNickName;
                                    _t.accountMainNumber = _t.acctList[i].accountNumber;
                                    _t.accountId = _t.acctList[i].accountId;
                                    var subDebitInfo = result.subDebitInfo;
                                    if(subDebitInfo != null){
                                        var subAcctList = subDebitInfo.subAcctList;
                                        if(subAcctList && subAcctList.length > 0){
                                            _t.accountNumber = subAcctList[0].accountNumber;
                                            //非关联账户的查询余额
                                            var params = {accountId: _t.accountId, accountNumber: _t.accountNumber};
                                            model.interaction({
                                                method: routesUtil.method.BII.OvpNoAssoAcctBalanceQry,
                                                params: params
                                            }, "BII", function (data) {
                                                var balanceList = data.balanceList;
                                                var bFlase = true;
                                                for(var i = 0; i < balanceList.length; i++){
                                                    if(balanceList[i].currencyCode == "032"){
                                                        _t.availableBalance = balanceList[i].availableBalance;
                                                        _t.currencyCode = balanceList[i].currencyCode;
                                                        $("#txtBalMoney").html(_t.availableBalance.toString().changePartition() );
                                                        $("#txtBalCurrencyCode").html("("+ constant.currency_sign_1_[_t.currencyCode] +")") ;
                                                        $("#txtCurrenyCode").html("("+ constant.currency_sign_1_[_t.currencyCode] +")");
                                                        _t.setCanvas();
                                                        bFlase = false;
                                                    }
                                                }

                                                if(bFlase){
                                                    common.showMessage($.localeResource['BocAbroad_AudBpayPay'].ovs_bpa_bp_error3);
                                                    $("#accountContent").removeClass('show').addClass('hide');
                                                    $("#accountChoice").removeClass('hide').addClass('show');
                                                    _t.accountId = "";
                                                }
                                                else{
                                                    $("#accountContent").removeClass('hide').addClass('show');
                                                    $("#accountChoice").removeClass('show').addClass('hide');
                                                }
                                            }, function(data){

                                            });

                                        }
                                    }

                                }
                                else {
                                    _t.accountId = _t.acctList[i].accountId;
                                    _t.accountNumber = _t.acctList[i].accountNumber;
                                    _t.accountType = _t.acctList[i].accountType;
                                    _t.accountNickName = _t.acctList[i].accountNickName;
                                    _t.accountMainNumber = "";

                                    var params = {accountId: _t.accountId};
                                    model.interaction({
                                        method: routesUtil.method.BII.OvpAcctBalanceQry,
                                        params: params
                                    }, "BII", function(data) {
                                        var balanceList = data.balanceList;
                                        var bFalse = false;

                                        for(var i = 0; i < balanceList.length; i++){
                                            if(balanceList[i].currencyCode == "032"){
                                                _t.currencyCode = balanceList[i].currencyCode;
                                                _t.availableBalance = balanceList[i].availableBalance;
                                                bFalse = true;
                                            }
                                        }

                                        if(!bFalse){
                                            common.showMessage($.localeResource['BocAbroad_AudBpayPay'].ovs_bpa_bp_error3);
                                            $("#accountContent").removeClass('show').addClass('hide');
                                            $("#accountChoice").removeClass('hide').addClass('show');
                                            _t.accountId = "";
                                        }



                                        if(bFalse){
                                            $("#txtBalMoney").html(_t.availableBalance.toString().changePartition() );
                                            $("#txtBalCurrencyCode").html("("+ constant.currency_sign_1_[_t.currencyCode] +")") ;
                                            $("#txtCurrenyCode").html("("+ constant.currency_sign_1_[_t.currencyCode] +")");
                                            _t.setCanvas();
                                            $("#accountContent").removeClass('hide').addClass('show');
                                            $("#accountChoice").removeClass('show').addClass('hide');

                                        }

                                    }, function(data){
                                        common.showMessage($.localeResource['BocAbroad_AudBpayPay'].ovs_bpa_bp_error3);
                                        $("#accountContent").removeClass('show').addClass('hide');
                                        $("#accountChoice").removeClass('hide').addClass('show');
                                        _t.accountId = "";
                                    });
                                }

                                if(_t.accountMainNumber == "")
                                    $("#txtAccountNum").html(_t.accountNumber);
                                else
                                    $("#txtAccountNum").html(_t.accountMainNumber);

                                var str = constant.account_type_[_t.accountType];
                                $("#txtAccountType").html('<em class="boc-change-type" style="float: left;">'+str+'</em>');
                                if(_t.accountNickName != undefined && _t.accountNickName != null &&  _t.accountNickName != "")
                                    $('#txtAccountType').html('<em class="boc-change-type" style="float: left;">'+str+'</em>'+'&nbsp;&nbsp;|&nbsp;&nbsp;' + _t.accountNickName);
//                                $("#txtNickName").html("&nbsp;&nbsp;|&nbsp;&nbsp;" + _t.accountNickName);
//                            else
//                                $("#txtNickName").html("");

                            }
                        }
                    },
                    function(data){

                    }, params);
            },
            //选择公司信息
            onMalJPayBillerListQuery: function() {

                //显示页面
                var _t = this;
                common.fullLayer.show({
                    view: new($.extendCls(controller, {}))({
                        id: 'bpayPayChoiceCompanyView',
                        data: [],
                        _hisClose:function(e){
                            common.fullLayer.close(e);
                        },
                        sure: function(e) {
                            common.fullLayer.close(e);
                            var clickobj = $(e.target);

                            if (clickobj.find('span').length == 0){
                                clickobj =  clickobj.parent();
                            }
                            var index = clickobj.attr("index");
                            //alert("bbbbbbbbbbbbbbb" + billerCode);
                            for (var i = 0; i < this.data.length; i++) {
                                //alert("aaaaaa" +  this.data[i].billerCode + "aaaa11"+ billerCode);
                                if (i == index) {
                                    //debugger;
                                    $('#txtBillerCode').val(this.data[i].billerCode);
                                    $('#txtCusRefNum1').val(this.data[i].cusRefNum1);//
                                    $('#txtBillerAlias').val(this.data[i].billerAlias);
                                    $('#txtCusRefNum2').val(this.data[i].cusRefNum2);
                                    break;
                                }
                            }

                        },
                        noresult:function(){
                            var noresultHtml = new EJS({

                                url: '../BocAbroad/views/bpay/jom/JomPay/noresult.ejs'
                            }).render();
                            $('#bpaypayCompanyView').html(noresultHtml);
                        },
                        onLoadFinish: function(data) {
                            var _t = this;
                            //_t.noresult();
                            new common.ScrollPagination({
                                pageSize: 50,
                                recordNum: 10000,
                                el: _t.domNode,
                                getPageData: function(pageSize, currentPage, startIdx, endIdx, callback) {

                                    //if(_t.data.length  == _t.recordNumber || _t.data.length  == _t.recordNumber % pageSize)
                                    //    return;
                                    if(_t.data.length / pageSize != 0){
                                        this.removeTip();
                                        return;
                                    }
                                    var params = {

                                        "currentIndex": _t.data.length / pageSize *  pageSize ,
                                        "pageSize": pageSize
                                    };
                                    var p = this;
                                    model.interaction({
                                        method: routesUtil.method.BII.OvpMalJPayBillerListQuery,
                                        params: params,
                                        loadingMask:_t.flag
                                    }, "BII", function(data) {
                                        p.removeTip();
                                        _t.flag = false;

                                        _t.data = _t.data.concat(data.list);
                                        //_t.recordNumber = _t.recordNumber;

                                        _t.append(_t.domNode, new EJS({//'../BocAbroad/views/bpay/jom/JomPay/jombpayPay.ejs'
                                            url: '../BocAbroad/views/bpay/jom/JomPay/jomPayChoiceCompanyView.ejs'
                                        }).render({
                                            data: {list: data.list, startIdx:startIdx != 0 ? startIdx -1 : startIdx}
                                        }));

                                        if (data.list.length ==0){
                                            _t.noresult();
                                            return;
                                        }
                                    }, {errorFun:function(data){
                                        //common.fullLayer.close();
                                        common.showMessage(data, function(){common.fullLayer.close()});
                                    }});

                                }
                            });
                        }
                    })
                });
            },

            // 返回主菜单
            onBack: function(data) {

                var params = "";
                if(data == undefined || data == "")
                    params = "home";
                else
                    params = data;
                bocovsbridge.navigateToPage(function(data){}, function(data){}, params);
            },
            onBackUI: function() {
                //   $(this).css("background", "#c6c6c6");//改变按钮颜色
                bocovsbridge.navigateToPage(function(data){}, function(data){}, "entrance");
            },


//----------------------------------------------------------
            //检查数据
            checkParams:function(){
                var _t = this;
//debugger;
                var params = {
                    cusRefNum1:$('#txtCusRefNum1').val().trim(),
                    cusRefNum2:$('#txtCusRefNum2').val().trim(),
                    billerCode: $('#txtBillerCode').val().trim(),
                    description: $('#txtDescription').val().trim(),
                    amount:_t.money,
                    //paymentDate: _t.transMode == "0" ? _t.sysTime: _t.assignedDate
                    paymentDate:  _t.sysTime
                };
                _t._OvcCreConversationWithToken();
            },
            _OvcCreConversationWithToken:function(){
                var _t = this;
                model.interaction({
                    method: routesUtil.method.BII.OvcCreConversationWithToken,
                    params: {}
                }, "BII", function(data) {
                    _t.conversationId = data.conversationId;
                    _t.token = data.token;
                    var params = {conversationId: _t.conversationId,
                        serviceId: "OB104"};
                    model.interaction({
                        method: routesUtil.method.BII.PsnGetSecurityFactor,
                        params: params
                    }, "BII", function(data) {
                        var params = {
                            conversationId:_t.conversationId,
                            accountId: _t.accountId,
                            currencyCode: "032",
                            amount: _t.money,
                            billerCode: $('#txtBillerCode').val().trim(),
                            // billerName: _t.confirmBillerName,//?
                            billerAlias: $('#txtBillerAlias').val().trim(),
                            // description: $('#txtDescribe').val().trim(),
                            cusRefNum1:$('#txtCusRefNum1').val().trim(),
                            cusRefNum2:$('#txtCusRefNum2').val().trim(),
                            description: $('#txtDescription').val().trim(),
                            terminalId:"04",//?
                            assignedDate: _t.assignedDate,//?
                            fromAcctNo:_t.accountNumber,//?
                            transMode: _t.transMode,//?
                            _combinId:data._combinList[0].id + "",
                        };

                        model.interaction({
                            method: routesUtil.method.BII.OvpMalJPayPaymentConfirm,
                            params: params
                        }, "BII", function(data) {
                        _t.confirmBillerName=common.strLong(data.billerName,20);
                            _t.exchangeSeq=data.exchangeSeq;
                            _t.rrnInfo=data.rrnInfo;
                           // _t.onTokePassword();获取到公司名称，再做显示。对应的流水号也可以显示，后续有需要添加。
                            _t.showComfirm();
                        });
                    });

                });
            },
//------------------------------------------------------
            _OvpBpaySchedPayment:function(){
                var _t = this;
                var params = {
                    conversationId:_t.conversationId,
                    accountId: _t.accountId,
                    fromAcctNo: _t.accountNumber,
                    currencyCode: "032",
                    amount: _t.money,
                    billerCode: $('#txtBillerCode').val().trim(),
                    billerName: _t.confirmBillerName,
                    billerAlias: $('#txtBillerAlias').val().trim(),
                    cusRefNum1:$('#txtCusRefNum1').val().trim(),
                    cusRefNum2:$('#txtCusRefNum2').val().trim(),
                    description: $('#txtDescription').val().trim(),
                    cusRefNum: $('#txtCusRefNum1').val().trim(),
                    transMode: "0",
                    assignedDate: _t.sysTime,
                    //assignedDate: _t.transMode == "0" ? _t.sysTime:_t.assignedDate,
                    // terminalId:"04",
                    Otp:_t.otp,
                    token:_t.token
                };
                model.interaction({
                    method: routesUtil.method.BII.OvpMalJPayPayment,
                    params: params
                }, "BII", function(data) {
                    var exchangeSeq = _t.exchangeSeq;
                    var amount = _t.money;
                    var paymentDate = data.paymentDate;
                    //                if(_t.transMode == "0"){
//                	paymentDate = data.paymentDate;
//                	exchangeSeq = data.receiptNum;
//                    str = $.localeResource['BocAbroad_AudBpayPay'].l_way;
//                }

                    //alert("exchangeSeq:" + exchangeSeq + "paymentDate:" + paymentDate);
                    //成功回显示界面
                    common.fullLayer.show({
                        view: new($.extendCls(controller, {
                            ejs: "../BocAbroad/views/bpay/jom/JomPay/jombpayPayResult.ejs"
                        }))({
                            id: 'bpayPayResultView',
                            data: [{
                                exchangeSeq: exchangeSeq,
                                amount: amount.toString().changePartition(),
                                rrnInfo:_t.rrnInfo,
                                accountNumber: _t.accountMainNumber == "" ? _t.accountNumber : _t.accountMainNumber,
                                accountId: _t.accountId,
                                billerCode: $('#txtBillerCode').val().trim(),
                                billerName: _t.confirmBillerName,
                                billerAlias: $('#txtBillerAlias').val().trim(),
                                cusRefNum1:$('#txtCusRefNum1').val().trim(),
                                cusRefNum2:$('#txtCusRefNum2').val().trim(),
                                description: $('#txtDescription').val().trim(),
                                //cusRefNum: $('#txtCusRefNum').val().trim(),
                                assignedDate: paymentDate,
//                            transMode: _t.transMode,
//                            transModeTxt: str,
                                type:"MYR"
                            }],
                            onBack: function(e) {
                                common.fullLayer.close(e);
                                _t.onBack('home');
                            },
                            _hisClose:function(e){
                                common.fullLayer.close(e);
                                common.params.targetRouter = {
                                    routerKey: "BocAbroad_JomPay",
                                    isExcuteInit: false,
                                    excuteFun: null,
                                    funArgs: null,
                                    moduleArgs: []
                                }
                                common.triggerRouter(common.params.targetRouter);
                                _t.clearData();

                            }
                        })
                    }, "");
                });
            },
            //显示tokenPassword
            onTokePassword:function(){
                var _t = this;
                var params = {cipher:false, challenge: _t.challenge};
                bocovsbridge.showEtokenPasswordPage(function(data){
//            		alert("password" + data.password);
                        _t.otp = data.password;
                        if(data.close == false)
                            _t._OvpBpaySchedPayment();

                    },
                    function(data){

                    },
                    params);
            },

            clearData:function(){
                var _t = this;
                $("#accountChoice").removeClass('hide').addClass('show');
                $("#accountContent").removeClass('show').addClass('hide');
                _t.noFiterAccList = [];
                _t.acctList = [];
                _t.billerBookList = [];
            },

            destroy: function() {
                $.proxy(this.baseprototype.destroy, this)();
            }
        });

        return common.Module.sub({
            _constructor: function() {
                this.mainView = null;
                $.proxy(this.baseprototype._constructor, this)();
            },
            init: function() {
                this.mainView = new mainView({
                    id: "bpayPayAud",
                    el: "#loginViewWrap",
                    eloper: "html",
                    //参数
                    data: {
                        acctTypeList: ["201", "203", "213"]
                    }
                });
                this.mainView.load();

            },
            destroy: function() {
                this.mainView.destroy();
            }
        });
    });
