/**
 * aud预约付款管理
 * @namespace jomPaymentCompanyDetail
 * @name jomPaymentCompanyDetail
 * @requires zepto,common,amountUtil
 */
define('jomPaymentCompanyDetail', ['zepto', 'common','viewcontroller','model','routesUtil','amountUtil','dateUtil','checkForm'], function($, common,controller,model,routesUtil,amountUtil,dateUtil,checkForm) {
    var JomPaymentCompanyDetail = {
    };
    JomPaymentCompanyDetail.cutCount = 25;
    JomPaymentCompanyDetail._pageSize = 50;
    JomPaymentCompanyDetail.errorCode = 'OIBS.ER00006';
    var _conversationId = "";
    var _token = "";
    /**
     * 绑定返回原生
     * @namespace _style 绑定的样式
     */
    JomPaymentCompanyDetail.getBackApp = function(_style) {
        $(_style).bind("click", function () {
            $(this).css("background", "#c6c6c6");//改变按钮颜色
            bocovsbridge.navigateToPage(function (params) {
            }, function (params) {
            }, 'entrance');
        });
    };

    /**
     * 加载列表
     * @namespace _style 绑定的样式
     */
    JomPaymentCompanyDetail.ovpPayManageList = function(_t,p,flag){
        model.interaction({//先拿到conversationId
            method: routesUtil.method.BII.OvcCreConversationWithToken,
            loadingMask:flag,
            params: {}
        }, "BII", function(data) {
            _conversationId = data.conversationId;
            _token = data.token;
            var params = {};
            if(_t.currentPage == 1){
                params = {
                    currentIndex:_t.startIdx,
                    pageSize:_t.pageSize,
                    _refresh:"true",
                    conversationId:_conversationId
                };
            }else{
                params = {
                    currentIndex:_t.startIdx,
                    pageSize:_t.pageSize,
                    _refresh:"false",
                    conversationId:_conversationId
                };
            }
            model.interaction({
                method: routesUtil.method.BII.OvpMalJPayBillerListQuery,
                loadingMask:flag,
                params: params
            }, "BII", function(data) {
                p.removeTip();
                var leng = $('.boc-list').length;
                _t.data = data.recordNumber;
                p.setRecordNum(_t.data);
                //判断列表数据是否已到最大条数
                if(_t.data != 0 && leng == _t.data){
                    p.showOverTipAtBtm();
                }else{
                    _t.resultData = _t.resultData.concat(data.list);
                    _t.icount = _t.resultData.length - data.list.length;
                    _t.bigData = {list:_t.resultData,icount:_t.icount};
                    //处理过长的title
                    var _title = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm,JomPaymentCompanyDetail.cutCount);
                    $("#audBpayMTitleName").html(_title);
                    if(_t.data == 0){
                        _t.append(_t.domNode.find('.boc-content') , new EJS({
                            url: '../BocAbroad/views/bpay/jom/JomPaymentCompany/noresult.ejs',
                        }).render({data:null}));
                        $(".boc-content-item-a").remove();
                        $("#isum").hide();
                        $("#leftCount").hide();
                        $("#rightCount").hide();
                        //返回原生app
                        JomPaymentCompanyDetail.getBackApp(".boc-red-icon");
                        JomPaymentCompanyDetail.getAddCompany();
                    }else{
                        _t.append(_t.domNode.find('.boc-content') , new EJS({
                            url: '../BocAbroad/views/bpay/jom/JomPaymentCompany/JomPaymentCompanyList.ejs',
                        }).render({data:_t.bigData}));
                        $("#leftCount").show();
                        $("#rightCount").show();
                        $("#isum").show();
                        $("#isum").html(_t.data);
                        //返回原生app
                        JomPaymentCompanyDetail.getBackApp(".boc-red-icon");
                        JomPaymentCompanyDetail.bindStyleDatail(".boc-detail",_t.resultData);
                        JomPaymentCompanyDetail.getAddCompany();
                        JomPaymentCompanyDetail.bindStyleModify('.boc-success-back',_t.resultData);
                    }
                }
            },{errorFun: function(data1){
                if(data1 != null){
                    if(data1.code == JomPaymentCompanyDetail.errorCode) {
                        _t.append(_t.domNode.find('.boc-content'), new EJS({
                            url: '../BocAbroad/views/bpay/jom/JomPaymentCompany/noresult.ejs',
                        }).render({data: null}));
                        $(".boc-content-item-a").remove();
                        //返回原生app
                        var _title = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm,JomPaymentCompanyDetail.cutCount);
                        $("#audBpayMTitleName").html(_title);
                        JomPaymentCompanyDetail.getBackApp(".boc-red-icon");
                        JomPaymentCompanyDetail.getAddCompany();
                    }else{
                        var _title = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm,JomPaymentCompanyDetail.cutCount);
                        $("#audBpayMTitleName").html(_title);
                        JomPaymentCompanyDetail.getBackApp(".boc-red-icon");
                        JomPaymentCompanyDetail.getAddCompany();
                        common.showMessage(data1.message);
                        return;
                    }
                }else{
                    _t.append(_t.domNode.find('.boc-content'), new EJS({
                        url: '../BocAbroad/views/bpay/jom/JomPaymentCompany/noresult.ejs',
                    }).render({data: null}));
                    $(".boc-content-item-a").remove();
                    //返回原生app
                    var _title = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm,JomPaymentCompanyDetail.cutCount);
                    $("#audBpayMTitleName").html(_title);
                    JomPaymentCompanyDetail.getBackApp(".boc-red-icon");
                    JomPaymentCompanyDetail.getAddCompany();
                }
                p.removeTip();
            }});
        },{errorFun: function(){
            p.removeTip();
        }});
    };

    /**
     * 新增账单公司
     */
    JomPaymentCompanyDetail.getAddCompany = function(){
        $('#ovpJomPayeeAdd').bind("click",function(){
            common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/bpay/jom/JomPaymentCompany/JomPaymentCompanyAdd.ejs",
                }))({
                    id: 'paymanage',
                    data:'',
                    ovpPaymentBack:function(e){
                        common.fullLayer.close(e);
                        JomPaymentCompanyDetail.getBackList();
                    },
                    ovpPaymentNext:function(e){
                        if(checkForm.checkAll(".boc-input-import")) {
                            var _code = $('#billerCode').val();
                            common.fullLayer.close(e);
                            JomPaymentCompanyDetail.getNextPage(_code);
                        }
                    }
                })
            });
            var _title = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm_newadd,JomPaymentCompanyDetail.cutCount);
            $("#audPayTit").html(_title);
        })
    }

    /**
     * 下一步
     */
    JomPaymentCompanyDetail.getNextPage = function(_code){
        common.fullLayer.show({
            view: new ($.extendCls(controller, {
                ejs: "../BocAbroad/views/bpay/jom/JomPaymentCompany/JomPaymentCompanySubmit.ejs",
            }))({
                id: 'paymanage',
                data:{"_code":_code},
                ovpPaymentBackList: function(e){
                    common.fullLayer.close(e);
                    JomPaymentCompanyDetail.getBackList();
                },
                ovpPaymentSubmit: function(e) {
                   if(checkForm.checkAll(".boc-input-import")){
                    var params = {
                        billerCode: _code,
                        billerAlias: $('#billerAlias').val(),
                        cusRefNum1: $('#cusRefNum1').val(),
                        cusRefNum2: $('#cusRefNum2').val()
                    };
                    common.fullLayer.show({
                        view: new ($.extendCls(controller, {
                            ejs: "../BocAbroad/views/bpay/jom/JomPaymentCompany/JomPaymentCompanyVerify.ejs",
                        }))({
                            id: 'paymanage',
                            data: params,
                            _hisClosever: function (e) {
                                common.fullLayer.close(e);
                                JomPaymentCompanyDetail.getBackList();
                            },
                            ovpJomPaymentVerify: function (e) {
                                model.interaction({
                                    method: routesUtil.method.BII.PsnGetSecurityFactor,
                                    params: {
                                        conversationId: _conversationId,
                                        serviceId: "OB104"
                                    }
                                }, "BII", function (data1) {
                                    var _combinId = data1._combinList[0].id + "";
                                    params._combinId = _combinId;
                                    JomPaymentCompanyDetail.getAddConfirm(params);
                                })
                            }
                        })
                    });
                }
                    var _title = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm_addmessage,JomPaymentCompanyDetail.cutCount);
                    $("#jomPayVerify").html(_title);
                }
            })
        });
        var _title = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm_addmessage,JomPaymentCompanyDetail.cutCount);
        $("#newsTit").html(_title);
    }

    /**
     * 新增－预交易
     */
    JomPaymentCompanyDetail.getAddConfirm = function(_data){
        //_data.token = _token;
        _data.conversationId = _conversationId;
        model.interaction({
            method: routesUtil.method.BII.OvpMalJPayBillCorpAddConfirm,
            params: _data
        }, "BII", function(data1){
            JomPaymentCompanyDetail.onTokePassword(_data,'add');
        })
    }

    /**
     * 新增
     */
    JomPaymentCompanyDetail.getAdd = function(_data){
        model.interaction({
            method: routesUtil.method.BII.OvpMalJPayBillCorpAdd,
            params: {
                billerCode:_data.billerCode,
                billerAlias:_data.billerAlias,
                cusRefNum1:_data.cusRefNum1,
                cusRefNum2:_data.cusRefNum2,
                Otp:_data._otp,
                token:_token,
                conversationId:_conversationId
            }
        }, "BII", function(data){
            var _msg = $.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bps_spm_addsuccess;
            _data.msg = _msg;
            _data.img = "images/suc.png";
            JomPaymentCompanyDetail.getSuccess(_data);
        },{errorFun: function(){
            var _msg = $.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bps_spm_addfail;
            _data.msg = _msg;
            _data.img = "images/fail.png";
            JomPaymentCompanyDetail.getSuccess(_data);
        }})
    }

    /**
     * 绑定样式显示详情
     * @namespace _style 绑定的样式
     * @name _data 列表data
     */
    JomPaymentCompanyDetail.bindStyleDatail = function(_style,_data){
        $(_style).bind("click", function(){
            var arr = this.id;
            var schedDetail = _data[arr];
            var params = {
                payeeId:schedDetail.payeeId,
                billerCode:schedDetail.billerCode,
                billerAlias:schedDetail.billerAlias,
                cusRefNum1:schedDetail.cusRefNum1,
                cusRefNum2:schedDetail.cusRefNum2
            };
            $("#countBig").css("overflow-y","hidden");
            $("#countBig").css('-webkit-overflow-scrolling','');
            common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/bpay/jom/JomPaymentCompany/JomPaymentCompanyDetail.ejs",
                }))({
                    id: 'paymanage',
                    data:params,
                    _hisClose: function(e){
                        $(e.currentTarget).css("background","#c6c6c6");//改变按钮颜色
                        common.fullLayer.close(e);
                        $("#countBig").css("overflow-y","auto");
                        $("#countBig").css('-webkit-overflow-scrolling','touch');
                    },
                    ovpBaySchedDelQry:function(e){
                        JomPaymentCompanyDetail.ovpRequestDel(schedDetail);
                    }
                })
            });
            var _titleDetail = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm_billpaymentdescription,JomPaymentCompanyDetail.cutCount);
            $("#audPayMDTitleName").html(_titleDetail);
        });
    };

    /**
     * 修改－绑定样式
     */
    JomPaymentCompanyDetail.bindStyleModify = function(_style,_data){
        $(_style).bind("click", function(){
            var arr = this.id;
            var schedDetail = _data[arr];
            var params = {
                payeeId:schedDetail.payeeId,
                billerCode:schedDetail.billerCode,
                billerAlias:schedDetail.billerAlias,
                cusRefNum1:schedDetail.cusRefNum1,
                cusRefNum2:schedDetail.cusRefNum2
            };
            var _code = schedDetail.billerCode;
            $("#countBig").css("overflow-y","hidden");
            $("#countBig").css('-webkit-overflow-scrolling','');
            common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/bpay/jom/JomPaymentCompany/JomPaymentCompanyMod.ejs",
                }))({
                    id: 'paymanage',
                    data:params,
                    _hisClose: function(e){
                        common.fullLayer.close(e);
                        $("#countBig").css("overflow-y","auto");
                        $("#countBig").css('-webkit-overflow-scrolling','touch');
                    },
                    ovpModSubmit:function(e) {
                        if(checkForm.checkAll(".boc-input-import")){
                            var params = {
                                payeeId: $('#payeeId').val(),
                                billerCode: _code,
                                billerAlias: $('#billerAlias').val(),
                                cusRefNum1: $('#cusRefNum1').val(),
                                cusRefNum2: $('#cusRefNum2').val()
                            };
                            model.interaction({
                                method: routesUtil.method.BII.PsnGetSecurityFactor,
                                params: {
                                    conversationId: _conversationId,
                                    serviceId: "OB104"
                                }
                            }, "BII", function (data1) {
                                var _combinId = data1._combinList[0].id + "";
                                params._combinId = _combinId;
                                JomPaymentCompanyDetail.getModConfirm(params);
                            })
                     }
                    }
                })
            });
            var _titleDetail = common.strLong($.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm_billpaymentdescription,JomPaymentCompanyDetail.cutCount);
            $("#audPayMDTitleName").html(_titleDetail);
        });
    };

    /**
     * 修改－预交易
     */
    JomPaymentCompanyDetail.getModConfirm = function(_data){
        //_data.token = _token;
        _data.conversationId = _conversationId;
        model.interaction({
            method: routesUtil.method.BII.OvpMalJPayBillCorpModConfirm,
            params: _data
        }, "BII", function(data1){
            JomPaymentCompanyDetail.onTokePassword(_data,'mod');
        })
    }

    /**
     * 修改
     */
    JomPaymentCompanyDetail.getMod = function(_data){
        model.interaction({
            method: routesUtil.method.BII.OvpMalJPayBillCorpMod,
            params: {
                payeeId:_data.payeeId,
                billerCode:_data.billerCode,
                billerAlias:_data.billerAlias,
                cusRefNum1:_data.cusRefNum1,
                cusRefNum2:_data.cusRefNum2,
                Otp:_data._otp,
                token:_token,
                conversationId:_conversationId
            }
        }, "BII", function(data){
            var _msg = $.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bp_spm_modsuccess;
            _data.msg = _msg;
            _data.img = "images/suc.png";
            JomPaymentCompanyDetail.getSuccess(_data);
        },{errorFun: function(){
            var _msg = $.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bp_spm_modfail;
            _data.msg = _msg;
            _data.img = "images/fail.png";
            JomPaymentCompanyDetail.getSuccess(_data);
        }})
    }

    /**
     * token
     */
    JomPaymentCompanyDetail.onTokePassword = function(data0,id){
        var params = {cipher:false, challenge: false};
        var _otp = '';
        bocovsbridge.showEtokenPasswordPage(function(data){
            _otp = data.password;
            if(!data.close){
                data0._otp = _otp;
                if(id == 'del'){
                    JomPaymentCompanyDetail.getDelete(data0);
                }
                if(id == 'add'){
                    JomPaymentCompanyDetail.getAdd(data0);
                }
                if(id == 'mod'){
                    JomPaymentCompanyDetail.getMod(data0);
                }
            }
        }, function(data){
        },
        params);
    }

    /**
     * 处理删除详情
     * @namespace _style 绑定的样式
     */
    JomPaymentCompanyDetail.ovpRequestDel = function(data){
        var str = $.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bpa_spm_afterdeletion;
        common.popup.single(str,function(e){
            model.interaction({
                method: routesUtil.method.BII.PsnGetSecurityFactor,
                params: {
                    conversationId:_conversationId,
                    serviceId: "OB104"
                }
            }, "BII", function(data1){
                var _combinId = data1._combinList[0].id + "";
                JomPaymentCompanyDetail.getDeleteConfirm(_combinId,data);
            })
        });
    };

    /**
     * 删除－预交易
     */
    JomPaymentCompanyDetail.getDeleteConfirm = function(_combinId,data){
        model.interaction({
            method: routesUtil.method.BII.OvpMalJPayBillCorpDeleteConfirm,
            params: {
                conversationId:_conversationId,
                payeeId:data.payeeId,
                billerCode:data.billerCode,
                cusRefNum1:data.cusRefNum1,
                cusRefNum2:data.cusRefNum2,
                _combinId:_combinId
            }
        }, "BII", function(data1){
            JomPaymentCompanyDetail.onTokePassword(data,'del');
        })
    }

    /**
     * 删除
     */
    JomPaymentCompanyDetail.getDelete = function(data){
        model.interaction({
            method: routesUtil.method.BII.OvpMalJPayBillCorpDelete,
            params: {
                conversationId:_conversationId,
                token:_token,
                payeeId:data.payeeId,
                billerCode:data.billerCode,
                cusRefNum1:data.cusRefNum1,
                cusRefNum2:data.cusRefNum2,
                Otp:data._otp
            }
        }, "BII", function(data){//跳转回列表页面
            JomPaymentCompanyDetail.getDelPage();
            $('#img').attr("src","images/suc.png");
            var strok = $.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bps_spm_delsuccess;
            $('#okorError').html(strok);
        },{errorFun: function(data1){
            JomPaymentCompanyDetail.getDelPage();
            $('#img').attr("src","images/fail.png");
            if(data1 != null){
                var strerror = $.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bps_spm_delfail;
                $('#okorError').html(strerror);
                $('#message').html(data1.message);
                //$('#code').html(data1.code);
            }else{
                var strerror = $.localeResource["BocAbroad_JomPaymentCompanyList"].ovs_bps_spm_delfail;
                $('#okorError').html(strerror);
            }
        }});
    }

    /**
     * 删除成功or失败页面
     */
    JomPaymentCompanyDetail.getDelPage = function(){
        common.fullLayer.show({
            view: new ($.extendCls(controller, {
                ejs: "../BocAbroad/views/bpay/jom/JomPaymentCompany/JomPaymentCompanyDel.ejs",
            }))({
                id: 'paymanage',
                data:'',
                _hisCloseOk: function(e){
                    common.fullLayer.close(e);
                    JomPaymentCompanyDetail.getBackList();
                },
                goHome:function(e){
                    bocovsbridge.navigateToPage(function (params) {
                    }, function (params) {
                    }, 'home');
                }
            })
        });
    }

    /**
     * add和mod-成功页面
     * id = 0 失败, 1 成功
     */
    JomPaymentCompanyDetail.getSuccess = function(_data){
        common.fullLayer.show({
            view: new ($.extendCls(controller, {
                ejs: "../BocAbroad/views/bpay/jom/JomPaymentCompany/JomPaymentCompanySuccess.ejs",
            }))({
                id: 'paymanage',
                data:_data,
                _hisCloseOk:function(e){
                    common.fullLayer.close(e);
                    JomPaymentCompanyDetail.getBackList();
                },
                goHome: function(e){
                    bocovsbridge.navigateToPage(function (params) {
                    }, function (params) {
                    }, 'home');
                }
            })
        });
    }

    /**
     * 回到列表
     */
    JomPaymentCompanyDetail.getBackList = function(){
        common.params.targetRouter = {
            routerKey: "BocAbroad_JomPaymentCompanyList",
            isExcuteInit: false,
            excuteFun: null,
            funArgs: null,
            moduleArgs: []
        }
        common.triggerRouter(common.params.targetRouter);
    }
    return JomPaymentCompanyDetail;
});