/**
 * Created by Pactera on 2015/11/7.
 */
define(['zepto', 'common', 'viewcontroller', 'model', 'routesUtil', 'dateUtil', 'constant'],
    function($, common, controller, model, routesUtil, dateUtil, constant) {

    var mainView = $.extendCls(controller, {
        services: null,
        ejs: '../BocAbroad/views/bpay/jom/JomSelectHistoryTime/queryHistoryMain.ejs',
        hisdata:null,
        resultData:[],
        p:null,
        loading:null,
        isFirst:true,
        pageparams:{
            currentIndex: 0,
            pageSize: 50,
            startDate:"",
            endDate:"",
            fromAcctNo:"",
            accountId: "",
            _refresh: "true"},
        conversationId:null,
        recordNumber:0,

        _showhisDetail: function(item) {

            common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/bpay/jom/JomSelectHistoryTime/showHistoryDetail.ejs"
                }))({
                    class: 'halfLayer',
                    id: 'hisdetailView',
                    data: item,
                    _hisClose: function(e){
                        common.fullLayer.close(e);

                    }
                })
            });

        },
        /*
         历史列表页面，点击返回，跳转选择查询时间页面
         */
        goHisTimeSelect:function(){
            var funArgs =[];

            common.params.targetRouter = {
                routerKey: "BocAbroad_JomSelectHistoryTime", //entrance
                isExcuteInit: false,
                excuteFun: "init",
                funArgs: funArgs,
                moduleArgs: []
            }
            common.triggerRouter(common.params.targetRouter);
        },

        /*
         查询无结果页面
         */
        noresult:function(){

            var html = new EJS({url:"../BocAbroad/views/bpay/jom/JomSelectHistoryTime/noresult.ejs"}).render({});
            $('#listViewContainer').html(html);
            //$('#container').append(html);

        },

        /**
         * 查询帐单历史列表
         */
        getOvpSinBpayHistoryQry: function() {
            var _t = this;
            _t.p.removeTip();
            _t.pageparams.conversationId = _t.conversationId;

            if (_t.isFirst){
                _t.pageparams.currentIndex = '0';
                _t.pageparams._refresh = "true";
            } else {
                var recordNumber = parseInt( _t.recordNumber);
                if (_t.resultData.length >= recordNumber){
                    return;
                }
                _t.pageparams.currentIndex = parseInt(_t.pageparams.currentIndex) +  parseInt(_t.pageparams.pageSize);
                _t.pageparams._refresh = "false";
            }

            model.interaction({
                method: routesUtil.method.BII.OvpMalJPayHistoryQry,
                loadingMask: _t.loading,//页面第一次加载loading显示
                params: _t.pageparams
            }, "BII", function (data) {
                _t.recordNumber = data.recordNumber;
                if (data.recordNumber==0){
                    _t.noresult();
                    return;
                }
                $("#recordNumberContainer").show();
                _t.loading = false;
                _t.isFirst = false;
                _t.resultData = _t.resultData.concat(data.billerHistoryList);

                $.each(data.billerHistoryList, function(index, item){

                    item.paymentDate =  dateUtil.format(dateUtil.parse(item.paymentDate, 'yyyy/MM/dd'), 'yyyy/MM/dd');
                    item.billerName= common.strLong(item.billerName,25);
                    // if (item.paymentTime) {
                    //     item.paymentTime =  dateUtil.format(dateUtil.parse(item.paymentTime, 'yyyy/MM/dd'), 'dd/MM/yyyy');
                    // }

                });
                _t.append(_t.domNode.find('#listView'), new EJS({
                    url: '../BocAbroad/views/bpay/jom/JomSelectHistoryTime/queryHistoryList.ejs'
                }).render(data));
                $('#recordNumber').html( _t.recordNumber);
                $.each($('.boc-list'), function(index, object){
                    $(object).bind('click', function(){
                        _t.resultData[index].cur = "("+ constant.currency_sign_1_["032"] +")";
                        _t._showhisDetail( _t.resultData[index]);
                    });
                });
            },{errorFun:function(data){
                _t.p.removeTip();
                _t.noresult();
            }});

        },

        onSubError: function(err) {

        },
        serviceFormParams: function() {
            return {};
        },
        onLoadFinish: function(data) {

            var _t = this;
            _t.pageparams.startDate = data.startDate;
            _t.pageparams.endDate = data.endDate;
            _t.pageparams.fromAcctNo = data.accountNumber;
            _t.pageparams.accountId = data.accountId;
            _t.loading = true;
            _t.resultData = [];
            //_t.domNode.find('.boc-h_content1').css('height', ($(window).height()-64) + 'px');

            new common.ScrollPagination({
                pageSize: _t.pageparams.pageSize,

                el: _t.domNode.find('#listViewContainer'),
                getPageData: function() {
                    _t.p = this;
                    if(_t.conversationId == null || _t.conversationId == ''){
                    model.interaction({//先拿到先拿到conversationId
                        method: routesUtil.method.BII.OvcCreConversation,
                        loadingMask: _t.loading,//页面第一次加载loading显示
                        params: {}
                    }, "BII", function(data) {
                        _t.conversationId = data.conversationId;
                        _t.getOvpSinBpayHistoryQry();
                        _t.loading = false;
                    })}
                    else _t.getOvpSinBpayHistoryQry();

                }
            });

        },

        //执行方式
        onChoice: function() {

        },
        destroy: function() {
            $.proxy(this.baseprototype.destroy, this)();
        }
    });

    return common.Module.sub({
        _constructor: function() {

            this.mainView = null;
            $.proxy(this.baseprototype._constructor, this)();
        },
        CSSPATH:[""],
        init: function() {
  },
        initdata:function(data){

            this.mainView = new mainView({
                id: "boc-historylistview",
                el: "#loginViewWrap",
                eloper: "html",
                //参数
                data:data
            });
            this.mainView.load(data);
        },
        destroy: function() {
            this.mainView.destroy();
        }
    });
});