/**
 * sin预约付款管理
 * @namespace sinPayManageDetail
 * @name sinPayManageDetail
 * @requires zepto,common,amountUtil
 * jsn = encodeURI(jsn);
 */
define('sinPayManageDetail', ['zepto', 'common','viewcontroller','model','routesUtil','amountUtil','checkForm','pluginsUtil','dateUtil','constant'],
    function($, common,controller,model,routesUtil,amountUtil,checkForm,pluginsUtil,dateUtil,constant) {
    var SinPayManageDetail = {
    };
    SinPayManageDetail.cutCount = 25;
    SinPayManageDetail._pageSize = 50;
    SinPayManageDetail.errorCode = 'OIBS.ER00006';
    var _conversationId = "";
    var _token = "";
    var accList = [];
    /**
     * 绑定返回原生
     * @namespace _style 绑定的样式
     */
    SinPayManageDetail.getBackApp = function(_style) {
        $(_style).bind("click", function () {
            $(this).css("background", "#c6c6c6");//改变按钮颜色
            bocovsbridge.navigateToPage(function (params) {
            }, function (params) {
            }, 'entrance');
        });
    };
    /**
     * 加载列表
     * @namespace _style 绑定的样式
     */
    SinPayManageDetail.ovpPayManageList = function(_t,p,flag){
        model.interaction({//先拿到conversationId
            method: routesUtil.method.BII.OvcCreConversationWithToken,
            loadingMask:flag,
            params: {}
        }, "BII", function(data) {
            _conversationId = data.conversationId;
            _token = data.token;
            var params = {};
            if(_t.currentPage == 1){
                params = {
                    currentIndex:_t.startIdx,
                    pageSize:_t.pageSize,
                    _refresh:"true",
                    conversationId:_conversationId
                };
            }else{
                params = {
                    currentIndex:_t.startIdx,
                    pageSize:_t.pageSize,
                    _refresh:"false",
                    conversationId:_conversationId
                };
            }
            model.interaction({
                method: routesUtil.method.BII.OvpSinBpaySchedListQry,
                loadingMask:flag,
                params: params
            }, "BII", function(data) {
                p.removeTip();
                var leng = $('.boc-list').length;
                _t.data = data.recordNumber;
                p.setRecordNum(_t.data);
                if(_t.data != 0 && leng == _t.data){
                    p.showOverTipAtBtm();
                }else {
                    _t.resultData = _t.resultData.concat(data.scheduleList);
                    _t.icount = _t.resultData.length - data.scheduleList.length;
                    _t.bigData = {scheduleList: _t.resultData, icount: _t.icount};
                    //处理过长的title
                    var _title = common.strLong($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm, SinPayManageDetail.cutCount);
                    $("#sinBpayMTitleName").html(_title);
                    if (_t.data == 0) {
                        _t.append(_t.domNode.find('.boc-content'), new EJS({
                            url: '../BocAbroad/views/bpay/aud/AudPaymentManage/noresult.ejs',
                        }).render({data: null}));
                        $(".boc-content-item-a").remove();
                        $("#isum").hide();
                        $("#leftCount").hide();
                        $("#rightCount").hide();
                        //返回原生app
                        SinPayManageDetail.getBackApp(".boc-red-icon");
                    } else {
                        _t.append(_t.domNode.find('.boc-content'), new EJS({
                            url: '../BocAbroad/views/bpay/sin/SinPaymentManage/SinPayManageList.ejs',
                        }).render({data: _t.bigData}));
                        $("#leftCount").show();
                        $("#rightCount").show();
                        $("#isum").show();
                        $("#isum").html(_t.data);
                        //返回原生app
                        SinPayManageDetail.getBackApp(".boc-red-icon");
                        SinPayManageDetail.bindStyleDatail(".boc-detail", _t.resultData);
                        SinPayManageDetail.bindStyleModify(".boc-success-back", _t.resultData, _t.sysTime);
                    }
                }
             },{errorFun: function(data){
                if(data !=null){
                    if(data.code == SinPayManageDetail.errorCode){
                        _t.append(_t.domNode.find('.boc-content'), new EJS({
                            url: '../BocAbroad/views/bpay/aud/AudPaymentManage/noresult.ejs',
                        }).render({data: null}));
                        $(".boc-content-item-a").remove();
                        //返回原生app
                        var _title = common.strLong($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm, SinPayManageDetail.cutCount);
                        $("#sinBpayMTitleName").html(_title);
                        SinPayManageDetail.getBackApp(".boc-red-icon");
                    }else{
                        var _title = common.strLong($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm, SinPayManageDetail.cutCount);
                        $("#sinBpayMTitleName").html(_title);
                        SinPayManageDetail.getBackApp(".boc-red-icon");
                        common.showMessage(data.message);;
                        return;
                    }
                }else{
                    _t.append(_t.domNode.find('.boc-content'), new EJS({
                        url: '../BocAbroad/views/bpay/aud/AudPaymentManage/noresult.ejs',
                    }).render({data: null}));
                    $(".boc-content-item-a").remove();
                    //返回原生app
                    var _title = common.strLong($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm, SinPayManageDetail.cutCount);
                    $("#sinBpayMTitleName").html(_title);
                    SinPayManageDetail.getBackApp(".boc-red-icon");
                }
                p.removeTip();
            }});
        },{errorFun: function(){p.removeTip();}});
    };

    /**
     * 绑定样式显示详情
     * @namespace _style 绑定的样式
     * @name _data 列表data
     */
    SinPayManageDetail.bindStyleDatail = function(_style,_data){
        $(_style).bind("click", function(){
            var arr = this.id;
            var schedDetail = $.extend({}, _data[arr]);
            var params = {
                exchangeSeq:schedDetail.exchangeSeq,
                paymentAcctNum:schedDetail.paymentAcctNum,
                billerName:schedDetail.billerName,
                payeeActno:schedDetail.payeeActno,
                billerAlias:schedDetail.billerAlias,
                amount:amountUtil.changePartition(schedDetail.amount.toString()),
                description:schedDetail.description,
                schedDate:SinPayManageDetail.getDdMmYyyy(schedDetail.schedDate),
                isModFlag:schedDetail.isModFlag
            };
            $("#countBig").css("overflow-y","hidden");
            $("#countBig").css('-webkit-overflow-scrolling','');
            common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/bpay/sin/SinPaymentManage/SinPayManageDetail.ejs",
                }))({
                    id: 'paymanage',
                    data:params,
                    _hisCloseDetail: function(e){
                        $(e.currentTarget).css("background","#c6c6c6");//改变按钮颜色
                        common.fullLayer.close(e);
                        $("#countBig").css("overflow-y","auto");
                        $("#countBig").css('-webkit-overflow-scrolling', 'touch');
                    },
                    ovpSinBaySchedDelQry:function(e){
                        SinPayManageDetail.ovpRequestDel($("#exchangeSeq").text());
                    },
                })
            });
            var _titleDetail = common.strLong($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm_transactiondetails,SinPayManageDetail.cutCount);
            $("#sinPayMDTitleName").html(_titleDetail);
        });
    };

    /**
     * 处理删除详情
     * @namespace _style 绑定的样式
     */
    SinPayManageDetail.ovpRequestDel = function(exchangeSeq){
        var str = $.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm_afterdeletion;
        common.popup.single(str,function(e){
            common.fullLayer.close(e);//先关闭窗口
            model.interaction({
                method: routesUtil.method.BII.OvpSinBpaySchedRecordDel,
                params: {
                    conversationId:_conversationId,
                    token:_token,
                    exchangeSeq:exchangeSeq
                }
            }, "BII", function(data) {//跳转回列表页面
                    common.params.targetRouter = {
                        routerKey: "BocAbroad_SinPaymentManageList",
                        isExcuteInit: false,
                        excuteFun: null,
                        funArgs: null,
                        moduleArgs: []
                    }
                    common.triggerRouter(common.params.targetRouter);
                    var strdel = $.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm_delsuccess;
                    common.popdown.single(strdel,function(e){});
                });
            });
    };

    /**
     * 修改－绑定样式显示详情
     * @namespace _style 绑定的样式
     * @name _data 列表data
     */
    SinPayManageDetail.bindStyleModify = function(_style,_data,time){
        $(_style).bind("click", function(){
            var arr = this.id;
            var schedDetail = $.extend({}, _data[arr]);
            model.interaction({//获取typeMap
                method: routesUtil.method.BII.OvpSinBpayBillerOrgOwnedDetailQry,
                params: {payeeId:schedDetail.payeeId}
            }, "BII", function(data) {
                    var minAmount = data.minAmount;
                    var maxAmount = data.maxAmount;
                    //处理过长的详情页title
                    schedDetail.sinEditPayMDTitleName = common.strLong($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm_amendpaymentinformation,SinPayManageDetail.cutCount);
                    schedDetail.checkAmount = $.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm_paymentlimit + amountUtil.changePartition(minAmount.toString()) + '~' + amountUtil.changePartition(maxAmount.toString());
                    var ownedDetail = data;
                    var orgdetail = constant.sin_company_id_2_[schedDetail.billerCode];
                    var billerorgdetail = $.extend({},{"orgdetail":orgdetail},{"schedDetail":schedDetail},{"ownedDetail":ownedDetail});
                    $("#countBig").css("overflow-y","hidden");
                    $("#countBig").css('-webkit-overflow-scrolling','');
                    common.fullLayer.show({
                        view: new ($.extendCls(controller, {
                            ejs: "../BocAbroad/views/bpay/sin/SinPaymentManage/SinPayManageEdit.ejs",
                        }))({
                            id: 'paymanageedit',
                            data:billerorgdetail,
                            _hisEditClose: function(e){
                                $(e.currentTarget).css("background","#c6c6c6");//改变按钮颜色
                                common.fullLayer.close(e);
                                $("#countBig").css("overflow-y","auto");
                                $("#countBig").css('-webkit-overflow-scrolling','touch');
                            },
                            //提交按钮
                            ovpSinBaySchedSubmit : function(e){
                                billerorgdetail.schedDetail.paymentAcctNum = $("#paymentAcctNum").text();
                                billerorgdetail.schedDetail.amount = $("#amount").val();
                                billerorgdetail.schedDetail.description = $("#description").val();
                                billerorgdetail.schedDetail.schedDate = $("#schedDate").val();
                                billerorgdetail.schedDetail.accountId = $("#accountId").val();
                                billerorgdetail.schedDetail.currencyCode = $("#currencyCode").val();
                                var _txtAccountType = $("#txtAccountType").html();
                                $("#amount").val($("#amount").val().replace(',',''));
                                var _txtBalMoney = $("#txtBalMoney").html();
                                if(SinPayManageDetail.checkFormForSinPayManageDetail(".boc-input-import")){
                                    if(_txtAccountType == '' || _txtAccountType == 'undefined'){
                                        common.showMessage($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_bpm_noaccount);
                                        return ;
                                    }else{
                                        if(Number(billerorgdetail.schedDetail.amount) > Number(maxAmount)){
                                            common.showMessage($.localeResource["BocAbroad_SinPaymentManageList"].l_tip2);
                                            return;
                                        }else if(Number(billerorgdetail.schedDetail.amount) < Number(minAmount)){
                                            common.showMessage($.localeResource["BocAbroad_SinPaymentManageList"].l_tip3);
                                            return;
                                        }else{
                                            if(_txtBalMoney != '_txtBalMoney' && Number(_txtBalMoney.replace(',','')) < Number($("#amount").val())){
                                                var str = $.localeResource["BocAbroad_SinPaymentManageList"].ovs_bpa_bp_error2;
                                                common.popup.single(str,function(e) {
                                                    $("#amount").val(billerorgdetail.schedDetail.amount);
                                                    billerorgdetail.schedDetail.amount = billerorgdetail.schedDetail.amount.replace(',', '');
                                                    //common.fullLayer.close(e);
                                                    SinPayManageDetail.getSubmitVerifyMessage(billerorgdetail, e);
                                                })
                                            }else{
                                                $("#amount").val(billerorgdetail.schedDetail.amount);
                                                billerorgdetail.schedDetail.amount = billerorgdetail.schedDetail.amount.replace(',', '');
                                                SinPayManageDetail.getSubmitVerifyMessage(billerorgdetail, e);
                                            }

                                        }
                                    }
                                }
                            },
                            onCard:function(){
                                SinPayManageDetail.cardList();
                            },
                            onDate: function() {
                                var schedDateVal = $("#schedDate").val();
                                if(schedDateVal != '' && schedDateVal != 'undefined'){
                                    SinPayManageDetail.checkAppTime(time,schedDateVal);
                                }else{
                                    SinPayManageDetail.checkAppTime(time,schedDetail.schedDate);
                                }

                            },
                        })
                    });
                SinPayManageDetail.cardDetail(schedDetail.paymentAcctNum);
        });
        });
    };
    /**
     *交验表单输入项
     */
    SinPayManageDetail.checkFormForSinPayManageDetail = function(_style){
        if(!checkForm.checkAll(_style)){
            return false;
        }
        return true;
    };

    /**
     * 填充页面值
     * @param writeList
     * @param _availableBalance 余额
     * @param _currencyCode 币种
     */
    SinPayManageDetail.writeHtml = function(writeList,_availableBalance,_currencyCode){
        $("#paymentAcctNum").html('');
        $("#txtBalCurrencyCode").html('');
        $("#txtAccountType").html('');
        $("#currencyCode").val('');
        $("#accountId").val('');
        $("#txtBalMoney").html('');
        $("#txtNickName").html('');
        $("#txtCurrencyCode").html('');
        var str = constant.account_type_[writeList.accountType];
        if(writeList.accountType == "212" ){
            $('#tubiao').hide();
            $("#txtBalCurrencyCode").html("&nbsp;&nbsp;"+"(SGD)");
        }else{
            $('#tubiao').show();
            $("#txtBalCurrencyCode").html("&nbsp;&nbsp;"+"(SGD)");//html("("+ constant.currency_sign_1_[writeList.currencyCode] +")") ;
        }
        $("#paymentAcctNum").html(writeList.accountNumber);
        $('#txtAccountType').html('<em class="boc-change-type" style="float: left;">'+str+'</em>');
        $('#currencyCode').val(_currencyCode);
        $('#accountId').val(writeList.accountId);
        $('#txtBalMoney').html(_availableBalance.toString().changePartition());
        if(writeList.accountNickName != 'undefined' && writeList.accountNickName != '' && writeList.accountNickName != null){
            $('#txtAccountType').html('<em class="boc-change-type" style="float: left;">'+str+'</em>'+'&nbsp;&nbsp;|&nbsp;&nbsp;' + writeList.accountNickName);
            //$("#txtNickName").html("&nbsp;&nbsp;|&nbsp;&nbsp;" + writeList.accountNickName);
        }
        //角标
        $("#txtCurrencyCode").html("SGD");//html(constant.currency_sign_1_[writeList.currencyCode]);
    }
    /**
     *回显帐户信息
     */
    SinPayManageDetail.cardDetail = function(paymentAcctNum){
        //var count = 0;
        var parList = {};
        bocovsbridge.retrieveAccountsList(function(data){
            accList = data.acctList;
            for(var i = 0;i < accList.length;i++){
                var _accountNumber = accList[i].accountNumber;
                 var _accountId = accList[i].accountId;
                if(paymentAcctNum == _accountNumber){
               			parList = accList[i];
                    model.interaction({
                        method: routesUtil.method.BII.OvpAcctBalanceQry,
                        params: {accountId:_accountId}
                    }, "BII", function(data1) {
                        for(var j = 0;j < data1.balanceList.length;j++){
                            var _currencyCode = data1.balanceList[j].currencyCode;
                            var _availableBalance = data1.balanceList[j].availableBalance;//余额
                            if(_currencyCode == '018'){
                                SinPayManageDetail.writeHtml(parList,_availableBalance,_currencyCode);
                            }
                        }
                    })
                    //count++;
                }
            }
        }, function(data){});
       /* if(count > 0){//跳到无帐户列表
            SinPayManageDetail.showNoAccountView();
        }*/
    }
    //显示无可用账户界面
    SinPayManageDetail.showNoAccountView = function(){
        common.fullLayer.show({
            view: new($.extendCls(controller, {
                ejs: "../BocAbroad/views/bpay/sin/bpayPay/noAccountView.ejs"
            }))({
                id: 'NoAccountView',
                data: {},
                _hisClose: function(e) {
                    common.fullLayer.close(e);
                    SinPayManageDetail.getBackApp(".boc-gray-icon");
                }
            })
        });
    }

    /**
     * 1 点击触发卡列表，2 选择并回显选中的卡
     */
    SinPayManageDetail.cardList = function(){
        var params = [];
        var parList = {};
        if(accList != null){
            for(var i = 0;i < accList.length;i++){
                var accountType = accList[i].accountType;
                if(accountType == '201'){
                    if(accList[i].currencyCode == '018'){
                        params.push(accList[i]);
                    }
                }
                if(accountType == '203'){
                    if(accList[i].currencyCode == '018'){
                        params.push(accList[i]);
                    }
                }
                if(accountType == '212'){
                    params.push(accList[i]);
                }
            }
            params = {acctList:params};
            bocovsbridge.showAccountListPage(function(data){
                if(!data.close){
                		parList = data.data;
                    model.interaction({
                        method: routesUtil.method.BII.OvpAcctBalanceQry,
                        params: {accountId:parList.accountId}
                    }, "BII", function(data1) {
                        var ii = 0;
                        for(var j = 0;j < data1.balanceList.length;j++){
                            var _currencyCode = data1.balanceList[j].currencyCode;
                            var _availableBalance = data1.balanceList[j].availableBalance;//余额
                            if(_currencyCode == '018'){
                                ii++;
                                SinPayManageDetail.writeHtml(parList,_availableBalance,_currencyCode);
                            }
                        }
                        if(ii == 0){
                                common.showMessage($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bpa_bp_no018);
                                return;
                        }
                    })
                }
            }, function(data){
                //console(data);
            },
            params);
        }
    }

    /**
     * 设置币种
     */
    SinPayManageDetail.setCanvas = function(accountType) {
        if(accountType == "212" ){
            $('#tubiao').hide();
        }
        else{
            $('#tubiao').show();
        }
    }

    /**
     *日期
     */
    SinPayManageDetail.checkAppTime = function(time,time2){
        var addtime1 = "";
        if(time != null){
            addtime1 = dateUtil.formatDateToString(dateUtil.addDays(dateUtil.getDateObj(time),1),'%Y/%m/%d %H:%M:%S');
            addtime1 = addtime1.substring(0,10);
            time = time.substring(0,10);
        }
        var params = {
            min:SinPayManageDetail.getDdMmYyyy(addtime1),
            max:SinPayManageDetail.getDdMmYyyy(dateUtil.format(dateUtil.addMonths(time,3),"yyyy/MM/dd")),
            def:time2
        };
        var par = pluginsUtil.createSigleDateSelectParams(params,'dd/MM/yyyy');
        bocovsbridge.showDatePicker(function(data){
            if(data.close){
                var nowDate = $('#schedDate').val();
                $('#schedDate').val(nowDate);
            }else{
                var assignedDate1 = data.picker.single;
                $('#schedDate').val(assignedDate1);
            }
        }, function(data){
            console(data);
        }, par);
    };

    /**
     *提交修改信息处理
     */
    SinPayManageDetail.getSubmitVerifyMessage = function(retParams,e){
        retParams.schedDetail.schedDate = SinPayManageDetail.getDdMmYyyy(retParams.schedDetail.schedDate);
        model.interaction({//交易初始化
            method: routesUtil.method.BII.OvpSinBpaySchedRecordModPre,
            params: {
                exchangeSeq:retParams.schedDetail.exchangeSeq,
                amount:Number(retParams.schedDetail.amount),
                description:retParams.schedDetail.description,
                assignedDate:retParams.schedDetail.schedDate,
                accountId:retParams.schedDetail.accountId,
                transMode:retParams.schedDetail.transMode,
                conversationId:_conversationId,
                payeeActno:retParams.schedDetail.payeeActno,
                currencyCode:retParams.schedDetail.currencyCode,
                billerCode:retParams.schedDetail.billerCode,
                billerName:retParams.schedDetail.billerName,
                billerAlias:retParams.schedDetail.billerAlias
            }
        }, "BII", function(data) {
            var typeList = [];
            var params1 = {};
            for(var i = 0; i < data._combinList.length; i ++){
                typeList.push(data._combinList[i].id + "");
            }
            params1['typeList'] = typeList;
            bocovsbridge.showChoiceEtokenPasswordPage(function(data1){
            model.interaction({//交易纪录确认
                method: routesUtil.method.BII.OvpSinBpaySchedRecordModConfirm,
                params: {
                    exchangeSeq:retParams.schedDetail.exchangeSeq,
                    amount:Number(retParams.schedDetail.amount),
                    description:retParams.schedDetail.description,
                    assignedDate:retParams.schedDetail.schedDate,
                    accountId:retParams.schedDetail.accountId,
                    transMode:retParams.schedDetail.transMode,
                    conversationId:_conversationId,
                    payeeActno:retParams.schedDetail.payeeActno,
                    currencyCode:retParams.schedDetail.currencyCode,
                    billerCode:retParams.schedDetail.billerCode,
                    billerName:retParams.schedDetail.billerName,
                    billerAlias:retParams.schedDetail.billerAlias,
                    _combinId:data1.type
                }
            }, "BII", function(data0) {
                var _tokenClass = [];
                for(var i = 0; i < data0.factorList.length; i++){
                    if(data0.factorList[i].field.name == "Otp")
                        _tokenClass.push("1");//动态口令 1代
                    else if(data0.factorList[i].field.name == "Smc")
                        _tokenClass.push("3");//// 短信验证码
                    else if(data0.factorList[i].field.name == "Tsp")
                        _tokenClass.push("2"); //动态口令 2代
                }
                var _challengeCode = data0._challengeCode == null ? false : data0._challengeCode;
                common.fullLayer.show({
                    view: new ($.extendCls(controller, {
                        ejs: "../BocAbroad/views/bpay/sin/SinPaymentManage/SinPayManageVerify.ejs",
                    }))({
                        id: 'paymanagever',
                        data:retParams,
                        _hisClosever: function(e){
                            common.fullLayer.close(e);
                            $('#fullModeDialog').remove();
                            common.params.targetRouter = {
                                routerKey: "BocAbroad_SinPaymentManageList",
                                isExcuteInit: false,
                                excuteFun: null,
                                funArgs: null,
                                moduleArgs: []
                            }
                            common.triggerRouter(common.params.targetRouter);
                        },
                        ovpSinBaySchedVerify:function(e){
                            var _random = '';
                            //retParams.schedDetail._combinId = _combinId;
                            var params = {};
                            model.interaction({
                                method: routesUtil.method.BII.OverseaGetRandom,
                                params: {conversationId: _conversationId}
                            }, "BII", function(datas) {
                                _random = datas;
                                var bTest = false;
                                if(datas == null) {
                                    bTest = true;
                                    params = {cipher:false,challengeCode:_challengeCode, tokenClass: _tokenClass,conversationId:_conversationId};
                                }else{
                                    params = {
                                        cipher:true,
                                        challengeCode:_challengeCode,
                                        tokenClass:_tokenClass,
                                        cipherType: "1",
                                        randomeKey_S: _random,
                                        outputValueType: "2",
                                        passwordRegularExpression: "",
                                        passwordMinLength: "1",
                                        passwordMaxLength: "6",
                                        keyboardType: "1",
                                        conversationId: _conversationId
                                    };
                                }
                                retParams.schedDetail.tokenClass = _tokenClass;
                                SinPayManageDetail.onTokePassword(retParams,params,e,bTest);
                            },{errorFun: function(data11){
                                common.showMessage(data11.message);
                                return;
                            }});
                        }
                    })
                });
                var _titleDetail = common.strLong($.localeResource["BocAbroad_SinPaymentManageList"].ovs_bps_sbpm_paymentsubmit,SinPayManageDetail.cutCount);
                $("#sinPayVerTitleName").html(_titleDetail);
             });
            }, function(data){
            }, params1);
        });
    };
    /**
     * token
     */
    SinPayManageDetail.onTokePassword = function(retParams,pars,e,bTest){
        bocovsbridge.showEtokenPasswordPage(function(data){
            if(!bTest){
                retParams.schedDetail.otp = data.password;
                retParams.schedDetail.otp_rc = data.random;
                retParams.schedDetail.version = data.version;
                retParams.schedDetail.tokenType = data.type;
            }else{
                retParams.schedDetail.otp = data.password;
                retParams.schedDetail.otp_rc = "";
                retParams.schedDetail.tokenType = data.type;
            }
            if(!data.close){
                SinPayManageDetail.schedRecordMod(retParams,e);
            }
            }, function(data){
            }, pars);
    }
    /**
     * 确认修改
     */
    SinPayManageDetail.schedRecordMod = function(retParams,e){
        var _params = {};
        model.interaction({
            method: routesUtil.method.BII.OvcGetTokenId,
            params: {conversationId:_conversationId}
        }, "BII", function(data) {
            if(retParams.schedDetail.tokenClass == '1'){
                _params = {
                    exchangeSeq:retParams.schedDetail.exchangeSeq,
                    amount:Number(retParams.schedDetail.amount),
                    description:retParams.schedDetail.description,
                    assignedDate:retParams.schedDetail.schedDate,
                    accountId:retParams.schedDetail.accountId,
                    transMode:retParams.schedDetail.transMode,
                    conversationId:_conversationId,
                    payeeActno:retParams.schedDetail.payeeActno,
                    currencyCode:retParams.schedDetail.currencyCode,
                    billerCode:retParams.schedDetail.billerCode,
                    billerName:retParams.schedDetail.billerName,
                    billerAlias:retParams.schedDetail.billerAlias,
                    token:data.token,
                    Otp: retParams.schedDetail.otp,
                    Otp_RC: retParams.schedDetail.otp_rc,
                    state: "",
                    activ: retParams.schedDetail.version
                };
            }else if(retParams.schedDetail.tokenClass == '2'){
                _params = {
                    exchangeSeq:retParams.schedDetail.exchangeSeq,
                    amount:Number(retParams.schedDetail.amount),
                    description:retParams.schedDetail.description,
                    assignedDate:retParams.schedDetail.schedDate,
                    accountId:retParams.schedDetail.accountId,
                    transMode:retParams.schedDetail.transMode,
                    conversationId:_conversationId,
                    payeeActno:retParams.schedDetail.payeeActno,
                    currencyCode:retParams.schedDetail.currencyCode,
                    billerCode:retParams.schedDetail.billerCode,
                    billerName:retParams.schedDetail.billerName,
                    billerAlias:retParams.schedDetail.billerAlias,
                    token:data.token,
                    Tsp: retParams.schedDetail.otp,
                    Tsp_RC: retParams.schedDetail.otp_rc,
                    state: "",
                    activ: retParams.schedDetail.version
                };
            }else if(retParams.schedDetail.tokenClass == '3'){
                _params = {
                    exchangeSeq:retParams.schedDetail.exchangeSeq,
                    amount:Number(retParams.schedDetail.amount),
                    description:retParams.schedDetail.description,
                    assignedDate:retParams.schedDetail.schedDate,
                    accountId:retParams.schedDetail.accountId,
                    transMode:retParams.schedDetail.transMode,
                    conversationId:_conversationId,
                    payeeActno:retParams.schedDetail.payeeActno,
                    currencyCode:retParams.schedDetail.currencyCode,
                    billerCode:retParams.schedDetail.billerCode,
                    billerName:retParams.schedDetail.billerName,
                    billerAlias:retParams.schedDetail.billerAlias,
                    token:data.token,
                    Smc: retParams.schedDetail.otp,
                    Smc_RC: retParams.schedDetail.otp_rc,
                    state: "",
                    activ: retParams.schedDetail.version
                };
            }
            model.interaction({//修改交易纪录
                method: routesUtil.method.BII.OvpSinBpaySchedRecordMod,
                params:_params
            }, "BII", function(data) {
                SinPayManageDetail.getRetSuccess(retParams,e);
            });
        });

    }
    /**
     *提交请求成功后返回成功页面
     */
    SinPayManageDetail.getRetSuccess = function(retParams,e){
        common.fullLayer.show({
            view: new ($.extendCls(controller, {
                ejs: "../BocAbroad/views/bpay/sin/SinPaymentManage/SinPayManageSuccess.ejs",
            }))({
                id: 'paymanageok',
                data:retParams,
                _hisCloseOk: function(e){
                    common.fullLayer.close(e);
                    $('#fullModeDialog').remove();
                    common.params.targetRouter = {
                        routerKey: "BocAbroad_SinPaymentManageList",
                        isExcuteInit: false,
                        excuteFun: null,
                        funArgs: null,
                        moduleArgs: []
                    }
                    common.triggerRouter(common.params.targetRouter);
                },
                goHome:function(){
                    bocovsbridge.navigateToPage(function (params) {
                    }, function (params) {
                    }, 'home');
                }
            })
        });
    };

    /**
     * 日/月/年
     * @param retParams
     * @param e
     */
    SinPayManageDetail.getDdMmYyyy = function(str){
        var newStr = '';
        if(str != '' && str != null){
            for(var i = str.split('/').length-1;i >= 0;i--){
                if(i == 0){
                    newStr += str.split('/')[i];
                }else{
                    newStr += str.split('/')[i]+'/';
                }
            }
        }
        return newStr;
    };
    return SinPayManageDetail;
});