define(['zepto', 'common', 'viewcontroller', 'model', 'routesUtil','amountUtil', 'constant', 'checkForm'],
    function($, common, controller, model, routesUtil,amountUtil, constant, checkForm) {
    var mainView = $.extendCls(controller, {
        ejs: '../BocAbroad/views/transfer/frankfurt/FfTransMainView.ejs',
        payOutAvailBalance: 0,//可用余额
        transPayeeInfor:{},
        transPayerInfor:{},
        inCurrencyCode: "",
        outCurrencyCode: "",
        savePayee:false,

        clearType:"37",
        isCurrenyControl: false,
        conversationId: "",
        token: "",
        id:"",
        safetyFactorList:[],
        inAmount: "",
        transType: "1",
        challenge:false,
        _certDN:"",
        _plainData: "",
        transFee: "",
        transFeeCur: "",
        otp: "",
        currencyList:[],//转出账户币种
        rateList:[],
        local:"",
        chargeType: "",//费用承担方式
        chargeTypeList: ["OUR", "SHA", "BEN"],
        onSubError: function(err) {
        },
        serviceFormParams: function() {
            return {};
        },
        onLoadFinish:function(data){
            var _t = this;
            _t.type = common.currentRouterKey;
            document.addEventListener('deviceready', function(){_t.getTransData();}, false);
            $('#txtMoney').html($.localeResource[_t.type].ovs_bps_sbpm_40);
            $('#txtMoneyTitle').html($.localeResource[_t.type].ovs_bps_sbpm_5);
            $('#txtChargeType').html($.localeResource[_t.type].ovs_bps_sbpm_10);
            this.local = common.urlParams._locale ;

        },
        serviceFormParams:function(){

        },

        afterFormSubmit:function(data){

        },

        //费用承担方式
        onChargeType:function(){
            var _t = this;
            common.fullLayer.show({
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/ChargeTypeView.ejs"
                }))({
                    id: 'SinUseView',
                    data: _t.chargeTypeList,
                    sure: function(e) {
                        common.fullLayer.close(e);
                        var clickobj = $(e.target);
                        while (clickobj.length > 0 && !clickobj.hasClass('boc-list-item')) {
                            clickobj = clickobj.parent();
                        }
                        _t.chargeType  = clickobj.attr("use");
                        $('#txtChargeType').html(_t.chargeType);
                    },
                    onCancel: function(e){
                        common.fullLayer.close(e);
                    }
                })
            });
        },
        //输入金额
        onInputMoney:function(){
            var _t = this;
            common.fullLayer.show({
                classes:"halfLayer boc-popup",
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/SimpleInputMoneyView.ejs"
                }))({
                    id: 'SimpleInputMoneyView',
                    data: {
                        inCurrencyCode: constant.currency_sign_1_[_t.inCurrencyCode],
                        title: $.localeResource[_t.type].ovs_bps_sbpm_5

                    },
                    onSure: function(e) {
                        if(!checkForm.checkAll('.boc-simple-input')){//验证页面信息。
                            return;
                        };
                        if($('#in_amount').val() != ""){
                            _t.inAmount = Number($('#in_amount').val().trim()) + "";
                            $('#txtMoney').html(_t.local == "de_de"? _t.inAmount.toString().changeGERPartition() :
                            _t.inAmount.toString().formatMoney(_t.inCurrencyCode)
                            +"("+ constant.currency_sign_1_[_t.inCurrencyCode] +")");
                            //_t.amountType = "1";
                        }

                        if (_t.inCurrencyCode != _t.outCurrencyCode) {//不同币种显示查看牌照界面
                            $("#divRate").removeClass("hide").addClass("show");
                            $("#inMoneyCode").html($.localeResource[_t.type].ovs_bps_sbpm_17 +"("+ constant.currency_sign_1_[_t.outCurrencyCode] +")");
                        }
                        else
                            $("#divRate").removeClass("show").addClass("hide");
                        common.fullLayer.close(e);

                    },
                    onCancel:function(e){
                        common.fullLayer.close(e);
                    },
                    onLoadFinish:function(data){
                        if(_t.inAmount != "")
                           $('#in_amount').val(_t.inAmount);
                    }
                })
            });
        },

        //查看牌价
        onOvpExchangeRateQry:function() {
            var _t = this;
            //_t.showRateView();
            //return;
            //_t.inAmount = $('#txtMoney').val();
            if(_t.inAmount == ""){
                common.showMessage($.localeResource[_t.type].ovs_bps_sbpm_21);
                return;
            }
            var params = {fromAccountId: _t.transPayerInfor.accountId,
                        fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                        bankId: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountIbknum:  _t.transPayerInfor.accountIbknum,
                        outCurrencyCode: _t.outCurrencyCode,
                        //inCurrencyCode: _t.inCurrencyCode,
                        currency: _t.inCurrencyCode,
                        clearType: "37",
                        currencyCode: _t.inCurrencyCode,
                        //交易金额和转出金额
                        //amount: _t.inAmount
                        transAmount: _t.inAmount
            };
            model.interaction({
                method: routesUtil.method.BII.OvpExchangeRateQry,
                params: params
            }, "BII", function(data) {
                    for(var i = 0; i < data.rateList.length; i++){
                        data.rateList[i].soureCodeShow = constant.currency_sign_1_[data.rateList[i].soureCode];
                        data.rateList[i].targetCodeShow = constant.currency_sign_1_[data.rateList[i].targetCode];
                    }
                    _t.rateList = data.rateList;
                    _t.showRateView();
            });
        },

        //得到转账汇款数据
        getTransData: function(){
            var _t = this;
            var params = {};
            bocovsbridge.retrieveTransAcctInfo(function(data) {
                //得到数据赋值
                _t.payOutAvailBalance = data.payOutAvailBalance;
                _t.outCurrencyCode = data.payOutCurrency;
                _t.inCurrencyCode = data.payInCurrency;
                _t.transPayeeInfor = data.transPayeeInfor;
                _t.transPayerInfor = data.transPayerInfor;
                _t.savePayee = data.savePayee;


                //转出信息
               $("#txtOutAccountNum").html(_t.transPayerInfor.accountNumber);

                var str = constant.account_type_[_t.transPayerInfor.accountType];
                $("#txtAccountType").html('<em class="boc-change-type" style="float: left;">'+str+'</em>');
                if(_t.transPayerInfor.accountNickName != undefined && _t.transPayerInfor.accountNickName != null &&  _t.transPayerInfor.accountNickName != "")
                    $('#txtAccountType').html('<em class="boc-change-type" style="float: left;">'+str+'</em>'+'&nbsp;&nbsp;|&nbsp;&nbsp;' + _t.transPayerInfor.accountNickName);

                //$("#txtAccountType").html(constant.account_type_[_t.transPayerInfor.accountType]);
                //if(_t.transPayerInfor.accountNickName != undefined && _t.transPayerInfor.accountNickName != null &&  _t.transPayerInfor.accountNickName != "")
                //    $("#txtNickName").html("&nbsp;&nbsp;|&nbsp;&nbsp;" + _t.transPayerInfor.accountNickName);
                //else
                //    $("#txtNickName").html("");

                if(_t.transPayerInfor.accountType == "212" || _t.transPayerInfor.accountType == "213"){
                    $("#txtCurrencyCodeBg").removeClass("show").addClass("hide");
                    $("#txtCurrencyCode").removeClass("show").addClass("hide");
                }
                else{
                    $("#txtCurrencyCodeBg").removeClass("hide").addClass("show");
                    $("#txtCurrencyCode").removeClass("hide").addClass("show");
                }
                $("#txtCurrencyCode").html(constant.currency_sign_1_[_t.outCurrencyCode]);
                //alert('_t.payOutAvailBalance' + _t.payOutAvailBalance + '_t.outCurrencyCode' + _t.outCurrencyCode);
                if(_t.transPayerInfor.accountType != "212" && _t.transPayerInfor.accountType != "213"){
                    $("#txtCurrencyCodeBg").css("display", "block");
                }
                else {
                    $("#txtCurrencyCodeBg").css("display", "none");
                }
                $("#txtBalCurrencyCode").html("("+ constant.currency_sign_1_[_t.outCurrencyCode] +")");
                $("#txtBalMoney").html(_t.local? _t.payOutAvailBalance.toString().changeGERPartition() : _t.payOutAvailBalance.toString().formatMoney(_t.outCurrencyCode) );
                //$("#txtBalCurrencyCode").html("("+ constant.currency_sign_1_[_t.outCurrencyCode] +")");
                //转入信息
                $("#txtInAccountNum").html(_t.transPayeeInfor.accountNumber);
                $("#txtInAccountName").html(_t.transPayeeInfor.payeeEnName);
                //_t.ovpRemitCurrListQry();
            }, function(data){}, params);

        },
        //返回
        onBack:function(id){
            var params = "";
            if(id == undefined || id == "")
               params = "entrance";
            else
                params = id;
            bocovsbridge.navigateToPage(function(data){}, function(data){},params);
        },
        onBackUi:function(e){
            var params = "back";
            bocovsbridge.navigateToPage(function(data){}, function(data){},params);
        },
        onTokePassword:function(){
            var _t = this;

            var params = {cipher:false, challenge: _t.challenge, close: true};

            bocovsbridge.showEtokenPasswordPage(function(data){
                    _t.otp = data.password;
                    if(data.close == false)
                    _t.OvpEUT2Remit();

                }, function(data){

                },
                params);
        },
        //提交
        onSubmit:function(){

            var _t = this;
            //_t.showComfirm();
            //return;
            //_t.showResult({transFee: "111"});
            //return;
            if(_t.inAmount == ""){
                common.showMessage($.localeResource[_t.type].ovs_bps_sbpm_21);
                return;
            }

            if(_t.chargeType == "") {
                common.showMessage($.localeResource[_t.type].ovs_bps_sbpm_103);
                return;
            }

            _t.remark = $("#txtRemark").val().trim();
            _t.remark = _t.remark.replace(/\u2006/g, " ");
            if(!checkForm.checkAll('.boc-content')){//验证页面信息。
                return;
            };

            _t.ovcCreConversationWithToken();

        },
        destroy: function() {
            $.proxy(this.baseprototype.destroy, this)();
        },

        showComfirm: function(){
            var _t = this;
            common.fullLayer.show({
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/frankfurt/FfTransComfirmView.ejs"
                }))({
                    id: 'TransComfirmView',
                    data: {
                        outCurrencyCode: constant.currency_sign_1_[_t.outCurrencyCode],
                        inCurrencyCode: constant.currency_sign_1_[_t.inCurrencyCode],
                        inAmount: _t.local == "de_de"? _t.inAmount.toString().changeGERPartition() : _t.inAmount.toString().formatMoney(_t.inCurrencyCode) ,
                        transFee: _t.local == "de_de"? _t.transFee.toString().changeGERPartition() : _t.transFee.toString().formatMoney(_t.transFeeCur) ,
                        transFeeCurShow:  constant.currency_sign_1_[_t.transFeeCur] ,
                        payeeBankSwift: _t.transPayeeInfor.branchId,
                        payeeBankName: _t.transPayeeInfor.bankName,
                        payeeName: _t.transPayeeInfor.payeeEnName,
                        remark: _t.remark,
                        ibanNum: _t.transPayeeInfor.accountNumber,
                        outAccountNumber: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                        type:_t.type,
                        chargeType: _t.chargeType
                    },
                    sure: function(e) {
                        common.fullLayer.close(e);
                        _t.onTokePassword();

                    },
                    _hisClose:function(e){
                        common.fullLayer.close(e);
                    }
                })
            });
        },

        showResult: function(result){
            var _t = this;

            var str = "-";
            if(result.tradeRate != null && result.tradeRate.length > 0){
                var array = result.tradeRate[0].split('/');
                if(array.length == 3)
                    str = constant.currency_sign_1_[array[0]] + "/" + constant.currency_sign_1_[array[1]] + "/"+ array[2];
            }


            //成功回显示界面
            common.fullLayer.show({
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/frankfurt/FfTransResultView.ejs"
                }))({
                    id: 'TransResultView',
                    data: {
                        type:_t.type,
                        accountId: _t.transPayerInfor.accountId,
                        payeeName: _t.transPayeeInfor.payeeEnName,
                        payeeActno: _t.payeeActno,
                        inCurrencyCode: constant.currency_sign_1_[result.inCurrencyCode],
                        outCurrencyCode: constant.currency_sign_1_[result.outCurrencyCode],
                        inAmount: _t.local == "de_de"? _t.inAmount.toString().changeGERPartition() : _t.inAmount.toString().formatMoney(result.inCurrencyCode) ,
                        transTime: result.transTime,
                        transFee: _t.local == "de_de"? result.transFee.toString().changeGERPartition() : result.transFee.toString().formatMoney(result.transFeeCur) ,
                        transFeeCurShow:  constant.currency_sign_1_[result.transFeeCur] ,
                        statusShow: constant.trans_status_[result.status],
                        status:result.status,
                        transId: result.transId,
                        remark: _t.remark,
                        baseAmt: _t.rateList.length > 0 ? _t.rateList[0].baseAmt : "",
                        outAccountNumber: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                        ibanNum: _t.transPayeeInfor.accountNumber,
                        payeeBankName: _t.transPayeeInfor.bankName,
                        payeeBankSwift: _t.transPayeeInfor.branchId,
                        tradeRate:str,
                        chargeType: _t.chargeType

                    },
                    onBack: function(e) {
                        //common.fullLayer.close(e);
                        _t.onBack('home');
                    },
                    _hisClose:function(e){
                        common.fullLayer.close(e);
                        _t.onBack("tr_01");
                    }
                })
            }, "");
        },


        ///////////////////////////////接口方法//////////////////显示牌价
        showRateView:function(){
            var _t = this;
            common.fullLayer.show({
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/RateView.ejs"
                }))({
                    id: 'RateView',
                    data: {
                        type:_t.type,
                        rateList: _t.rateList
                    },
                    _hisClose:function(e){
                        common.fullLayer.close(e);
                    }

                })
            }, "");

        },//
        //转账币种控制 这个接口后面会合成一个不用了
        ovpCurrencyControl: function(){
            var _t = this;
            var params = {
                accountId: _t.transPayerInfor.accountId ,
                clearType: _t.clearType,
                inCurrencyCode: _t.inCurrencyCode,
                outCurrencyCode: _t.outCurrencyCode
            };
            model.interaction({
                method: routesUtil.method.BII.OvpCurrencyControl,
                params: params
            }, "BII", function(data) {
                _t.isCurrenyControl = true;
            });
        },
        //
        ovcCreConversationWithToken: function(){
            var _t = this;
            model.interaction({
                method: routesUtil.method.BII.OvcCreConversationWithToken,
                params: {}
            }, "BII", function(data) {
                _t.conversationId = data.conversationId;
                _t.token = data.token;
                _t.OvcGetSecurityFactor();
            });
        },
        OvcGetSecurityFactor: function(){
            var _t = this;
            model.interaction({
                method: routesUtil.method.BII.OvcGetSecurityFactor,
                params: {conversationId: _t.conversationId,
                         serviceId: "OB02A"}
            }, "BII", function(data) {
                _t.id = data._combinList[0].id + "";
                _t.safetyFactorList = data._combinList[0].safetyFactorList;
                _t.OvpEUT2RemitConfirm();
            });
        },
        OvpEUT2RemitConfirm: function(){
            var _t = this;
            var params = {
                conversationId: _t.conversationId,
                _combinId: _t.id,
                cleaningId: _t.clearType,
                fromAccountId:  _t.transPayerInfor.accountId,
                fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                //ibanNum: _t.transPayeeInfor.accountNumber,
                payeeActno: _t.transPayeeInfor.accountNumber,
                payeeBankSwift: _t.transPayeeInfor.branchId,
                inAmount: _t.inAmount,
                inCurrencyCode: _t.inCurrencyCode,
                outCurrencyCode: _t.outCurrencyCode,
                payeeBankName: _t.transPayeeInfor.bankName,
                payeeName: _t.transPayeeInfor.payeeEnName,
                remark: _t.remark,
                transType: _t.transType,
                savePayee: _t.savePayee + "",
                chargeType: _t.chargeType
                     };
            model.interaction({
                method: routesUtil.method.BII.OvpEUT2RemitConfirm,
                params: params
            }, "BII", function(data) {
//                _t._challengeCode = data._challengeCode;
                _t._certDN = data._certDN;
                _t._plainData = data._plainData;
                _t.transFee = data.transFee != undefined ? data.transFee + "" : "";
                _t.transFeeCur = data.transFeeCur != undefined ? data.transFeeCur : "";
                _t.showComfirm();
            });
        },

        //提交
        OvpEUT2Remit:function(){
            var _t = this;
            var params = {
                conversationId: _t.conversationId,
                Otp: _t.otp,
                _combinId: _t.id,
                cleaningId:_t.clearType,
                fromAccountId: _t.transPayerInfor.accountId ,
                fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                //ibanNum: _t.transPayeeInfor.accountNumber,
                payeeActno: _t.transPayeeInfor.accountNumber,
                inAmount: _t.inAmount,
                inCurrencyCode: _t.inCurrencyCode,
                outCurrencyCode: _t.outCurrencyCode,
                payeeBankName: _t.transPayeeInfor.bankName,
                payeeBankSwift: _t.transPayeeInfor.branchId,
                payeeName: _t.transPayeeInfor.payeeEnName,
                remark: _t.remark,
                token: _t.token,
                transFee: _t.transFee + "",
                transFeeCur: _t.transFeeCur,
                transType: _t.transType,
                savePayee: _t.savePayee + "",
                chargeType: _t.chargeType
                };
            model.interaction({
                method: routesUtil.method.BII.OvpEUT2Remit,
                params: params
            }, "BII", function(data) {
                _t.showResult(data);
            });
        },

        //查询目标币种
        OvpSDRemitCurrListQry: function(){
            var _t = this;
            var params = {
                accountId:  _t.transPayerInfor.accountId ,
                outCurrencyCode: _t.outCurrencyCode
            };
            model.interaction({
                method: routesUtil.method.BII.OvpTransToOthBankSEPA,
                params: params
            }, "BII", function(data) {
                _t.remitFlag = data.remitFlag;
                _t.currencyList = data.currencyList;

                //显示选择币种界面
                common.fullLayer.show({
                    classes:"halfLayer boc-popup",
                    view: new($.extendCls(controller, {
                        ejs: "../BocAbroad/views/transfer/ChoiceTransTypeView.ejs"
                    }))({
                        id: 'ChoiceMoneyView',
                        data:  _t.currencyList,
                        onChoice: function(e) {
                            common.fullLayer.close(e);
                            var clickobj = $(e.target);
                            while (clickobj.length > 0 && !clickobj.hasClass('companydiv')) {
                                clickobj = clickobj.parent();
                            }
                            //选择转入币种
                            _t.inCurrencyCode  = clickobj.attr("currencyCode");
                        }
                    })
                });
            });
        }
    });
    return common.Module.sub({
        _constructor: function() {
            this.mainView = null;
            $.proxy(this.baseprototype._constructor, this)();
        },


        init: function() {
            this.mainView = new mainView({
                id: common.currentRouterKey,
                el: "#loginViewWrap",
                eloper: "html",
                //参数
                data: {
                    type:common.currentRouterKey,
                }
            });
            this.mainView.load();
        },
        destroy: function() {
            this.mainView.destroy();
        }
    });
});