/**
 * 新增收款人
 * @namespace addPayee
 * @name addPayee
 * @requires zepto,common,amountUtil
 */
define('addPayee', ['zepto', 'common','viewcontroller','model','routesUtil','amountUtil','checkForm','pluginsUtil','dateUtil','constant'],
    function($, common,controller,model,routesUtil,amountUtil,checkForm,pluginsUtil,dateUtil,constant) {
        var AddPayee = {
        };
        AddPayee._cleaningId = 28;//新加坡上送清算类型28
        var _conversationId = "";
        var _token = "";
        AddPayee.cutCount = 25;
        AddPayee._serviceId = "OB050";//安全因子－服务码
        /**
         * 新增收款人－境内
         */
        AddPayee.getSinInnerOther = function(){
            /*common.fullLayer.show({
                view: new ($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/SinAddPayee.ejs",
                }))({
                    id: 'innerother',
                    data:'',
                })
            });*/
            var _title = common.strLong($.localeResource["BocAbroad_SinAddPayee"].ovs_tr_spm_newpayee,AddPayee.cutCount);
            $("#addPayee").html(_title);
        }

        /**
         *选择银行-sin
         */
        AddPayee.getBankList = function(e){
            model.interaction({//修改交易纪录
                method: routesUtil.method.BII.OvpBankQryByClear,
                params: {
                    cleaningId:AddPayee._cleaningId
                }
            }, "BII", function(data) {
                var banklist = data.bankList;
                common.fullLayer.show({
                    view: new ($.extendCls(controller, {
                        ejs: "../BocAbroad/views/transfer/SinBankList.ejs",
                    }))({
                        id: 'banklist1',
                        data:banklist,
                        _hisBankClose: function(e){
                            common.fullLayer.close(e);
                        },
                        optionBank:function(e){
                            var bankName = e.currentTarget.children[0].id;
                            var bankCode = e.currentTarget.children[1].id;
                            common.fullLayer.close(e);
                            $("#bankName").text(bankName);
                            $("#bankCode").val(bankCode);
                        }
                    })
                },true);
                var _title = common.strLong($.localeResource["BocAbroad_SinAddPayee"].ovs_tr_spm_selectbank,AddPayee.cutCount);
                $("#optionBankName").html(_title);
            });

        }

        /**
         * 提交收款人
         */
        AddPayee.getSavePayee = function(e,params1){
            model.interaction({//修改交易纪录
                method: routesUtil.method.BII.OvcCreConversationWithToken,
                params: {}
            }, "BII", function(data) {
                _conversationId = data.conversationId;
                _token = data.token;
                model.interaction({
                    method: routesUtil.method.BII.OvcGetSecurityFactor,
                    params: {
                        conversationId:_conversationId,
                        serviceId:AddPayee._serviceId
                    }
                }, "BII", function(data0) {
                    var typeList = [];
                    var params2 = {};
                    for(var i = 0; i < data0._combinList.length; i ++){
                        typeList.push(data0._combinList[i].id + "");
                    }
                    params2['typeList'] = typeList;
                    bocovsbridge.showChoiceEtokenPasswordPage(function(data2){
                    model.interaction({//预保存
                        method: routesUtil.method.BII.OvpTransSavePayeeConfirm,
                        params: {
                            conversationId:_conversationId,
                            payeeAcctType:AddPayee._cleaningId + "",
                            payeeName:params1.payeeName,
                            payeeActno:params1.payeeActno,
                            payeeBankSwift:params1.bankName,
                            payeeBankName:params1.bankCode,
                            _combinId:data2.type
                        }
                    }, "BII", function(data1) {
                        model.interaction({
                            method: routesUtil.method.BII.OverseaGetRandom,
                            params: {conversationId: _conversationId}
                        }, "BII", function(datas) {
                            AddPayee.getRandom(params1,datas,data1,data2.type);
                        });
                    });
                    }, function(data){
                    }, params2);
                });
            });
        }

        AddPayee.getRandom = function(params1,_random,data,cbid){
            var bTest = false;
            var params = {};
            var _tokenClass = [];
            for(var i = 0; i < data.factorList.length; i++){
                if(data.factorList[i].field.name == "Otp")
                    _tokenClass.push("1");//动态口令 1代
                else if(data.factorList[i].field.name == "Smc")
                    _tokenClass.push("3");//// 短信验证码
                else if(data.factorList[i].field.name == "Tsp")
                    _tokenClass.push("2"); //动态口令 2代
            }
            var _challengeCode = data._challengeCode == null ? false : data._challengeCode;
            if(_random == null){
                bTest = true;
                params = {cipher:false,challengeCode:_challengeCode, tokenClass: _tokenClass,conversationId:_conversationId};
            }else{
                params = {
                    cipher:true,
                    challengeCode:_challengeCode,
                    tokenClass:_tokenClass,
                    cipherType: "1",
                    randomeKey_S: _random,
                    outputValueType: "2",
                    passwordRegularExpression: "",
                    passwordMinLength: "1",
                    passwordMaxLength: "6",
                    keyboardType: "1",
                    conversationId: _conversationId
                };
            }
            //弹出token
            var otp = '';
            var otp_rc = '';
            var version = '';
            var tokenType = '';
            bocovsbridge.showEtokenPasswordPage(function(data1){
                    if(!bTest){
                        otp = data1.password;
                        otp_rc = data1.random;
                        version = data1.version;
                        tokenType = data1.type;
                    }
                    else{
                        otp = data1.password;
                        otp_rc = "";
                        tokenType = data1.type;
                    }
                    if(!data1.close){
                        model.interaction({//获取token
                            method: routesUtil.method.BII.OvcGetTokenId,
                            params: {conversationId:_conversationId}
                        }, "BII", function(data) {
                            var params = {};
                            if(_tokenClass == '1'){
                                params = {
                                    Otp: otp,
                                    Otp_RC: otp_rc,
                                    activ: version,
                                    conversationId:_conversationId,
                                    payeeAcctType:AddPayee._cleaningId + "",
                                    payeeActno:params1.payeeActno,
                                    token:data.token,
                                    _combinId: cbid+"",
                                    payeeBankName:params1.bankName,
                                    payeeBankSwift:params1.bankCode,
                                    payeeName:params1.payeeName
                                }
                            }else if(_tokenClass == '2'){
                                params = {
                                    Tsp: otp,
                                    Tsp_RC: otp_rc,
                                    activ: version,
                                    conversationId:_conversationId,
                                    payeeAcctType:AddPayee._cleaningId + "",
                                    payeeActno:params1.payeeActno,
                                    token:data.token,
                                    _combinId: cbid+"",
                                    payeeBankName:params1.bankName,
                                    payeeBankSwift:params1.bankCode,
                                    payeeName:params1.payeeName
                                }
                            }else if(_tokenClass == '3'){
                                params = {
                                    Smc: otp,
                                    Smc_RC: otp_rc,
                                    activ: version,
                                    conversationId:_conversationId,
                                    payeeAcctType:AddPayee._cleaningId + "",
                                    payeeActno:params1.payeeActno,
                                    token:data.token,
                                    _combinId: cbid+"",
                                    payeeBankName:params1.bankName,
                                    payeeBankSwift:params1.bankCode,
                                    payeeName:params1.payeeName
                                }
                            }
                            model.interaction({//保存
                                method: routesUtil.method.BII.OvpTransSavePayee,
                                params:params
                            }, "BII", function(data) {
                                bocovsbridge.navigateToPage(function (par) {
                                }, function (par) {
                                }, 'tr_pm_01');
                            },{errFun: function(){//新增失败
                                common.params.targetRouter = {
                                    routerKey: "BocAbroad_SinAddPayee",
                                    isExcuteInit: false,
                                    excuteFun: null,
                                    funArgs: null,
                                    moduleArgs: []
                                }
                                common.triggerRouter(common.params.targetRouter);
                            }});
                        });
                    }
                }, function(data0){
                },
                params);
        }
        return AddPayee;
});