define(['zepto', 'common', 'viewcontroller', 'model', 'routesUtil','amountUtil', 'constant', 'checkForm'],
    function($, common, controller, model, routesUtil,amountUtil, constant, checkForm) {
    var mainView = $.extendCls(controller, {
        ejs: '../BocAbroad/views/transfer/TransMainView.ejs',
        payOutAvailBalance: 0,//可用余额
        savePayee:false,
        transPayeeInfor:{},   //转入
        transPayerInfor:{},  //转出
        inCurrencyCode: "",
        outCurrencyCode: "",
        isCurrenyControl: false,
        clearingTypeIdList: [],//28-MEPS 29-GIRO 35-FAST //银行清算类型列表
        clearingTypeIdListDic: {28:"MEPS", 29:"GIRO", 35:"FAST"},
        conversationId: "",
        token: "",
        id: "",
        //safetyFactorList: "",
        cleaningId: "",//交易类型
        transType: "",//清算类型
        remittanceInfo: "",
        inAmount:"",
        tokenClass: [],
        tokenType: "1",//默认是一代Key
        onSubError: function(err) {
        },
        serviceFormParams: function() {
            return {};
        },
        //返回的列表数据
        onLoadFinish: function() {
            var _t = this;
            document.addEventListener('deviceready', function(){_t.getTransData();}, false);
            $('#txtMoney').html($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_40);       //请输入
            $('#txtMoneyTitle').html($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_8);  //转出金额
            //$('txtRemark').attr('maxLength', '35');
            $('#showRate').addClass('hide');


        },
        //转账方式
        onTransType:function(){
            var _t = this;
            if(_t.clearingTypeIdList.length == 0){
                _t.ovpCleaningIdForSGPQry();//查询收款银行清算类型
                return;
            }


            common.fullLayer.show({
                classes:"halfLayer boc-popup",
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/SinChoiceTransTypeView.ejs"
                }))({
                    id: 'SinChoiceTransTypeView',
                    data: {clearingTypeIdList: _t.clearingTypeIdList, clearingTypeIdListDic: _t.clearingTypeIdListDic},
                    sure: function(e) {
                        common.fullLayer.close(e);
                        var clickobj = $(e.target);
                        while (clickobj.length > 0 && !clickobj.hasClass('boc-popup-a')) {
                            clickobj = clickobj.parent();
                        }
                        _t.cleaningId  = clickobj.attr("transType");
            // 根据不同的清算类型上送不同的交易类型 一一对应 28--〉0    29-->1     35-->2
                       if(_t.cleaningId == "28"){
                            _t.transType = "0";
                        }
                        else if(_t.cleaningId == "29"){
                            _t.transType = "1";
                        }
                        else if(_t.cleaningId == "35"){
                            _t.transType = "2";
                        }
                            $('#txtTransType').html(_t.clearingTypeIdListDic[_t.cleaningId]);

                        if(_t.cleaningId == "35" || _t.cleaningId == "29"){
                            $('#useDiv').removeClass('hide').addClass('show');
                            $('#txtUse').html($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_10);
                            _t.remittanceInfo = "";
                        }
                        else{
                            $('#useDiv').removeClass('show').addClass('hide');
                        }

                    },
                })
            });

        },
        //转账用途
        onTransUse:function(){
            var _t = this;
            common.fullLayer.show({
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/SinUseView.ejs"
                }))({
                    id: 'SinUseView',
                    data: constant.sin_use_id_,
                    sure: function(e) {
                        common.fullLayer.close(e);
                        var clickobj = $(e.target);
                        while (clickobj.length > 0 && !clickobj.hasClass('boc-list-item')) {
                            clickobj = clickobj.parent();
                        }
                        _t.remittanceInfo  = clickobj.attr("use");
                        $('#txtUse').html(_t.remittanceInfo);

                    },
                    onCancel: function(e){
                        common.fullLayer.close(e);
                    }
                })
            });

        },
        destroy: function() {
            $.proxy(this.baseprototype.destroy, this)();
        },

        //输入金额
        onInputMoney:function(){
            var _t = this;
            common.fullLayer.show({
                classes:"halfLayer boc-popup",
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/SimpleInputMoneyView.ejs"
                }))({
                    id: 'SimpleInputMoneyView',
                    data: {
                        inCurrencyCode: constant.currency_sign_1_[_t.outCurrencyCode],
                        title: $.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_8,
                        inAmount: _t.inAmount,
                    },
                    onSure: function(e) {
                        if(!checkForm.checkAll('.boc-simple-input')){//验证页面信息。
                            return;
                        };
                        if($('#in_amount').val() != ""){
                            _t.inAmount = Number($('#in_amount').val().trim()) + "";
                            $('#txtMoney').html(_t.inAmount.toString().formatMoney(_t.outCurrencyCode) + "("+ constant.currency_sign_1_[_t.outCurrencyCode] +")");
                            //_t.amountType = "1";
                        }

                        //if(_t.inCurrencyCode != _t.outCurrencyCode) {//不同币种显示查看牌照界面
                        //    $("#inMoneyCode").css("display","block");
                        //    $("#divRate").removeClass("hide");
                        //    $("#showRate").css("display", "none");
                        //    $("#inMoneyCode").html($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_17 +"("+ constant.currency_sign_1_[_t.outCurrencyCode] +")");
                        //}
                        //else{
                        //    $("#inMoneyCode").removeClass("show").addClass("hide");
                        //    $("#divRate").addClass('hide');
                        //    $("#showRate").removeClass("hide");
                        //}

                        common.fullLayer.close(e);

                    },
                    onCancel:function(e){
                        common.fullLayer.close(e);
                    },
                    onLoadFinish:function(data){
                        if(_t.inAmount != "")
                            $('#in_amount').val(_t.inAmount);
                    }
                })
            });
        },

        //获取账户信息
        getTransData:function(){
            var _t = this;
            var params = {};
            //$("#divRate").removeClass("hide").addClass("show");
            //$("#inMoneyCode").html($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_17);
            //_t.outCurrencyCode = "018";
            //_t.payOutAvailBalance = "910355972.81";
            //$("#txtCurrencyCode").html(constant.currency_sign_1_[_t.outCurrencyCode]);
            //$("#txtBalMoney").html(_t.payOutAvailBalance.toString().formatMoney(_t.outCurrencyCode));
              bocovsbridge.retrieveTransAcctInfo(function(data){
                //得到数据赋值
                _t.payOutAvailBalance =  data.payOutAvailBalance;  //可用余额
                _t.outCurrencyCode = data.payOutCurrency;  //转出币种
                _t.inCurrencyCode = data.payInCurrency;    //转入币种
                _t.transPayeeInfor = data.transPayeeInfor;
                _t.transPayerInfor = data.transPayerInfor;
                _t.savePayee = data.savePayee;　//是否保存收款人标识

                //if(_t.inCurrencyCode != _t.outCurrencyCode) {//不同币种显示查看牌照界面
                //    $("#divRate").removeClass("hide").addClass("show");
                //    $("#inMoneyCode").html($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_17 +"("+ constant.currency_sign_1_[_t.outCurrencyCode] +")");
                //}
                //else
                //    $("#divRate").removeClass("show").addClass("hide");

                //$("#txtInCurrencyCode").html("("+ constant.currency_sign_1_[_t.inCurrencyCode] +")");

                //转出信息
                 $("#txtOutAccountNum").html(_t.transPayerInfor.accountNumber);

                var str = constant.account_type_[_t.transPayerInfor.accountType];
                $("#txtAccountType").html('<em class="boc-change-type" style="float: left;">'+str+'</em>');
                if(_t.transPayerInfor.accountNickName != undefined && _t.transPayerInfor.accountNickName != null &&  _t.transPayerInfor.accountNickName != "")
                    $('#txtAccountType').html('<em class="boc-change-type" style="float: left;">'+str+'</em>'+'&nbsp;&nbsp;|&nbsp;&nbsp;' + _t.transPayerInfor.accountNickName);

                //$("#txtAccountType").html(constant.account_type_[_t.transPayerInfor.accountType]);
                //if(_t.transPayerInfor.accountNickName != undefined && _t.transPayerInfor.accountNickName != null &&  _t.transPayerInfor.accountNickName != "")
                //    $("#txtNickName").html("&nbsp;&nbsp;|&nbsp;&nbsp;" + _t.transPayerInfor.accountNickName);
                //else
                //    $("#txtNickName").html("");
                  //212 -->活期一本通      213 --〉借记卡      214-->  信用卡
                if(_t.transPayerInfor.accountType == "212" || _t.transPayerInfor.accountType == "213"){
                    $("#txtCurrencyCodeBg").removeClass("show").addClass("hide");
                    $("#txtCurrencyCode").removeClass("show").addClass("hide");
                }
                else{
                    $("#txtCurrencyCodeBg").removeClass("hide").addClass("show");
                    $("#txtCurrencyCode").removeClass("hide").addClass("show");
                }

                //alert("aaaaaaaaaaaaa" + _t.outCurrencyCode + "bbbbb"  + _t.payOutAvailBalance);
                $("#txtCurrencyCode").html(constant.currency_sign_1_[_t.outCurrencyCode]);
                $("#txtBalMoney").html(_t.payOutAvailBalance.toString().formatMoney(_t.outCurrencyCode));
                if(_t.transPayerInfor.accountType != "212" && _t.transPayerInfor.accountType != "213"){
                    $("#txtCurrencyCodeBg").css("display", "block");
                }
                else {
                    $("#txtCurrencyCodeBg").css("display", "none");
                }
                $("#txtBalCurrencyCode").html("("+ constant.currency_sign_1_[_t.outCurrencyCode] +")");
                //转入信息
                $("#txtInAccountNum").html(_t.transPayeeInfor.accountNumber);
                $("#txtInAccountName").html(_t.transPayeeInfor.payeeEnName);

                  _t.ovpCleaningIdForSGPQry();

                 //return outNum;
            }, function(data){}, params);
        },

        //提交
        onSubmit:function(){
            var _t = this;
            if(_t.inAmount == ""){
                common.showMessage($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_21);
                return;
            }

            _t.remark = $("#txtRemark").val().trim();
            //_t.inAmount = $("#txtMoney").val();
            if(!checkForm.checkAll('.boc-content')){//验证页面信息。
                return;
            };


            if(_t.transType == ""){
                common.showMessage($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_38);
                return;
            }

            if(_t.transType != "0" && _t.remittanceInfo == ""){
                common.showMessage($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_39);
                return;
            }

            //fast 判断50000限制
            if(_t.cleaningId == "35"){
                if(Number(_t.inAmount) > 50000 || Number(_t.inAmount) < 1){
                    common.showMessage($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_53);
                    return;
                }

            }
            //alert("_t.inCurrencyCode" + _t.inCurrencyCode + "_t.outCurrencyCode" + _t.outCurrencyCode + "_t.inAmount " + _t.inAmount  + "_t.payOutAvailBalance" + _t.payOutAvailBalance);
            //同币种判断可用余额提示信息
            if(_t.inCurrencyCode == _t.outCurrencyCode && Number(_t.inAmount) > Number(_t.payOutAvailBalance)){
                common.showAlert($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_37, [window.app.nls.l_comfirm, window.app.nls.l_cancel], [$.proxy(_t.OvpSDCurrencyControl, _t), function(){}]);
            }
            else{
                _t.OvpSDCurrencyControl();
            }

           // _t.ovcCreConversationWithToken();
        },

        ///////////////////////////////接口方法//////////////////
        //转账币种控制
        OvpSDCurrencyControl: function(){
            var _t = this;
            var params = {
                accountId:_t.transPayerInfor.accountId,
                clearType: _t.cleaningId,
                inCurrencyCode: _t.inCurrencyCode,
                outCurrencyCode: _t.outCurrencyCode
            }
            model.interaction({
                method: routesUtil.method.BII.OvpSDCurrencyControl,
                params: params
            }, "BII", function(data) {
                _t.isCurrenyControl = true;
                _t.ovcCreConversationWithToken();
            });
        },
        //查询收款银行清算类型
        ovpCleaningIdForSGPQry: function(){
            var _t = this;
            model.interaction({
                method: routesUtil.method.BII.OvpCleaningIdForSGPQry,
                params: {payeeBankSwift: _t.transPayeeInfor.branchId,
                    fromActType:_t.transPayerInfor.accountType
                }
            }, "BII", function(data) {
                _t.clearingTypeIdList = data.clearingTypeIdList;
                //若传过来的只有一种转账方式那么默认显示为“FAST”
                if(_t.clearingTypeIdList.length == 1 && _t.clearingTypeIdList[0] == '35'){
                    if(_t.clearingTypeIdList[0] == "35"){
                        _t.transType = "2";     //交易类型    “FAST”
                        _t.cleaningId = "35";
                    }
                    $('#txtTransType').html( _t.clearingTypeIdListDic[_t.clearingTypeIdList[0]]);
                    $('#useDiv').removeClass('hide').addClass('show');
                }
            });

        },
        //
        ovcCreConversationWithToken: function(){
            var _t = this;
            model.interaction({
                method: routesUtil.method.BII.OvcCreConversationWithToken,
                params: {}
            }, "BII", function(data) {
                _t.conversationId = data.conversationId;
                _t.token = data.token;//防重机制
                _t.ovcGetTokenId();
                //_t.psnGetSecurityFactor();
            });
        },

        psnGetSecurityFactor: function(){
            var _t = this;
            model.interaction({
                method: routesUtil.method.BII.PsnGetSecurityFactor,
                params: {conversationId: _t.conversationId, serviceId: "OB034"}
            }, "BII", function(data) {
                //_t.onShowChoiceEtokenPasswordPage(data);
                //_t.id = data._combinList[0].id + "";
                //_t.safetyFactorList = data._combinList[0].safetyFactorList;
                //_t.id = data.id + "";
                //_t.safetyFactorList = data.safetyFactorList;
                _t.ovcGetTokenId();
            });
        },

        ovcGetTokenId:function(){
            var _t = this;
            model.interaction({
                method: routesUtil.method.BII.OvcGetTokenId,
                params: {conversationId:_t.conversationId}
            }, "BII", function(data) {
                _t.token = data.token;
                _t.ovpTransToOtherBankForSGPPre();
            });
        },
   //他行转帐用户初始化
        ovpTransToOtherBankForSGPPre:function(){
            var _t = this;
            var params = {
                conversationId: _t.conversationId,
                //_combinId: _t.id,
                cleaningId: _t.cleaningId,
                fromAccountId: _t.transPayerInfor.accountId,
                fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                payeeActno: _t.transPayeeInfor.accountNumber,
                inputAmount: _t.inAmount,
                inCurrencyCode: _t.inCurrencyCode,
                outCurrencyCode: _t.outCurrencyCode,
                payeeBankName: _t.transPayeeInfor.bankName,
                payeeName: _t.transPayeeInfor.payeeEnName,
                payeeBankNum: _t.transPayeeInfor.branchId,
                payeeAddress: "",
                remark: _t.remark,
                transType: _t.transType,
                amountType: "0",
                //token: _t.token,
                token: "",
            };
            model.interaction({
                method: routesUtil.method.BII.OvpTransToOtherBankForSGPPre,
                params: params
            }, "BII", function(data) {
                //_t.id = data._combinList[0].id + "";
                //_t.safetyFactorList = data._combinList[0].safetyFactorList;
                _t.onShowChoiceEtokenPasswordPage(data);
                //_t.ovpTransToOtherBankForSGPConfirm();
            });

        },

        onShowChoiceEtokenPasswordPage: function(data){
            var _t = this;
            var params = {};
            var typeList = [];
            for(var i = 0; i < data._combinList.length; i ++){
                typeList.push(data._combinList[i].id + "");
            }
            params['typeList'] = typeList;
            bocovsbridge.showChoiceEtokenPasswordPage(function(data){
                    if(data.close == false){
                        _t.id = data.type;
                        _t.ovpTransToOtherBankForSGPConfirm();
                        //_t.ovcGetTokenId();
                    }

                }, function(data){

                },
                params);
        },
        //他行账户转账(新加坡)预交易
        ovpTransToOtherBankForSGPConfirm:function(){
            var _t = this;
            var params = {
                conversationId: _t.conversationId,
                _combinId: _t.id,
                cleaningId: _t.cleaningId, //清算类型
                fromAccountId: _t.transPayerInfor.accountId,  //转出账号标识
                fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                payeeActno: _t.transPayeeInfor.accountNumber,//收款帐号
                inputAmount: _t.inAmount,
                inCurrencyCode: _t.inCurrencyCode, //转入币种
                outCurrencyCode: _t.outCurrencyCode,　//转出币种
                payeeBankName: _t.transPayeeInfor.bankName,
                payeeName: _t.transPayeeInfor.payeeEnName,  //收款人姓名
                payeeBankNum: _t.transPayeeInfor.branchId,   //转入账户银行号
                payeeAddress: "",
                remark: _t.remark,  //摘要
                transType: _t.transType,  //交易类型
                amountType: "0",  //金额类型
                //token: _t.token,
                token: "",
                orgidt: "",  //网点号，仅GIRO收款人上送
                remittanceInfo: constant.sin_use_dict[_t.remittanceInfo],  //汇款用途
                savePayee: _t.savePayee + "",
            };

            model.interaction({
                method: routesUtil.method.BII.OvpTransToOtherBankForSGPConfirm,
                params: params
            }, "BII", function(data) {
                _t._challengeCode = data._challengeCode == null ? false : data._challengeCode;//二代令牌挑战码
                for(var i = 0; i < data.factorList.length; i++){
                    if(data.factorList[i].field.name == "Otp")
                        _t.tokenClass.push("1");//动态口令 1代
                    else if(data.factorList[i].field.name == "Smc")
                        _t.tokenClass.push("3");// 短信验证码
                    else if(data.factorList[i].field.name == "Tsp")
                        _t.tokenClass.push("2"); //动态口令 2代
                }
                //_t.tokenClass = data.factorList[0].field.name == "Otp" ? "1":"2";
                _t._certDN = data._certDN;
                _t._plainData = data._plainData;
                _t.transFee = data.transFee;  //试算费用
                //_t.transFee=null;
                _t.transFeeCur = data.transFeeCur != null ? data.transFeeCur : "";  //试算币种
                _t.showComfirm();
            });
        },
    //确认页
        showComfirm:function(){
            var _t = this;

            //alert("_t.transFeeCur" + _t.transFeeCur);
            common.fullLayer.show({
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/TransComfirmView.ejs"
                }))({
                    id: 'TransComfirmView',
                    data: {
                        outCurrencyCode: constant.currency_sign_1_[_t.outCurrencyCode],
                        inCurrencyCode: constant.currency_sign_1_[_t.inCurrencyCode],
                        inAmount: _t.inAmount.toString().formatMoney(_t.outCurrencyCode),
                        transFee: (_t.transFee=== null || _t.transFee ==="")? "-" : _t.transFee.toString().formatMoney(_t.transFeeCur)+" "+constant.currency_sign_1_[_t.transFeeCur],
                        //transFee:_t.transFee.toString().formatMoney(_t.transFeeCur),

                        transFeeCurShow:constant.currency_sign_1_[_t.transFeeCur] ,
                        payeeBankSwift: _t.transPayeeInfor.branchId, //收款银行行号
                        payeeBankName: _t.transPayeeInfor.bankName,
                        payeeName: _t.transPayeeInfor.payeeEnName,
                        remark: _t.remark,
                       // ibanNum: _t.transPayeeInfor.accountNumber.toString().replace(/(\d{4})/g,"$1"+" "),
                        ibanNum:_t.transPayeeInfor.accountNumber.toString().beautyDisplay(),
                        transType:_t.transType,
                        cleaningId: _t.cleaningId, //清算类型
                        remittanceInfo:_t.remittanceInfo,
                      //  outAccountNumber:_t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber.toString().replace(/(\d{4})/g,"$1"+" "):  _t.transPayerInfor.accountNumber.toString().replace(/(\d{4})/g,"$1"+" "),
                        outAccountNumber:_t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber.toString().beautyDisplay():  _t.transPayerInfor.accountNumber.toString().beautyDisplay(),
                        type:"sgd",
                        transpayeefo:_t.transPayerInfor.accountType,
                        transTypeInfo: _t.clearingTypeIdListDic[_t.cleaningId],
                    },
                    sure: function(e) {
                        common.fullLayer.close(e);
                        model.interaction({
                            method: routesUtil.method.BII.OverseaGetRandom,
                            params: {conversationId: _t.conversationId}
                        }, "BII", function(data) {
                            _t.onTokePassword(data);
                        });
                        //_t.onTokePassword();

                    },
                    _hisClose:function(e){
                        common.fullLayer.close(e);
                    }
                })
            });
        },

        onTokePassword:function(data){

            var _t = this;
            var params = {};

            if(data == null){
                _t.bTest = true;
                params = {cipher:false,challengeCode:_t._challengeCode, tokenClass: _t.tokenClass, conversationId: _t.conversationId};
            }
            else{

                params = {
                    cipher:true,
                    challengeCode:_t._challengeCode,
                    tokenClass:_t.tokenClass,
                    cipherType: "1",
                    randomeKey_S: data,
                    outputValueType: "2",
                    passwordRegularExpression: "",
                    passwordMinLength: "1",
                    passwordMaxLength: "6",
                    keyboardType: "1",
                    conversationId: _t.conversationId

                };
                _t.bTest = false;
            }


           // var params = {cipher:false, challenge: _t._challengeCode, tokenClass: _t.tokenClass};

            bocovsbridge.showEtokenPasswordPage(function(data){

                    if(!_t.bTest){

                        _t.otp = data.password;
                        _t.otp_rc = data.random;
                        _t.version = data.version;
                        _t.tokenType = data.type;
                    }
                    else{

                        _t.otp = data.password;
                        _t.otp_rc = "";
                        _t.tokenType = data.type;
                    }
                    if(data.close == false)
                        _t.ovpTransToOtherBankForSGP();

                }, function(data){

                },
                params);
        },
    //他行账户转账
        ovpTransToOtherBankForSGP:function(){
            var _t = this;
			var params = {};
            if(_t.tokenType == "1"){
                params = {
                    conversationId: _t.conversationId,
                    Otp: _t.otp,
                    state :"",
                    Otp_RC: _t.otp_rc,
                    activ: _t.version,
                    _combinId: _t.id,
                    amountType: "0",
                    cleaningId:_t.cleaningId,
                    fromAccountId: _t.transPayerInfor.accountId,
                    fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                    payeeActno: _t.transPayeeInfor.accountNumber,
                    inputAmount: _t.inAmount,
                    inCurrencyCode: _t.inCurrencyCode,
                    outCurrencyCode: _t.outCurrencyCode,
                    payeeBankName: _t.transPayeeInfor.bankName,
                    payeeBankNum: _t.transPayeeInfor.branchId,
                    payeeName: _t.transPayeeInfor.payeeEnName,
                    remark: _t.remark,
                    token: _t.token,
                    transFee: _t.transFee,
                    transFeeCur: _t.transFeeCur,
                    transType: _t.transType,
                    orgidt: "",
                    payeeAddress: "",
                    remittanceInfo: constant.sin_use_dict[_t.remittanceInfo],
                    savePayee: _t.savePayee + "",
                };
			}
			else  if(_t.tokenType == "2"){
                params = {
                    conversationId: _t.conversationId,
                    Tsp: _t.otp,
                    Tsp_RC: _t.otp_rc,
                    state: "",
                    activ: _t.version,
                    _combinId: _t.id,
                    amountType: "0",
                    cleaningId: _t.cleaningId,
                    fromAccountId: _t.transPayerInfor.accountId,
                    fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                    payeeActno: _t.transPayeeInfor.accountNumber,
                    inputAmount: _t.inAmount,
                    inCurrencyCode: _t.inCurrencyCode,
                    outCurrencyCode: _t.outCurrencyCode,
                    payeeBankName: _t.transPayeeInfor.bankName,
                    payeeBankNum: _t.transPayeeInfor.branchId,
                    payeeName: _t.transPayeeInfor.payeeEnName,
                    remark: _t.remark,
                    token: _t.token,
                    transFee: _t.transFee,
                    transFeeCur: _t.transFeeCur,
                    transType: _t.transType,
                    orgidt: "",
                    payeeAddress: "",
                    remittanceInfo: constant.sin_use_dict[_t.remittanceInfo],
                    savePayee: _t.savePayee + "",
                }
            }
            else if(_t.tokenType == "3"){
                params = {
                    conversationId: _t.conversationId,
                    Smc: _t.otp,
                    Smc_RC: _t.otp_rc,
                    state: "",
                    activ: _t.version,
                    _combinId: _t.id,
                    amountType: "0",
                    cleaningId: _t.cleaningId,
                    fromAccountId: _t.transPayerInfor.accountId,
                    fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                    payeeActno: _t.transPayeeInfor.accountNumber,
                    inputAmount: _t.inAmount,
                    inCurrencyCode: _t.inCurrencyCode,
                    outCurrencyCode: _t.outCurrencyCode,
                    payeeBankName: _t.transPayeeInfor.bankName,
                    payeeBankNum: _t.transPayeeInfor.branchId,
                    payeeName: _t.transPayeeInfor.payeeEnName,
                    remark: _t.remark,
                    token: _t.token,
                    transFee: _t.transFee,
                    transFeeCur: _t.transFeeCur,
                    transType: _t.transType,
                    orgidt: "",
                    payeeAddress: "",
                    remittanceInfo: constant.sin_use_dict[_t.remittanceInfo],
                    savePayee: _t.savePayee + "",
                }
            }
            model.interaction({
                method: routesUtil.method.BII.OvpTransToOtherBankForSGP,
                params: params
            }, "BII", function(data) {
                _t.showResult(data);
            });
        },
        //结果页
        showResult: function(result){
            var _t = this;
            var str = "-";
            if(result.tradeRate != null && result.tradeRate.length > 0){　　//交易牌价
                var array = result.tradeRate[0].split('/');
                if(array.length == 3)
                    str = constant.currency_sign_1_[array[0]] + "/" + constant.currency_sign_1_[array[1]] + "/"+ array[2];
            }
            //alert("result.transFeeCur" + result.transFeeCur);
            common.fullLayer.show({
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/TransResultView.ejs"
                }))({
                    id: 'TransResultView',
                    data: {
                        type:"sgd",
                        accountId: _t.transPayerInfor.accountId,
                        payeeName: _t.transPayeeInfor.payeeEnName,
                        payeeActno: _t.payeeActno,
                        //cleaningId:_t.cleaningId,
                        inCurrencyCode: constant.currency_sign_1_[result.inCurrencyCode],
                        outCurrencyCode: constant.currency_sign_1_[result.outCurrencyCode],
                        inAmount: _t.inAmount.toString().formatMoney(result.outCurrencyCode),
                        transTime: result.transTime,//执行交易时间
                        //transFee: result.transFee.toString().formatMoney(result.transFeeCur),
                        transFee: (result.transFee=== null || result.transFee ==="")? "-" : result.transFee.toString().formatMoney(result.transFeeCur)+" "+"("+constant.currency_sign_1_[result.transFeeCur]+")",
                        transFeeCurShow:  constant.currency_sign_1_[result.transFeeCur] ,
                        statusShow: constant.trans_status_[result.status],
                        status:result.status,
                        transId: result.transId,
                        remark: _t.remark,
                        tradeRate: str,
                        //ibanNum: _t.transPayeeInfor.accountNumber.toString().replace(/(\d{4})/g,"$1"+" "),
                        ibanNum:_t.transPayeeInfor.accountNumber.toString().beautyDisplay(),
                        payeeBankName: _t.transPayeeInfor.bankName,
                        payeeBankSwift: _t.transPayeeInfor.branchId,
                        //outAccountNumber: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber.toString().replace(/(\d{4})/g,"$1"+" "):  _t.transPayerInfor.accountNumber.toString().replace(/(\d{4})/g,"$1"+" "),
                        outAccountNumber: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber.toString().beautyDisplay():  _t.transPayerInfor.accountNumber.toString().beautyDisplay(),
                        remittanceInfo: _t.remittanceInfo,
                        transTypeInfo: _t.clearingTypeIdListDic[_t.cleaningId],
                    },
                    onBack: function(e) {
                        common.fullLayer.close(e);
                        _t.onBack('home');
                    },
                    _hisClose:function(e){
                        common.fullLayer.close(e);
                        _t.onBack("tr_01");
                    }
                })
            }, "");
            //if(_t.cleaningId=="35"){
            //    $('#processingFee').removeClass('hide').addClass('show');
            //}else {
            //    $('#processingFee').removeClass('show').addClass('hide')
            //}
        },

        onBack:function(id){
            var params = "";
            if(id == undefined || id == "")
                params = "entrance";
            else
                params = id;
            bocovsbridge.navigateToPage(function(data){}, function(data){},params);
        },
        onBackUi:function(e){
            var params = "back";
            bocovsbridge.navigateToPage(function(data){}, function(data){},params);
        },

        onOvpExchangeRateQry:function(){
            var _t = this;

            //_t.inAmount = $('#txtMoney').val();
            if(_t.inAmount == ""){
                common.showMessage($.localeResource['BocAbroad_SinTrans'].ovs_bps_sbpm_21);
                return;
            }
            //_t.showRateView();
            //return;
            //_t.inAmount = $('#txtMoney').val();
            var params = {fromAccountId: _t.transPayerInfor.accountId,
                fromAcctNo: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountNumber:  _t.transPayerInfor.accountNumber,
                bankId: _t.transPayerInfor.accountType == "213" ? _t.transPayerInfor.subDebitInfo.subAcctList[0].accountIbknum:  _t.transPayerInfor.accountIbknum,
                outCurrencyCode: _t.outCurrencyCode,
                //inCurrencyCode: _t.inCurrencyCode,
                currency: _t.inCurrencyCode,
                clearType: "20",
                currencyCode: _t.inCurrencyCode,
                //交易金额和转出金额
                //amount: _t.inAmount
                transAmount: _t.inAmount
            };
            model.interaction({
                method: routesUtil.method.BII.OvpExchangeRateQry,
                params: params
            }, "BII", function(data) {
                for(var i = 0; i < data.rateList.length; i++){
                    data.rateList[i].soureCodeShow = constant.currency_sign_1_[data.rateList[i].transFeeCurShow];
                    data.rateList[i].targetCodeShow = constant.currency_sign_1_[data.rateList[i].targetCode];
                }
                _t.rateList = data.rateList;
                _t.showRateView();
            });
        },

        //显示牌价
        showRateView:function(){
            var _t = this;
            common.fullLayer.show({
                view: new($.extendCls(controller, {
                    ejs: "../BocAbroad/views/transfer/RateView.ejs"
                }))({
                    id: 'RateView',
                    data: {
                        type:"sgd",
                        rateList: _t.rateList
                    },
                    _hisClose:function(e){
                        common.fullLayer.close(e);
                    }

                })
            }, "");

        },


    });
    return common.Module.sub({
        _constructor:function() {
            this.mainView = null;
            $.proxy(this.baseprototype._constructor, this)();
        },
        init: function() {
            this.mainView = new mainView({
                id: "SinTrans",
                el: "#loginViewWrap",
                eloper: "html",
                //参数
                data: {
                    type: "sgd",
                }
            });
            this.mainView.load();
        },
        destroy: function() {
            this.mainView.destroy();
        }
    });
});